﻿using Kometa.Models;
using KompetencniMatice.Models;
using System;
using System.Collections.ObjectModel;
using System.DirectoryServices;

namespace Kometa.Helpers
{
    class ActiveDirectory
    {
        public static Uzivatel VyhledejUzivatelePodleNT(string userName)
        {
            Uzivatel uzivatel = new Uzivatel();

            try
            {

                string domainName = "emea.bosch.com";
                DirectoryEntry entry = new DirectoryEntry("LDAP://" + domainName);
                DirectorySearcher search = new DirectorySearcher(entry);

                string query = "sAMAccountName= " + userName;

                search.Filter = query;

                search.PropertiesToLoad.AddRange(new string[] { "sn", "givenName", "sAMAccountName", "Department", "mail" });

                using (SearchResultCollection results = search.FindAll())
                {
                    if (results.Count > 0)
                    {
                        foreach (SearchResult result in results)
                        {
                            if (result.Properties["mail"] != null && result.Properties["mail"].Count > 0
                                && result.Properties["sn"] != null && result.Properties["sn"].Count > 0
                                && result.Properties["givenName"] != null && result.Properties["givenName"].Count > 0
                                && result.Properties["sAMAccountName"] != null && result.Properties["sAMAccountName"].Count > 0
                                && result.Properties["Department"] != null && result.Properties["Department"].Count > 0)
                            {

                                uzivatel.jmeno = result.Properties["givenName"][0].ToString();
                                uzivatel.prijmeni = result.Properties["sn"][0].ToString();
                                uzivatel.ntUser = result.Properties["sAMAccountName"][0].ToString();
                                uzivatel.oddeleni = result.Properties["Department"][0].ToString();
                                uzivatel.email = result.Properties["mail"][0].ToString();

                            }
                        }
                    }

                    else
                    {
                        return null;
                    }
                }
            }
            catch
            {

                uzivatel.jmeno = "Patrik";
                uzivatel.prijmeni = "Fišer";
                uzivatel.ntUser = "fip8jh";
                uzivatel.oddeleni = "JhP/ICO";
                uzivatel.email = "P.Fiser@cz.Bosch.com";
            }

            return uzivatel;
        }
    }
}
