﻿using Kometa.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kometa.Models
{
    class Report : ViewModelBase
    {
        private int _pocetZam;
        private int _pocetZaskolovanych;
        private int _pocetInzeratu;
        private int _pocetMychInzeratu;
        private int _pocetZapujcenychZam;
        private double _procentoZaskolovanych;
        private double _procentoZapujenych;
        
        public int pocetZam
        {
            get { return _pocetZam; }
            set
            {
                if (_pocetZam == value)
                    return;
                _pocetZam = value;
                OnPropertyChanged("pocetZam");
                OnPropertyChanged("procentoZapujenych");
                OnPropertyChanged("procentoZaskolovanych");
            }
        }
        public int pocetZaskolovanych
        {
            get { return _pocetZaskolovanych; }
            set
            {
                if (_pocetZaskolovanych == value)
                    return;
                _pocetZaskolovanych = value;
                OnPropertyChanged("pocetZaskolovanych");
                OnPropertyChanged("procentoZapujenych");
                OnPropertyChanged("procentoZaskolovanych");

            }
        }
        public int pocetInzeratu
        {
            get { return _pocetInzeratu; }
            set
            {
                if (_pocetInzeratu == value)
                    return;
                _pocetInzeratu = value;
                OnPropertyChanged("pocetInzeratu");
            }
        }
        public int pocetMychInzeratu
        {
            get { return _pocetMychInzeratu; }
            set
            {
                if (_pocetMychInzeratu == value)
                    return;
                _pocetMychInzeratu = value;
                OnPropertyChanged("pocetMychInzeratu");
            }
        }
        public int pocetZapujcenychZam
        {
            get { return _pocetZapujcenychZam; }
            set
            {
                if (_pocetZapujcenychZam == value)
                    return;
                _pocetZapujcenychZam = value;
                OnPropertyChanged("pocetZapujcenychZam");
                OnPropertyChanged("procentoZapujenych");
                OnPropertyChanged("procentoZaskolovanych");
            }
        }
        public double procentoZaskolovanych
        {
            get
            {
                if (pocetZaskolovanych != 0 && pocetZam != 0) return pocetZaskolovanych * 100 / pocetZam;
                return 0;
            }
            set
            {
                if (_procentoZaskolovanych == value)
                    return;
                _procentoZaskolovanych = value;
                OnPropertyChanged("procentoZaskolovanych");
            }
        }
        public double procentoZapujenych
        {
            get 
            {
                if (pocetZapujcenychZam != 0 && pocetZam != 0) return pocetZapujcenychZam * 100 / pocetZam + procentoZaskolovanych;
                else return 0;
            }
                
                
            set
            {
                if (_procentoZapujenych == value)
                    return;
                _procentoZapujenych = value;
                OnPropertyChanged("procentoZapujenych");
            }
        }
        
    }
}
