﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;


namespace KompetencniMatice.Converters
{
    [ValueConversion(typeof(int), typeof(bool))]
    class HodnoceniToBooleanConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (value != null && parameter != null)
            {
                if ((int)value >= System.Convert.ToInt32(parameter))
                    return true;

                else
                    return false;
            }

            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (parameter != null)
            {
                if ((bool)value == false && parameter.ToString() == "1")
                {
                    return System.Convert.ToInt32(parameter) -1;
                }
                return System.Convert.ToInt32(parameter);
            }
            return Binding.DoNothing;
        }
    }
}