﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace KompetencniMatice.DialogWindows
{
    /// <summary>
    /// Interaction logic for WarningWindow.xaml
    /// </summary>
    public partial class WarningWindow : Window
    {
        [DllImport("user32.dll")]
        static extern uint GetWindowLong(IntPtr hWnd, int nIndex);

        [DllImport("user32.dll")]
        static extern int SetWindowLong(IntPtr hWnd, int nIndex, uint dwNewLong);

        private const int GWL_STYLE = -16;

        private const uint WS_SYSMENU = 0x80000;

        protected override void OnSourceInitialized(EventArgs e)
        {
            IntPtr hwnd = new System.Windows.Interop.WindowInteropHelper(this).Handle;
            SetWindowLong(hwnd, GWL_STYLE,
                GetWindowLong(hwnd, GWL_STYLE) & (0xFFFFFFFF ^ WS_SYSMENU));

            base.OnSourceInitialized(e);
        }
        public bool OK
        {
            get { return (bool)GetValue(OKProperty); }
            set { SetValue(OKProperty, value); }
        }
        public string TextVarovani
        {
            get { return (string)GetValue(TextVarovaniProperty); }
            set { SetValue(TextVarovaniProperty, value); }
        }
        public static readonly DependencyProperty OKProperty = DependencyProperty.Register("OK", typeof(bool), typeof(WarningWindow));
        public static readonly DependencyProperty TextVarovaniProperty = DependencyProperty.Register("TextVarovani", typeof(string), typeof(WarningWindow));
        public WarningWindow()
        {
            InitializeComponent();
        }

        private void btnZrusit_Click(object sender, RoutedEventArgs e)
        {
            OK = false;
            this.Close();
        }

        private void btnPotvrdit_Click(object sender, RoutedEventArgs e)
        {
            OK = true;
            this.Close();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            tbTextVarovani.Text = TextVarovani;
        }
    }
}
