﻿using KompetencniMatice.Models;
using System;
using System.Collections.ObjectModel;
using System.DirectoryServices;

namespace KompetencniMatice.Helpers
{
    public class ActiveDirectory
    {
        public static ObservableCollection<Opravneni> VyhledejUzivatele(string userName)
        {
            ObservableCollection<Opravneni> seznamUzivatelu = new ObservableCollection<Opravneni>();

            string domainName = "emea.bosch.com";
            bool test = false;
            DirectoryEntry entry = new DirectoryEntry("LDAP://" + domainName);
            DirectorySearcher search = new DirectorySearcher(entry);

            string query;

            if (userName == null) test = true;
            else
            {
                for (int i = 0; i < userName.Length; i++)
                {
                    if (char.IsNumber(userName[i]))
                    {
                        test = true;
                    }
                }
            }

            if (test)
            {
                query = "sAMAccountName= " + userName + "*";
            }
            else
            {
                if (!userName.Contains(" "))
                {
                    query = query = "sn= " + userName + "*";
                }
                else
                {
                    query = string.Format("(&(objectCategory=person)(objectClass=user)(&(sn={0}*)(givenName={1}*)))", userName.Split(' ')[0], userName.Split(' ')[1]);
                }
            }
            search.Filter = query;

            search.PropertiesToLoad.AddRange(new string[] { "sn", "givenName", "sAMAccountName", "Department", "Description", "mail" });

            try
            {
                using (SearchResultCollection results = search.FindAll())
                {
                    if (results.Count > 0)
                    {
                        foreach (SearchResult result in results)
                        {
                            if (result.Properties["mail"] != null && result.Properties["mail"].Count > 0
                                && result.Properties["sn"] != null && result.Properties["sn"].Count > 0
                                && result.Properties["givenName"] != null && result.Properties["givenName"].Count > 0
                                && result.Properties["sAMAccountName"] != null && result.Properties["sAMAccountName"].Count > 0
                                && result.Properties["Department"] != null && result.Properties["Department"].Count > 0)
                            {
                                Opravneni uzivatel = new Opravneni();

                                uzivatel.jmeno = result.Properties["givenName"][0].ToString();
                                uzivatel.prijmeni = result.Properties["sn"][0].ToString();
                                uzivatel.nt = result.Properties["sAMAccountName"][0].ToString();
                                uzivatel.oddeleni = result.Properties["Department"][0].ToString();
                                uzivatel.email = result.Properties["mail"][0].ToString();

                                seznamUzivatelu.Add(uzivatel);

                            }
                        }
                    }

                    else
                    {
                        return null;
                    }
                }
            }
            catch { }
            return seznamUzivatelu;
        }

        public static Opravneni VyhledejUzivatelePodleNT(string userName)
        {
            Opravneni uzivatel = new Opravneni();

            try
            {
                string domainName = "emea.bosch.com";
                DirectoryEntry entry = new DirectoryEntry("LDAP://" + domainName);
                DirectorySearcher search = new DirectorySearcher(entry);

                string query = "sAMAccountName= " + userName;

                search.Filter = query;

                search.PropertiesToLoad.AddRange(new string[] { "sn", "givenName", "sAMAccountName", "Department", "mail" });

                using (SearchResultCollection results = search.FindAll())
                {
                    if (results.Count > 0)
                    {
                        foreach (SearchResult result in results)
                        {
                            if (result.Properties["mail"] != null && result.Properties["mail"].Count > 0
                                && result.Properties["sn"] != null && result.Properties["sn"].Count > 0
                                && result.Properties["givenName"] != null && result.Properties["givenName"].Count > 0
                                && result.Properties["sAMAccountName"] != null && result.Properties["sAMAccountName"].Count > 0
                                && result.Properties["Department"] != null && result.Properties["Department"].Count > 0)
                            {

                                uzivatel.jmeno = result.Properties["givenName"][0].ToString();
                                uzivatel.prijmeni = result.Properties["sn"][0].ToString();
                                uzivatel.nt = result.Properties["sAMAccountName"][0].ToString();
                                uzivatel.oddeleni = result.Properties["Department"][0].ToString();
                                uzivatel.email = result.Properties["mail"][0].ToString();

                            }
                        }
                    }

                    else
                    {
                        return null;
                    }
                }
            }
            catch
            {
                uzivatel.jmeno = "Patrik";
                uzivatel.prijmeni = "Fišer";
                uzivatel.nt = "fip8jh";
                uzivatel.oddeleni = "JhP/ICO";
                uzivatel.email = "P.Fiser@cz.Bosch.com";

            }
            

            return uzivatel;
        }
    }
}
