﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class Cas : ViewModelBase
    {
        public int id { get; set; }
        private string _cas;

        public string cas
        {
            get { return _cas; }
            set
            {
                if (_cas == value)
                    return;
                _cas = value;
                OnPropertyChanged("cas");
            }
        }
        public Cas() { }
        public Cas(Cas cas)
        {
            this.id = cas.id;
            this.cas = cas.cas;
        }
        public static ObservableCollection<Cas> SelectCasy()
        {

            ObservableCollection<Cas> seznam = new ObservableCollection<Cas>();
            String sqlStr = "SELECT id, cas FROM Inzerat_Cas";


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Cas cas;

                    while (reader.Read())
                    {
                        cas = new Cas();
                        cas.id = reader.GetInt32(0);
                        cas.cas = reader.GetValue(1).ToString();

                        seznam.Add(cas);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static int VlozitCas(Cas cas)
        {
            String sqlStr = "INSERT INTO Inzerat_Cas (cas) "
                + "VALUES (@cas) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@cas", cas.cas);
                    
                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }

        public static void UpravitCas(Cas cas)
        {
            String sqlStr = "UPDATE Inzerat_Cas SET cas=@cas WHERE id = " + cas.id + ";";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@cas", cas.cas);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void SmazatCas(Cas cas)
        {
            String sqlStr = "DELETE Inzerat_Cas WHERE id = " + cas.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
    }
}
