﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;


namespace KompetencniMatice.Models
{
    public class Duvod: ViewModelBase
    {
        public int id { get; set; }
        private string _duvod;
        private bool _nabidka;

        public string duvod
        {
            get { return _duvod; }
            set
            {
                if (_duvod == value)
                    return;
                _duvod = value;
                OnPropertyChanged("duvod");
            }
        }
        public bool nabidka
        {
            get { return _nabidka; }
            set
            {
                if (_nabidka == value)
                    return;
                _nabidka = value;
                OnPropertyChanged("nabidka");
            }
        }
        public Duvod() { }
        public Duvod(Duvod duvod)
        {
            this.id = duvod.id;
            this.duvod = duvod.duvod;
            this.nabidka = duvod.nabidka;
        }
        public static ObservableCollection<Duvod> SelectDuvody()
        {

            ObservableCollection<Duvod> seznam = new ObservableCollection<Duvod>();
            String sqlStr = "SELECT id, duvod, nabidka FROM Inzerat_Duvod";


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Duvod duvod;

                    while (reader.Read())
                    {
                        duvod = new Duvod();
                        duvod.id = reader.GetInt32(0);
                        duvod.duvod = reader.GetValue(1).ToString();
                        duvod.nabidka = reader.GetBoolean(2);

                        seznam.Add(duvod);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static ObservableCollection<Duvod> SelectDuvodyNabidky()
        {

            ObservableCollection<Duvod> seznam = new ObservableCollection<Duvod>();
            String sqlStr = "SELECT id, duvod FROM Inzerat_Duvod WHERE nabidka = 1";


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Duvod duvod;

                    while (reader.Read())
                    {
                        duvod = new Duvod();
                        duvod.id = reader.GetInt32(0);
                        duvod.duvod = reader.GetValue(1).ToString();
                        duvod.nabidka = true;

                        seznam.Add(duvod);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static ObservableCollection<Duvod> SelectDuvodyPoptavky()
        {

            ObservableCollection<Duvod> seznam = new ObservableCollection<Duvod>();
            String sqlStr = "SELECT id, duvod FROM Inzerat_Duvod WHERE nabidka = 0";


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Duvod duvod;

                    while (reader.Read())
                    {
                        duvod = new Duvod();
                        duvod.id = reader.GetInt32(0);
                        duvod.duvod = reader.GetValue(1).ToString();
                        duvod.nabidka = true;

                        seznam.Add(duvod);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static int VlozitDuvod(Duvod duvod)
        {
            String sqlStr = "INSERT INTO Inzerat_Duvod (duvod, nabidka) "
                + "VALUES (@duvod, @nabidka) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@duvod", duvod.duvod);
                    cmd.Parameters.AddWithValue("@nabidka", duvod.nabidka);

                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }

        public static void UpravitDuvod(Duvod duvod)
        {
            String sqlStr = "UPDATE Inzerat_Duvod SET duvod=@duvod WHERE id = " + duvod.id + ";";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@duvod", duvod.duvod);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void SmazatDuvod(Duvod duvod)
        {
            String sqlStr = "DELETE Inzerat_Duvod WHERE id = " + duvod.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
    }
}

