﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class Inzerat : ViewModelBase
    {
        public int id { get; set; }
        private DateTime _datumVytvoreni;
        private DateTime _datumOd;
        private DateTime _datumDo;
        private string _casOd;
        private string _casDo;
        public int idZam { get; set; }
        public int idZadavajiciho { get; set; }
        public int idReagujiciho { get; set; }
        private string _duvod;
        private string _pohlavi;
        private string _smenovyModel;
        private string _pozice;
        public int typ { get; set; }
        public string ntReagujiciho { get; set; }
        private int _status;
        private int _idZapujcenehoUseku;
        private string _nazevZapujcenehoUseku;
        private int _dobaReakce;

        private Zamestnanec _zamestnanec;
        private KontaktniOsoba _zadavajici;
        private KontaktniOsoba _reagujici;

        public DateTime datumVytvoreni
        {
            get { return _datumVytvoreni; }
            set
            {
                if (_datumVytvoreni == value)
                    return;
                _datumVytvoreni = value;
                OnPropertyChanged("datumVytvoreni");
            }
        }
        public DateTime datumOd
        {
            get { return _datumOd; }
            set
            {
                if (_datumOd == value)
                    return;
                _datumOd = value;
                OnPropertyChanged("datumOd");
            }
        }
        public DateTime datumDo
        {
            get { return _datumDo; }
            set
            {
                if (_datumDo == value)
                    return;
                _datumDo = value;
                OnPropertyChanged("datumDo");
            }
        }
        public string casOd
        {
            get { return _casOd; }
            set
            {
                if (_casOd == value)
                    return;
                _casOd = value;
                OnPropertyChanged("casOd");
            }
        }
        public string casDo
        {
            get { return _casDo; }
            set
            {
                if (_casDo == value)
                    return;
                _casDo = value;
                OnPropertyChanged("casDo");
            }
        }
        public Zamestnanec zamestnanec
        {
            get { return _zamestnanec; }
            set
            {
                if (_zamestnanec == value)
                    return;
                _zamestnanec = value;
                OnPropertyChanged("zamestnanec");
            }
        }

        public string duvod
        {
            get { return _duvod; }
            set
            {
                if (_duvod == value)
                    return;
                _duvod = value;
                OnPropertyChanged("duvod");
            }
        }
        public string pohlavi
        {
            get { return _pohlavi; }
            set
            {
                if (_pohlavi == value)
                    return;
                _pohlavi = value;
                OnPropertyChanged("pohlavi");
            }
        }
        public string smenovyModel
        {
            get { return _smenovyModel; }
            set
            {
                if (_smenovyModel == value)
                    return;
                _smenovyModel = value;
                OnPropertyChanged("smenovyModel");
            }
        }
        public string pozice
        {
            get { return _pozice; }
            set
            {
                if (_pozice == value)
                    return;
                _pozice = value;
                OnPropertyChanged("pozice");
            }
        }
        public int status
        {
            get { return _status; }
            set
            {
                if (_status == value)
                    return;
                _status = value;
                OnPropertyChanged("status");
            }
        }
        public int idZapujcenehoUseku
        {
            get { return _idZapujcenehoUseku; }
            set
            {
                if (_idZapujcenehoUseku == value)
                    return;
                _idZapujcenehoUseku = value;
                OnPropertyChanged("idZapujcenehoUseku");
            }
        }
        public string nazevZapujcenehoUseku
        {
            get { return _nazevZapujcenehoUseku; }
            set
            {
                if (_nazevZapujcenehoUseku == value)
                    return;
                _nazevZapujcenehoUseku = value;
                OnPropertyChanged("nazevZapujcenehoUseku");
            }
        }
        public int dobaReakce
        {
            get { return _dobaReakce; }
            set
            {
                if (_dobaReakce == value)
                    return;
                _dobaReakce = value;
                OnPropertyChanged("dobaReakce");
            }
        }
        public KontaktniOsoba zadavajici
        {
            get { return _zadavajici; }
            set
            {
                if (_zadavajici == value)
                    return;
                _zadavajici = value;
                OnPropertyChanged("zadavajici");
            }
        }
        public KontaktniOsoba reagujici
        {
            get { return _reagujici; }
            set
            {
                if (_reagujici == value)
                    return;
                _reagujici = value;
                OnPropertyChanged("reagujici");
            }
        }

        public static ObservableCollection<Inzerat> SelectInzeraty()
        {

            ObservableCollection<Inzerat> seznam = new ObservableCollection<Inzerat>();
            String sqlStr = "SELECT a.id, a.datumVytvoreni, a.datumOd, a.datumDo, a.casOd, a.casDo, a.duvod, b.id, b.jmeno, b.prijmeni, b.osCislo, b.pohlavi, b.stredisko, b.smenovyModel, b.pozice,"
                + " c.id, c.jmeno, c.stredisko, c.oddeleni, c.usek, c.klapka, c.mobil, c.email, c.pozice, c.smenovyModel, c.zavod, c.hala, c.vchod, c.mistoVyzvednuti, c.uzivatel,"
                + " d.id, d.jmeno, d.stredisko, d.oddeleni, d.usek, d.klapka, d.mobil, d.email, d.pozice, d.smenovyModel, d.zavod, d.hala, d.vchod, d.mistoVyzvednuti, d.uzivatel, a.typ, a.ntReagujiciho, a.status, c.idUseku, a.smenovyModel, a.pohlavi, a.pozice, b.idUseku, a.dobaReakce FROM Inzerat_Inzerat AS a"
                + " LEFT JOIN Zamestnanec AS b ON b.id = a.idZam"
                + " JOIN Inzerat_KontaktniOsoba AS c ON c.id = a.idZadavajiciho"
                + " LEFT JOIN Inzerat_KontaktniOsoba AS d ON d.id = a.idReagujiciho"
                + " WHERE a.ukonceno = 0";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Inzerat inzerat;

                    while (reader.Read())
                    {
                        inzerat = new Inzerat();
                        inzerat.id = reader.GetInt32(0);
                        inzerat.datumVytvoreni = reader.GetDateTime(1);
                        inzerat.datumOd = reader.GetDateTime(2);
                        inzerat.datumDo = reader.GetDateTime(3);
                        inzerat.casOd = reader.GetValue(4).ToString();
                        inzerat.casDo = reader.GetValue(5).ToString();
                        inzerat.duvod = reader.GetValue(6).ToString();
                        inzerat.dobaReakce = reader.GetInt32(53);

                        if (reader.GetValue(7) != DBNull.Value)
                        {
                            inzerat.zamestnanec = new Zamestnanec();
                            inzerat.zamestnanec.id = reader.GetInt32(7);
                            inzerat.zamestnanec.jmeno = reader.GetValue(8).ToString();
                            inzerat.zamestnanec.prijmeni = reader.GetValue(9).ToString();
                            inzerat.zamestnanec.osCislo = reader.GetValue(10).ToString();
                            inzerat.zamestnanec.pohlavi = reader.GetValue(11).ToString();
                            inzerat.zamestnanec.stredisko = reader.GetValue(12).ToString();
                            inzerat.zamestnanec.smenovyModel = reader.GetValue(13).ToString();
                            inzerat.zamestnanec.pozice = reader.GetValue(14).ToString();
                            inzerat.zamestnanec.idUseku = reader.GetInt32(52);
                        }

                        inzerat.zadavajici = new KontaktniOsoba();
                        inzerat.zadavajici.id = reader.GetInt32(15);
                        inzerat.zadavajici.jmeno = reader.GetValue(16).ToString();
                        inzerat.zadavajici.stredisko = reader.GetValue(17).ToString();
                        inzerat.zadavajici.oddeleni = reader.GetValue(18).ToString();
                        inzerat.zadavajici.usek = reader.GetValue(19).ToString();
                        if (reader.GetValue(20) != DBNull.Value) inzerat.zadavajici.klapka = "+420(56)758-" + reader.GetValue(20).ToString();
                        else inzerat.zadavajici.klapka = "-";
                        inzerat.zadavajici.mobil = reader.GetValue(21).ToString();
                        inzerat.zadavajici.email = reader.GetValue(22).ToString();
                        inzerat.zadavajici.pozice = reader.GetValue(23).ToString();
                        inzerat.zadavajici.smenovyModel = reader.GetValue(24).ToString();
                        inzerat.zadavajici.zavod = reader.GetValue(25).ToString();
                        inzerat.zadavajici.hala = reader.GetValue(26).ToString();
                        inzerat.zadavajici.vchod = reader.GetValue(27).ToString();
                        inzerat.zadavajici.mistoVyzvednuti = reader.GetValue(28).ToString();
                        inzerat.zadavajici.uzivatel = reader.GetValue(29).ToString();

                        if (reader.GetValue(30) != DBNull.Value)
                        {
                            inzerat.reagujici = new KontaktniOsoba();
                            inzerat.reagujici.id = reader.GetInt32(30);
                            inzerat.reagujici.jmeno = reader.GetValue(31).ToString();
                            inzerat.reagujici.stredisko = reader.GetValue(32).ToString();
                            inzerat.reagujici.oddeleni = reader.GetValue(33).ToString();
                            inzerat.reagujici.usek = reader.GetValue(34).ToString();
                            if (reader.GetValue(35) != DBNull.Value) inzerat.reagujici.klapka = "+420(56)758-" + reader.GetValue(35).ToString();
                            else inzerat.reagujici.klapka = "-";
                            inzerat.reagujici.mobil = reader.GetValue(36).ToString();
                            inzerat.reagujici.email = reader.GetValue(37).ToString();
                            inzerat.reagujici.pozice = reader.GetValue(38).ToString();
                            inzerat.reagujici.smenovyModel = reader.GetValue(39).ToString();
                            inzerat.reagujici.zavod = reader.GetValue(40).ToString();
                            inzerat.reagujici.hala = reader.GetValue(41).ToString();
                            inzerat.reagujici.vchod = reader.GetValue(42).ToString();
                            inzerat.reagujici.mistoVyzvednuti = reader.GetValue(43).ToString();
                            inzerat.reagujici.uzivatel = reader.GetValue(44).ToString();
                        }
                        inzerat.typ = reader.GetInt32(45);
                        inzerat.ntReagujiciho = reader.GetValue(46).ToString();
                        inzerat.status = reader.GetInt32(47);
                        inzerat.zadavajici.idUseku = reader.GetInt32(48);

                        if (inzerat.typ == 1)
                        {
                            inzerat.smenovyModel = inzerat.zamestnanec.smenovyModel;
                            inzerat.pohlavi = inzerat.zamestnanec.pohlavi;
                            inzerat.pozice = inzerat.zamestnanec.pozice;
                        }
                        else
                        {
                            inzerat.smenovyModel = reader.GetValue(49).ToString();
                            inzerat.pohlavi = reader.GetValue(50).ToString();
                            inzerat.pozice = reader.GetValue(51).ToString();
                        }
                        if (inzerat.datumOd < DateTime.Now.AddDays(inzerat.dobaReakce).Date && inzerat.status == 1)
                        {
                            inzerat.status = 3;
                        }

                        seznam.Add(inzerat);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static int PocetOtevrenychInzeratu()
        {
            int vysledek = 0;
            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "Select COUNT(id) FROM Inzerat_Inzerat WHERE ukonceno = 0";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        vysledek = (reader.GetInt32(0));
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return vysledek;
        }
        public static int PocetOtevrenychMychInzeratu(string ntUser)
        {
            int vysledek = 0;
            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "Select COUNT(a.id) FROM Inzerat_Inzerat AS a JOIN Inzerat_KontaktniOsoba AS b ON b.id = a.idZadavajiciho " +
                "WHERE a.ukonceno = 0 AND b.uzivatel = '" + ntUser + "';";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        vysledek = (reader.GetInt32(0));
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return vysledek;
        }
        public static ObservableCollection<Inzerat> SelectFiltrovaneInzeraty(string sqlStr)
        {

            ObservableCollection<Inzerat> seznam = new ObservableCollection<Inzerat>();

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Inzerat inzerat;

                    while (reader.Read())
                    {
                        inzerat = new Inzerat();
                        inzerat.id = reader.GetInt32(0);
                        inzerat.datumVytvoreni = reader.GetDateTime(1);
                        inzerat.datumOd = reader.GetDateTime(2);
                        inzerat.datumDo = reader.GetDateTime(3);
                        inzerat.casOd = reader.GetValue(4).ToString();
                        inzerat.casDo = reader.GetValue(5).ToString();
                        inzerat.duvod = reader.GetValue(6).ToString();
                        inzerat.dobaReakce = reader.GetInt32(53);

                        if (reader.GetValue(7) != DBNull.Value)
                        {
                            inzerat.zamestnanec = new Zamestnanec();
                            inzerat.zamestnanec.id = reader.GetInt32(7);
                            inzerat.zamestnanec.jmeno = reader.GetValue(8).ToString();
                            inzerat.zamestnanec.prijmeni = reader.GetValue(9).ToString();
                            inzerat.zamestnanec.osCislo = reader.GetValue(10).ToString();
                            inzerat.zamestnanec.pohlavi = reader.GetValue(11).ToString();
                            inzerat.zamestnanec.stredisko = reader.GetValue(12).ToString();
                            inzerat.zamestnanec.smenovyModel = reader.GetValue(13).ToString();
                            inzerat.zamestnanec.pozice = reader.GetValue(14).ToString();
                            inzerat.zamestnanec.idUseku = reader.GetInt32(52);
                        }

                        inzerat.zadavajici = new KontaktniOsoba();
                        inzerat.zadavajici.id = reader.GetInt32(15);
                        inzerat.zadavajici.jmeno = reader.GetValue(16).ToString();
                        inzerat.zadavajici.stredisko = reader.GetValue(17).ToString();
                        inzerat.zadavajici.oddeleni = reader.GetValue(18).ToString();
                        inzerat.zadavajici.usek = reader.GetValue(19).ToString();
                        if (reader.GetValue(20) != DBNull.Value) inzerat.zadavajici.klapka = "+420(56)758-" + reader.GetValue(20).ToString();
                        else inzerat.zadavajici.klapka = "-";
                        inzerat.zadavajici.mobil = reader.GetValue(21).ToString();
                        inzerat.zadavajici.email = reader.GetValue(22).ToString();
                        inzerat.zadavajici.pozice = reader.GetValue(23).ToString();
                        inzerat.zadavajici.smenovyModel = reader.GetValue(24).ToString();
                        inzerat.zadavajici.zavod = reader.GetValue(25).ToString();
                        inzerat.zadavajici.hala = reader.GetValue(26).ToString();
                        inzerat.zadavajici.vchod = reader.GetValue(27).ToString();
                        inzerat.zadavajici.mistoVyzvednuti = reader.GetValue(28).ToString();
                        inzerat.zadavajici.uzivatel = reader.GetValue(29).ToString();

                        if (reader.GetValue(30) != DBNull.Value)
                        {
                            inzerat.reagujici = new KontaktniOsoba();
                            inzerat.reagujici.id = reader.GetInt32(30);
                            inzerat.reagujici.jmeno = reader.GetValue(31).ToString();
                            inzerat.reagujici.stredisko = reader.GetValue(32).ToString();
                            inzerat.reagujici.oddeleni = reader.GetValue(33).ToString();
                            inzerat.reagujici.usek = reader.GetValue(34).ToString();
                            if (reader.GetValue(35) != DBNull.Value) inzerat.reagujici.klapka = "+420(56)758-" + reader.GetValue(35).ToString();
                            else inzerat.reagujici.klapka = "-";
                            inzerat.reagujici.mobil = reader.GetValue(36).ToString();
                            inzerat.reagujici.email = reader.GetValue(37).ToString();
                            inzerat.reagujici.pozice = reader.GetValue(38).ToString();
                            inzerat.reagujici.smenovyModel = reader.GetValue(39).ToString();
                            inzerat.reagujici.zavod = reader.GetValue(40).ToString();
                            inzerat.reagujici.hala = reader.GetValue(41).ToString();
                            inzerat.reagujici.vchod = reader.GetValue(42).ToString();
                            inzerat.reagujici.mistoVyzvednuti = reader.GetValue(43).ToString();
                            inzerat.reagujici.uzivatel = reader.GetValue(44).ToString();
                        }
                        inzerat.typ = reader.GetInt32(45);
                        inzerat.ntReagujiciho = reader.GetValue(46).ToString();
                        inzerat.status = reader.GetInt32(47);
                        inzerat.zadavajici.idUseku = reader.GetInt32(48);

                        if (inzerat.typ == 1)
                        {
                            inzerat.smenovyModel = inzerat.zamestnanec.smenovyModel;
                            inzerat.pohlavi = inzerat.zamestnanec.pohlavi;
                            inzerat.pozice = inzerat.zamestnanec.pozice;
                        }
                        else
                        {
                            inzerat.smenovyModel = reader.GetValue(49).ToString();
                            inzerat.pohlavi = reader.GetValue(50).ToString();
                            inzerat.pozice = reader.GetValue(51).ToString();
                        }
                        if (inzerat.datumOd < DateTime.Now.AddDays(inzerat.dobaReakce).Date && inzerat.status == 1)
                        {
                            inzerat.status = 3;
                        }

                        seznam.Add(inzerat);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static ObservableCollection<Inzerat> SelectHistorieInzeratuZam(int idZam)
        {

            ObservableCollection<Inzerat> seznam = new ObservableCollection<Inzerat>();
            String sqlStr = "SELECT a.id, a.datumVytvoreni, a.datumOd, a.datumDo, a.casOd, a.casDo, a.duvod, a.typ, a.ntReagujiciho, a.idZapujcenehoUseku,"
                + " b.id, b.jmeno, b.stredisko, b.oddeleni, b.usek, c.nazev"
                + " FROM Inzerat_Inzerat AS a"
                + " JOIN Inzerat_KontaktniOsoba AS b ON b.id = a.idReagujiciho"
                + " JOIN Usek AS c ON c.id = a.idZapujcenehoUseku"
                + " WHERE idZam = " + idZam;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Inzerat inzerat;

                    while (reader.Read())
                    {
                        inzerat = new Inzerat();
                        inzerat.id = reader.GetInt32(0);
                        inzerat.datumVytvoreni = reader.GetDateTime(1);
                        inzerat.datumOd = reader.GetDateTime(2);
                        inzerat.datumDo = reader.GetDateTime(3);
                        inzerat.casOd = reader.GetValue(4).ToString();
                        inzerat.casDo = reader.GetValue(5).ToString();
                        inzerat.duvod = reader.GetValue(6).ToString();
                        inzerat.typ = reader.GetInt32(7);
                        inzerat.ntReagujiciho = reader.GetValue(8).ToString();
                        inzerat.idZapujcenehoUseku = reader.GetInt32(9);

                        inzerat.reagujici = new KontaktniOsoba();
                        inzerat.reagujici.id = reader.GetInt32(10);
                        inzerat.reagujici.jmeno = reader.GetValue(11).ToString();
                        inzerat.reagujici.stredisko = reader.GetValue(12).ToString();
                        inzerat.reagujici.oddeleni = reader.GetValue(13).ToString();
                        inzerat.reagujici.usek = reader.GetValue(14).ToString();
                        inzerat.nazevZapujcenehoUseku = reader.GetValue(15).ToString();

                        seznam.Add(inzerat);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static int VlozitNabidku(Inzerat inzerat)
        {
            String sqlStr = "INSERT INTO Inzerat_Inzerat (datumVytvoreni, datumOd, datumDo, casOd, casDo, duvod, idZam, idZadavajiciho, typ, status, ukonceno, dobaReakce) "
                + "VALUES (@datumVytvoreni, @datumOd, @datumDo, @casOd, @casDo, @duvod, @idZam, @idZadavajiciho, @typ, @status, @ukonceno, @dobaReakce) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@datumVytvoreni", inzerat.datumVytvoreni);
                    cmd.Parameters.AddWithValue("@datumOd", inzerat.datumOd);
                    cmd.Parameters.AddWithValue("@datumDo", inzerat.datumDo);
                    cmd.Parameters.AddWithValue("@casOd", inzerat.casOd);
                    cmd.Parameters.AddWithValue("@casDo", inzerat.casDo);
                    cmd.Parameters.AddWithValue("@duvod", inzerat.duvod);
                    cmd.Parameters.AddWithValue("@idZam", inzerat.zamestnanec.id);
                    cmd.Parameters.AddWithValue("@idZadavajiciho", inzerat.zadavajici.id);
                    cmd.Parameters.AddWithValue("@typ", inzerat.typ);
                    cmd.Parameters.AddWithValue("@status", 1);
                    cmd.Parameters.AddWithValue("@ukonceno", 0);
                    cmd.Parameters.AddWithValue("@dobaReakce", inzerat.dobaReakce);

                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }
        public static bool UpravitNabidku(Inzerat inzerat)
        {
            String sqlStr = "UPDATE Inzerat_Inzerat SET datumOd=@datumOd, datumDo=@datumDo, casOd=@casOd, casDo=@casDo, duvod=@duvod, idZam=@idZam, idZadavajiciho=@idZadavajiciho, typ=@typ, status=@status, pohlavi=@pohlavi, " +
                "smenovyModel=@smenovyModel, pozice=@pozice, dobaReakce=@dobaReakce WHERE id = " + inzerat.id;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@datumOd", inzerat.datumOd);
                    cmd.Parameters.AddWithValue("@datumDo", inzerat.datumDo);
                    cmd.Parameters.AddWithValue("@casOd", inzerat.casOd);
                    cmd.Parameters.AddWithValue("@casDo", inzerat.casDo);
                    cmd.Parameters.AddWithValue("@duvod", inzerat.duvod);
                    cmd.Parameters.AddWithValue("@idZam", inzerat.zamestnanec.id);
                    cmd.Parameters.AddWithValue("@idZadavajiciho", inzerat.zadavajici.id);
                    cmd.Parameters.AddWithValue("@typ", inzerat.typ);
                    cmd.Parameters.AddWithValue("@status", inzerat.status);
                    cmd.Parameters.AddWithValue("@pohlavi", inzerat.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", inzerat.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", inzerat.pozice);
                    cmd.Parameters.AddWithValue("@dobaReakce", inzerat.dobaReakce);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    return false;
                }
                finally
                {
                    conn.Close();
                }
                return true;
            }
        }
        public static int VlozitPoptavku(Inzerat inzerat)
        {
            String sqlStr = "INSERT INTO Inzerat_Inzerat (datumVytvoreni, datumOd, datumDo, casOd, casDo, duvod, idZadavajiciho, typ, status, pohlavi, smenovyModel, pozice, ukonceno, dobaReakce) "
                + "VALUES (@datumVytvoreni, @datumOd, @datumDo, @casOd, @casDo, @duvod, @idZadavajiciho, @typ, @status, @pohlavi, @smenovyModel, @pozice, @ukonceno, @dobaReakce) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@datumVytvoreni", inzerat.datumVytvoreni);
                    cmd.Parameters.AddWithValue("@datumOd", inzerat.datumOd);
                    cmd.Parameters.AddWithValue("@datumDo", inzerat.datumDo);
                    cmd.Parameters.AddWithValue("@casOd", inzerat.casOd);
                    cmd.Parameters.AddWithValue("@casDo", inzerat.casDo);
                    cmd.Parameters.AddWithValue("@duvod", inzerat.duvod);
                    cmd.Parameters.AddWithValue("@idZadavajiciho", inzerat.zadavajici.id);
                    cmd.Parameters.AddWithValue("@typ", inzerat.typ);
                    cmd.Parameters.AddWithValue("@status", 1);
                    cmd.Parameters.AddWithValue("@pohlavi", inzerat.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", inzerat.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", inzerat.pozice);
                    cmd.Parameters.AddWithValue("@ukonceno", 0);
                    cmd.Parameters.AddWithValue("@dobaReakce", inzerat.dobaReakce);

                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }

        public static bool UpravitPoptavku(Inzerat inzerat)
        {
            String sqlStr = "UPDATE Inzerat_Inzerat SET datumOd=@datumOd, datumDo=@datumDo, casOd=@casOd, casDo=@casDo, duvod=@duvod, idZadavajiciho=@idZadavajiciho, typ=@typ, status=@status, pohlavi=@pohlavi, " +
                "smenovyModel=@smenovyModel, pozice=@pozice, dobaReakce=@dobaReakce WHERE id = " + inzerat.id;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@datumOd", inzerat.datumOd);
                    cmd.Parameters.AddWithValue("@datumDo", inzerat.datumDo);
                    cmd.Parameters.AddWithValue("@casOd", inzerat.casOd);
                    cmd.Parameters.AddWithValue("@casDo", inzerat.casDo);
                    cmd.Parameters.AddWithValue("@duvod", inzerat.duvod);
                    cmd.Parameters.AddWithValue("@idZadavajiciho", inzerat.zadavajici.id);
                    cmd.Parameters.AddWithValue("@typ", inzerat.typ);
                    cmd.Parameters.AddWithValue("@status", inzerat.status);
                    cmd.Parameters.AddWithValue("@pohlavi", inzerat.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", inzerat.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", inzerat.pozice);
                    cmd.Parameters.AddWithValue("@dobaReakce", inzerat.dobaReakce);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    return false;
                }
                finally
                {
                    conn.Close();
                }
                return true;
            }
        }
        public static void ReagovatNaNabidku(Inzerat inzerat)
        {
            String sqlStr = "UPDATE Zamestnanec SET idZapujcenehoUseku=@idZapujcenehoUseku WHERE id = " + inzerat.zamestnanec.id + ";"
                + " UPDATE Inzerat_Inzerat SET idReagujiciho=@idReagujiciho, status=2, idZapujcenehoUseku=@idZapUseku, ntReagujiciho='" + "fip8jh" + "' WHERE id = " + inzerat.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@idZapujcenehoUseku", inzerat.reagujici.idUseku);
                    cmd.Parameters.AddWithValue("@idReagujiciho", inzerat.reagujici.id);
                    cmd.Parameters.AddWithValue("@idZapUseku", inzerat.reagujici.id);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static bool SmazatInzarat(int idInzeratu)
        {
            bool test = false;
            String sqlStr = "DELETE Inzerat_Inzerat WHERE id = " + idInzeratu;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                    test = true;
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return test;
        }
    }
}
