﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class Kompetentce: ViewModelBase
    {
        private int _id;
        private int _idZam;
        private int _idPracoviste;
        private int? _hodnoceni;
        private int _idTridy;
        public string nazevTridy { get; set; }
        public bool ulozitTridu;
        public bool ulozitHodnoceni;
        public bool ulozitPrehled;
        private string _prehled;
        public int id
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    OnPropertyChanged("id");
                }
            }
        }
        public int idZam
        {
            get { return _idZam; }
            set
            {
                if (_idZam != value)
                {
                    _idZam = value;
                    OnPropertyChanged("idZam");
                }
            }
        }
        public int idPracoviste
        {
            get { return _idPracoviste; }
            set
            {
                if (_idPracoviste != value)
                {
                    _idPracoviste = value;
                    OnPropertyChanged("idPracoviste");
                }
            }
        }
        
        public int? hodnoceni
        {
            get { return _hodnoceni; }
            set
            {
                if (_hodnoceni != value)
                {
                    _hodnoceni = value;
                    if (ulozitHodnoceni) UlozitZmenuKompetence(this);
                    else ulozitHodnoceni = true;
                    OnPropertyChanged("hodnoceni");
                }
            }
        }
        public int idTridy
        {
            get { return _idTridy; }
            set
            {
                if (_idTridy != value)
                {
                    _idTridy = value;
                    if (ulozitTridu) UlozitZmenuKompetence(this);
                    else ulozitTridu = true;
                    OnPropertyChanged("idTridy");

                }
            }
        }
        public string prehled
        {
            get { return _prehled; }
            set
            {
                if (_prehled == value)
                    return;
                _prehled = value;
                if (ulozitPrehled) UlozitZmenuKompetenceZprehledu(this);
                OnPropertyChanged("prehled");
            }
        }
        public static ObservableCollection<Pracoviste> SelectKompetenceZam(int idUseku, int idZam)
        {
            ObservableCollection<Pracoviste> seznam = new ObservableCollection<Pracoviste>();

            String sqlStr = "SELECT a.id, a.idOblasti, a.nazev, c.hodnoceni, c.idTridy FROM Matice_Pracoviste AS a "
                + "JOIN Matice_OblastVyroby AS b ON a.idOblasti = b.id "
                + "LEFT JOIN Matice_Kompetence AS c ON c.idPracoviste = a.id "
            + "WHERE idUseku = " + idUseku + " AND c.idZam = " + idZam;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Pracoviste item;

                    while (reader.Read())
                    {
                        item = new Pracoviste();
                        item.id = reader.GetInt32(0);
                        item.idOblasti = reader.GetInt32(1);
                        item.nazev = reader.GetValue(2).ToString();
                        if (reader.GetValue(3) != DBNull.Value)
                        {
                            item.kompetence.hodnoceni = reader.GetInt32(3);
                            item.kompetence.idTridy = reader.GetInt32(4);
                        }
                        else item.kompetence.hodnoceni = null;
                        item.kompetence.idPracoviste = item.id;
                        item.kompetence.idZam = idZam;
                        item.kompetence.ulozitTridu = true;
                        item.kompetence.ulozitHodnoceni = true;
                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static ObservableCollection<Pracoviste> SelectKompetenceVsechDaneOblasti(List<int> seznamPracovist)
        {
            
            ObservableCollection<Pracoviste> seznam = new ObservableCollection<Pracoviste>();

            if (seznamPracovist.Count == 0) return seznam;

            String sqlStr = "SELECT c.id, c.idOblasti, c.nazev, d.hodnoceni, d.idTridy, e.nazev, a.id FROM Zamestnanec AS a "
               + "JOIN Matice_OblastVyroby AS b ON b.idUseku = a.idUseku "
               + "LEFT JOIN Matice_Pracoviste AS c ON c.idOblasti = b.id "
               + "LEFT JOIN Matice_Kompetence AS d ON (d.idPracoviste = c.id AND d.idZam = a.id) "
               + "LEFT JOIN Matice_Trida AS e ON e.id = d.idTridy "
               + "WHERE c.id IN (";
                foreach (var item in seznamPracovist)
                {
                    sqlStr += item + ", ";
                }
                sqlStr = sqlStr.Remove(sqlStr.Length - 2);
                sqlStr += " ) ";



            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Pracoviste item;

                    while (reader.Read())
                    {
                        item = new Pracoviste();
                        item.id = reader.GetInt32(0);
                        item.idOblasti = reader.GetInt32(1);
                        item.nazev = reader.GetValue(2).ToString();
                        if (reader.GetValue(3) != DBNull.Value)
                        {
                            item.kompetence.hodnoceni = reader.GetInt32(3);
                            item.kompetence.idTridy = reader.GetInt32(4);
                            item.kompetence.nazevTridy = reader.GetValue(5).ToString();
                            if (item.kompetence.idTridy == 1)
                            {
                                switch (item.kompetence.hodnoceni)
                                {
                                    case 0: item.kompetence.prehled = "oo";
                                        break;
                                    case 1:
                                        item.kompetence.prehled = "●o";
                                        break;
                                    case 2:
                                        item.kompetence.prehled = "●●";
                                        break;
                                    default: item.kompetence.prehled = "oo";
                                        break;
                                }
                            }
                            else
                            {
                                switch (item.kompetence.hodnoceni)
                                {
                                    case 0:
                                        item.kompetence.prehled = "ooo";
                                        break;
                                    case 1:
                                        item.kompetence.prehled = "●oo";
                                        break;
                                    case 2:
                                        item.kompetence.prehled = "●●o";
                                        break;
                                    case 3:
                                        item.kompetence.prehled = "●●●";
                                        break;
                                    default:
                                        item.kompetence.prehled = "ooo";
                                        break;
                                }
                            }
                        }
                        else
                        {
                            item.kompetence.hodnoceni = null;
                            item.kompetence.nazevTridy = "-";
                            item.kompetence.prehled = "-";
                        }
                        item.kompetence.idPracoviste = item.id;
                        item.kompetence.idZam = reader.GetInt32(6);
                        item.kompetence.ulozitPrehled = true;
                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static ObservableCollection<Pracoviste> SelectVsechnyKompetenceZam(int idZam, int idAktualnihoUseku, ObservableCollection<Usek> seznamUseku)
        {
            ObservableCollection<Pracoviste> seznam = new ObservableCollection<Pracoviste>();

            String sqlStr = "SELECT a.id, a.idOblasti, a.nazev, c.hodnoceni, c.idTridy, d.nazev FROM Matice_Pracoviste AS a "
                + "JOIN Matice_OblastVyroby AS b ON a.idOblasti = b.id "
                + "LEFT JOIN Matice_Kompetence AS c ON (c.idZam = " + idZam + " AND c.idPracoviste = a.id) "
                + "LEFT JOIN Matice_Trida AS d ON d.id = c.idTridy "
                + "JOIN Usek AS e ON e.id = b.idUseku "
                + "WHERE e.id IN (" + idAktualnihoUseku + ", ";
                foreach (var item in seznamUseku)
                {
                    sqlStr += item.id + ", ";
                }
                sqlStr = sqlStr.Remove(sqlStr.Length - 2);
                sqlStr += " ) ";


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Pracoviste item;

                    while (reader.Read())
                    {
                        item = new Pracoviste();
                        item.id = reader.GetInt32(0);
                        item.idOblasti = reader.GetInt32(1);
                        item.nazev = reader.GetValue(2).ToString();
                        if (reader.GetValue(3) != DBNull.Value)
                        {
                            item.kompetence.hodnoceni = reader.GetInt32(3);
                            item.kompetence.idTridy = reader.GetInt32(4);
                            item.kompetence.nazevTridy = reader.GetValue(5).ToString();
                        }
                        else 
                        {
                            item.kompetence.hodnoceni = null;
                            item.kompetence.nazevTridy = "-";
                        }
                        item.kompetence.idPracoviste = item.id;
                        item.kompetence.idZam = idZam;
                        item.kompetence.ulozitTridu = true;
                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static void UlozitZmenuKompetence(Kompetentce item)
        {
            String sqlStr = "UPDATE Matice_Kompetence SET idZam=@idZam, idPracoviste=@idPracoviste, hodnoceni=@hodnoceni, idTridy=@idTridy WHERE idZam = " + item.idZam + " AND idPracoviste = " + item.idPracoviste
                        + " IF @@ROWCOUNT=0 INSERT INTO Matice_Kompetence (idZam, idPracoviste, hodnoceni, idTridy) VALUES"
                        + " (@idZam, @idPracoviste, @hodnoceni, @idTridy)";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();

                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.Clear();

                    cmd.Parameters.AddWithValue("@idZam", item.idZam);
                    cmd.Parameters.AddWithValue("@idPracoviste", item.idPracoviste);
                    if(item.idTridy != 0)
                    {

                        if (item.hodnoceni != null)
                        {
                            if (item.idTridy == 1 && item.hodnoceni == 3)
                            {
                                item.hodnoceni = 2;
                                cmd.Parameters.AddWithValue("@hodnoceni", 2);
                            }
                            else cmd.Parameters.AddWithValue("@hodnoceni", item.hodnoceni);
                        }
                        else
                        {
                            cmd.Parameters.AddWithValue("@hodnoceni", 0);
                            item.ulozitHodnoceni = true;
                        }                        
                    }
                    else
                    {
                        item.hodnoceni = 0;
                        cmd.Parameters.AddWithValue("@hodnoceni", 0);
                    }
                    
                    cmd.Parameters.AddWithValue("@idTridy", item.idTridy);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void UlozitZmenuKompetenceZprehledu(Kompetentce item)
        {
            String sqlStr = "UPDATE Matice_Kompetence SET idZam=@idZam, idPracoviste=@idPracoviste, hodnoceni=@hodnoceni, idTridy=@idTridy WHERE idZam = " + item.idZam + " AND idPracoviste = " + item.idPracoviste
                        + " IF @@ROWCOUNT=0 INSERT INTO Matice_Kompetence (idZam, idPracoviste, hodnoceni, idTridy) VALUES"
                        + " (@idZam, @idPracoviste, @hodnoceni, @idTridy)";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();

                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.Clear();

                    cmd.Parameters.AddWithValue("@idZam", item.idZam);
                    cmd.Parameters.AddWithValue("@idPracoviste", item.idPracoviste);
                    switch (item.prehled)
                    {
                        case "-":
                            cmd.Parameters.AddWithValue("@hodnoceni", 0);
                            cmd.Parameters.AddWithValue("@idTridy", 0);
                            break;
                        case "●●":
                            cmd.Parameters.AddWithValue("@hodnoceni", 2);
                            cmd.Parameters.AddWithValue("@idTridy", 1);
                            break;
                        case "●o":
                            cmd.Parameters.AddWithValue("@hodnoceni", 1);
                            cmd.Parameters.AddWithValue("@idTridy", 1);
                            break;
                        case "oo":
                            cmd.Parameters.AddWithValue("@hodnoceni", 0);
                            cmd.Parameters.AddWithValue("@idTridy", 1);
                            break;
                        case "●●●":
                            cmd.Parameters.AddWithValue("@hodnoceni", 3);
                            cmd.Parameters.AddWithValue("@idTridy", 2);
                            break;
                        case "●●o":
                            cmd.Parameters.AddWithValue("@hodnoceni", 2);
                            cmd.Parameters.AddWithValue("@idTridy", 2);
                            break;
                        case "●oo":
                            cmd.Parameters.AddWithValue("@hodnoceni", 1);
                            cmd.Parameters.AddWithValue("@idTridy", 2);
                            break;
                        case "ooo":
                            cmd.Parameters.AddWithValue("@hodnoceni", 0);
                            cmd.Parameters.AddWithValue("@idTridy", 2);
                            break;
                        default:
                            cmd.Parameters.AddWithValue("@hodnoceni", 0);
                            cmd.Parameters.AddWithValue("@idTridy", 0);
                            break;
                    }
                    
                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

    }
}
