﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class KontaktniOsoba : ViewModelBase
    {
        public int id { get; set; }
        private string _jmeno;
        private string _oddeleni;
        private string _stredisko;
        private string _usek;
        private string _klapka;
        private string _mobil;
        private string _email;
        private string _pozice;
        private string _smenovyModel;
        private string _zavod;
        private string _hala;
        private string _vchod;
        private string _mistoVyzvednuti;
        private string _uzivatel;
        public int idUseku { get; set; }
        private string _nazevUseku;
        public string jmeno
        {
            get { return _jmeno; }
            set
            {
                if (_jmeno == value)
                    return;
                _jmeno = value;
                OnPropertyChanged("jmeno");
            }
        }

        public string oddeleni
        {
            get { return _oddeleni; }
            set
            {
                if (_oddeleni == value)
                    return;
                _oddeleni = value;
                OnPropertyChanged("oddeleni");
            }
        }
        public string stredisko
        {
            get { return _stredisko; }
            set
            {
                if (_stredisko == value)
                    return;
                _stredisko = value;
                OnPropertyChanged("stredisko");
            }
        }
        public string usek
        {
            get { return _usek; }
            set
            {
                if (_usek == value)
                    return;
                _usek = value;
                OnPropertyChanged("usek");
            }
        }
        public string klapka
        {
            get { return _klapka; }
            set
            {
                if (_klapka == value)
                    return;
                _klapka = value;
                OnPropertyChanged("klapka");
            }
        }
        public string mobil
        {
            get { return _mobil; }
            set
            {
                if (_mobil == value)
                    return;
                _mobil = value;
                OnPropertyChanged("mobil");
            }
        }
        public string email
        {
            get { return _email; }
            set
            {
                if (_email == value)
                    return;
                _email = value;
                OnPropertyChanged("email");
            }
        }
        public string pozice
        {
            get { return _pozice; }
            set
            {
                if (_pozice == value)
                    return;
                _pozice = value;
                OnPropertyChanged("pozice");
            }
        }
        public string smenovyModel
        {
            get { return _smenovyModel; }
            set
            {
                if (_smenovyModel == value)
                    return;
                _smenovyModel = value;
                OnPropertyChanged("smenovyModel");
            }
        }
        public string zavod
        {
            get { return _zavod; }
            set
            {
                if (_zavod == value)
                    return;
                _zavod = value;
                OnPropertyChanged("zavod");
            }
        }
        public string hala
        {
            get { return _hala; }
            set
            {
                if (_hala == value)
                    return;
                _hala = value;
                OnPropertyChanged("hala");
            }
        }
        public string vchod
        {
            get { return _vchod; }
            set
            {
                if (_vchod == value)
                    return;
                _vchod = value;
                OnPropertyChanged("vchod");
            }
        }
        public string mistoVyzvednuti
        {
            get { return _mistoVyzvednuti; }
            set
            {
                if (_mistoVyzvednuti == value)
                    return;
                _mistoVyzvednuti = value;
                OnPropertyChanged("mistoVyzvednuti");
            }
        }
        public string uzivatel
        {
            get { return _uzivatel; }
            set
            {
                if (_uzivatel == value)
                    return;
                _uzivatel = value;
                OnPropertyChanged("uzivatel");
            }
        }
        public string nazevUseku
        {
            get { return _nazevUseku; }
            set
            {
                if (_nazevUseku == value)
                    return;
                _nazevUseku = value;
                OnPropertyChanged("nazevUseku");
            }
        }
        public KontaktniOsoba() { }
        public KontaktniOsoba(KontaktniOsoba kontakt)
        {
            this.id = kontakt.id;
            this.jmeno = kontakt.jmeno;
            this.oddeleni = kontakt.oddeleni;
            this.stredisko = kontakt.stredisko;
            this.usek = kontakt.usek;
            this.klapka = kontakt.klapka;
            this.mobil = kontakt.mobil;
            this.email = kontakt.email;
            this.pozice = kontakt.pozice;
            this.smenovyModel = kontakt.smenovyModel;
            this.zavod = kontakt.zavod;
            this.hala = kontakt.hala;
            this.vchod = kontakt.vchod;
            this.mistoVyzvednuti = kontakt.mistoVyzvednuti;
            this.uzivatel = kontakt.uzivatel;
            this.idUseku = kontakt.idUseku;
            this.nazevUseku = kontakt.nazevUseku;
        }
        public static ObservableCollection<KontaktniOsoba> SelectKontakty()
        {

            ObservableCollection<KontaktniOsoba> seznam = new ObservableCollection<KontaktniOsoba>();
            String sqlStr = "SELECT a.id, a.jmeno, a.oddeleni, a.stredisko, a.usek, a.klapka, a.mobil, a.email, a.pozice, a.smenovyModel, a.zavod, a.hala, a.vchod, a.mistoVyzvednuti, a.uzivatel, a.idUseku, b.nazev FROM Inzerat_KontaktniOsoba AS a "
                + "JOIN Usek AS b on b.id = a.idUseku "
                + "WHERE aktivni = 1 ORDER BY a.jmeno";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    KontaktniOsoba kontakt;

                    while (reader.Read())
                    {
                        kontakt = new KontaktniOsoba();
                        kontakt.id = reader.GetInt32(0);
                        kontakt.jmeno = reader.GetValue(1).ToString();
                        kontakt.oddeleni = reader.GetValue(2).ToString();
                        kontakt.stredisko = reader.GetValue(3).ToString();
                        kontakt.usek = reader.GetValue(4).ToString();
                        kontakt.klapka = reader.GetValue(5).ToString();
                        kontakt.mobil = reader.GetValue(6).ToString();
                        kontakt.email = reader.GetValue(7).ToString();
                        kontakt.pozice = reader.GetValue(8).ToString();
                        kontakt.smenovyModel = reader.GetValue(9).ToString();
                        kontakt.zavod = reader.GetValue(10).ToString();
                        kontakt.hala = reader.GetValue(11).ToString();
                        kontakt.vchod = reader.GetValue(12).ToString();
                        kontakt.mistoVyzvednuti = reader.GetValue(13).ToString();
                        kontakt.uzivatel = reader.GetValue(14).ToString();
                        kontakt.idUseku = reader.GetInt32(15);
                        kontakt.nazevUseku = reader.GetValue(16).ToString();
                        seznam.Add(kontakt);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static KontaktniOsoba HledejKontaktPodleNT()
        {

            KontaktniOsoba kontakt = new KontaktniOsoba();
            String sqlStr = "SELECT a.id, a.jmeno, a.oddeleni, a.stredisko, a.usek, a.klapka, a.mobil, a.email, a.pozice, a.smenovyModel, a.zavod, a.hala, a.vchod, a.mistoVyzvednuti, a.uzivatel, a.idUseku, b.nazev FROM Inzerat_KontaktniOsoba AS a "
                + "JOIN Usek AS b on b.id = a.idUseku "
                + "WHERE uzivatel = '" + "fip8jh" + "' AND aktivni = 1";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();


                    while (reader.Read())
                    {
                        kontakt.id = reader.GetInt32(0);
                        kontakt.jmeno = reader.GetValue(1).ToString();
                        kontakt.oddeleni = reader.GetValue(2).ToString();
                        kontakt.stredisko = reader.GetValue(3).ToString();
                        kontakt.usek = reader.GetValue(4).ToString();
                        kontakt.klapka = reader.GetValue(5).ToString();
                        kontakt.mobil = reader.GetValue(6).ToString();
                        kontakt.email = reader.GetValue(7).ToString();
                        kontakt.pozice = reader.GetValue(8).ToString();
                        kontakt.smenovyModel = reader.GetValue(9).ToString();
                        kontakt.zavod = reader.GetValue(10).ToString();
                        kontakt.hala = reader.GetValue(11).ToString();
                        kontakt.vchod = reader.GetValue(12).ToString();
                        kontakt.mistoVyzvednuti = reader.GetValue(13).ToString();
                        kontakt.uzivatel = reader.GetValue(14).ToString();
                        kontakt.idUseku = reader.GetInt32(15);
                        kontakt.nazevUseku = reader.GetValue(16).ToString();
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return kontakt;
        }
        public static ObservableCollection<KontaktniOsoba> HledejKontakt(string sqlStr)
        {

            ObservableCollection<KontaktniOsoba> seznam = new ObservableCollection<KontaktniOsoba>();

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    KontaktniOsoba kontakt;

                    while (reader.Read())
                    {
                        kontakt = new KontaktniOsoba();
                        kontakt.id = reader.GetInt32(0);
                        kontakt.jmeno = reader.GetValue(1).ToString();
                        kontakt.oddeleni = reader.GetValue(2).ToString();
                        kontakt.stredisko = reader.GetValue(3).ToString();
                        kontakt.usek = reader.GetValue(4).ToString();
                        kontakt.klapka = reader.GetValue(5).ToString();
                        kontakt.mobil = reader.GetValue(6).ToString();
                        kontakt.email = reader.GetValue(7).ToString();
                        kontakt.pozice = reader.GetValue(8).ToString();
                        kontakt.smenovyModel = reader.GetValue(9).ToString();
                        kontakt.zavod = reader.GetValue(10).ToString();
                        kontakt.hala = reader.GetValue(11).ToString();
                        kontakt.vchod = reader.GetValue(12).ToString();
                        kontakt.mistoVyzvednuti = reader.GetValue(13).ToString();
                        kontakt.uzivatel = reader.GetValue(14).ToString();
                        seznam.Add(kontakt);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static int UlozitKontaktniOsobu(KontaktniOsoba kontakt)
        {

            String sqlStr = "UPDATE Inzerat_KontaktniOsoba SET jmeno=@jmeno, oddeleni=@oddeleni, stredisko=@stredisko, usek=@usek, klapka=@klapka, mobil=@mobil, email=@email, pozice=@pozice, smenovyModel=@smenovyModel, zavod=@zavod, "
                        + "hala=@hala, vchod=@vchod, mistoVyzvednuti=@mistoVyzvednuti, uzivatel=@uzivatel, aktivni=@aktivni, idUseku=@idUseku WHERE uzivatel = '" + kontakt.uzivatel + "'"
                        + " IF @@ROWCOUNT=0 INSERT INTO Inzerat_KontaktniOsoba (jmeno, oddeleni, stredisko, usek, klapka, mobil, email, pozice, smenovyModel, zavod, hala, vchod, mistoVyzvednuti, uzivatel, aktivni, idUseku) "
                        + "VALUES (@jmeno, @oddeleni, @stredisko, @usek, @klapka, @mobil, @email, @pozice, @smenovyModel, @zavod, @hala, @vchod, @mistoVyzvednuti, @uzivatel, @aktivni, @idUseku) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@jmeno", kontakt.jmeno);
                    cmd.Parameters.AddWithValue("@oddeleni", kontakt.oddeleni);
                    cmd.Parameters.AddWithValue("@stredisko", kontakt.stredisko);
                    cmd.Parameters.AddWithValue("@usek", kontakt.usek);
                    cmd.Parameters.AddWithValue("@klapka", kontakt.klapka);
                    cmd.Parameters.AddWithValue("@mobil", kontakt.mobil);
                    cmd.Parameters.AddWithValue("@email", kontakt.email);
                    cmd.Parameters.AddWithValue("@pozice", kontakt.pozice);
                    cmd.Parameters.AddWithValue("@smenovyModel", kontakt.smenovyModel);
                    cmd.Parameters.AddWithValue("@zavod", kontakt.zavod);
                    cmd.Parameters.AddWithValue("@hala", kontakt.hala);
                    cmd.Parameters.AddWithValue("@vchod", kontakt.vchod);
                    cmd.Parameters.AddWithValue("@mistoVyzvednuti", kontakt.mistoVyzvednuti);
                    cmd.Parameters.AddWithValue("@uzivatel", kontakt.uzivatel);
                    cmd.Parameters.AddWithValue("@aktivni", 1);
                    cmd.Parameters.AddWithValue("@idUseku", kontakt.idUseku);


                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }

        
        public static void SmazatKontaktniOsobu(KontaktniOsoba kontakt)
        {
            String sqlStr = "UPDATE Inzerat_KontaktniOsoba SET aktivni=0 WHERE id = " + kontakt.id + ";";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void UpravitKontaktniOsobu(KontaktniOsoba kontakt)
        {
            String sqlStr = "UPDATE Inzerat_KontaktniOsoba SET jmeno=@jmeno, oddeleni=@oddeleni, stredisko=@stredisko, usek=@usek, klapka=@klapka, mobil=@mobil, pozice=@pozice, smenovyModel=@smenovyModel, zavod=@zavod, "
                        + "hala=@hala, vchod=@vchod, mistoVyzvednuti=@mistoVyzvednuti WHERE uzivatel = '" + kontakt.uzivatel + "'";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    if (kontakt.jmeno != null) cmd.Parameters.AddWithValue("@jmeno", kontakt.jmeno);
                    else cmd.Parameters.AddWithValue("@jmeno", DBNull.Value);
                    if (kontakt.oddeleni != null) cmd.Parameters.AddWithValue("@oddeleni", kontakt.oddeleni);
                    else cmd.Parameters.AddWithValue("@oddeleni", DBNull.Value);
                    if (kontakt.stredisko != null) cmd.Parameters.AddWithValue("@stredisko", kontakt.stredisko);
                    else cmd.Parameters.AddWithValue("@stredisko", DBNull.Value);
                    if (kontakt.usek != null) cmd.Parameters.AddWithValue("@usek", kontakt.usek);
                    else cmd.Parameters.AddWithValue("@usek", DBNull.Value);
                    if (kontakt.klapka != null) cmd.Parameters.AddWithValue("@klapka", kontakt.klapka);
                    else cmd.Parameters.AddWithValue("@klapka", DBNull.Value);
                    if (kontakt.mobil != null) cmd.Parameters.AddWithValue("@mobil", kontakt.mobil);
                    else cmd.Parameters.AddWithValue("@mobil", DBNull.Value);
                    if (kontakt.pozice != null) cmd.Parameters.AddWithValue("@pozice", kontakt.pozice);
                    else cmd.Parameters.AddWithValue("@pozice", DBNull.Value);
                    if (kontakt.smenovyModel != null) cmd.Parameters.AddWithValue("@smenovyModel", kontakt.smenovyModel);
                    else cmd.Parameters.AddWithValue("@smenovyModel", DBNull.Value);
                    if (kontakt.zavod != null) cmd.Parameters.AddWithValue("@zavod", kontakt.zavod);
                    else cmd.Parameters.AddWithValue("@zavod", DBNull.Value);
                    if (kontakt.hala != null) cmd.Parameters.AddWithValue("@hala", kontakt.hala);
                    else cmd.Parameters.AddWithValue("@hala", DBNull.Value);
                    if (kontakt.vchod != null) cmd.Parameters.AddWithValue("@vchod", kontakt.vchod);
                    else cmd.Parameters.AddWithValue("@vchod", DBNull.Value);
                    if (kontakt.mistoVyzvednuti != null) cmd.Parameters.AddWithValue("@mistoVyzvednuti", kontakt.mistoVyzvednuti);
                    else cmd.Parameters.AddWithValue("@mistoVyzvednuti", DBNull.Value);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

    }
}