﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class Pozice : ViewModelBase
    {
        public int id { get; set; }
        private string _nazev;

        public string nazev
        {
            get { return _nazev; }
            set
            {
                if (_nazev == value)
                    return;
                _nazev = value;
                OnPropertyChanged("nazev");
            }
        }

        public Pozice() { }
        public Pozice(Pozice pozice)
        {
            this.id = pozice.id;
            this.nazev = pozice.nazev;
        }
        public static ObservableCollection<Pozice> SelectPoziceProCB()
        {
            ObservableCollection<Pozice> seznam = new ObservableCollection<Pozice>();

            String sqlStr = "SELECT id, nazev FROM Matice_Pozice";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Pozice item;

                    while (reader.Read())
                    {
                        item = new Pozice();
                        item.id = reader.GetInt32(0);
                        item.nazev = reader.GetValue(1).ToString();

                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static int VlozitPozici(Pozice pozice)
        {
            String sqlStr = "INSERT INTO Matice_Pozice (nazev) "
                + "VALUES (@nazev) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@nazev", pozice.nazev);

                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }

        public static void UpravitPozici(Pozice pozice)
        {
            String sqlStr = "UPDATE Matice_Pozice SET nazev=@nazev WHERE id = " + pozice.id + ";";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@nazev", pozice.nazev);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void SmazatPozici(Pozice pozice)
        {
            String sqlStr = "DELETE Matice_Pozice WHERE id = " + pozice.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
    }
}
