﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;


namespace KompetencniMatice.Models
{
    public class SmenovyModel: ViewModelBase
    {
        public int id { get; set; }
        private string _nazev;

        public string nazev
        {
            get { return _nazev; }
            set
            {
                if (_nazev == value)
                    return;
                _nazev = value;
                OnPropertyChanged("nazev");
            }
        }

        public SmenovyModel() { }
        public SmenovyModel(SmenovyModel smena)
        {
            this.id = smena.id;
            this.nazev = smena.nazev;
        }

        public static ObservableCollection<SmenovyModel> SelectSmenoveModelyProCB()
        {
            ObservableCollection<SmenovyModel> seznam = new ObservableCollection<SmenovyModel>();

            String sqlStr = "SELECT id, nazev FROM Matice_SmenovyModel";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    SmenovyModel item;

                    while (reader.Read())
                    {
                        item = new SmenovyModel();
                        item.id = reader.GetInt32(0);
                        item.nazev = reader.GetValue(1).ToString();

                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static int VlozitSmenu(SmenovyModel smena)
        {
            String sqlStr = "INSERT INTO Matice_SmenovyModel (nazev) "
                + "VALUES (@nazev) SELECT SCOPE_IDENTITY();";
            int id = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@nazev", smena.nazev);

                    id = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return id;
            }
        }

        public static void UpravitSmenu(SmenovyModel smena)
        {
            String sqlStr = "UPDATE Matice_SmenovyModel SET nazev=@nazev WHERE id = " + smena.id + ";";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@nazev", smena.nazev);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static void SmazatSmenu(SmenovyModel smena)
        {
            String sqlStr = "DELETE Matice_SmenovyModel WHERE id = " + smena.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
    }
}
