﻿using Support;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class Usek
    {
        public int id { get; set; }
        public string nazev { get; set; }
        public string poznamka { get; set; }
        public bool povoleno { get; set; }
        public static ObservableCollection<Usek> SelectUseky()
        {

            ObservableCollection<Usek> seznam = new ObservableCollection<Usek>();
            String sqlStr = "SELECT * FROM Usek";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Usek usek;

                    while (reader.Read())
                    {
                        usek = new Usek();
                        usek.id = reader.GetInt32(0);
                        usek.nazev = reader.GetValue(1).ToString();
                        usek.poznamka = reader.GetValue(2).ToString();
                        
                        seznam.Add(usek);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static Usek SelectUsekPodleID(int idUseku)
        {

            Usek usek = new Usek();
            String sqlStr = "SELECT * FROM Usek WHERE id = " + idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        usek = new Usek();
                        usek.id = reader.GetInt32(0);
                        usek.nazev = reader.GetValue(1).ToString();
                        usek.poznamka = reader.GetValue(2).ToString();
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return usek;
        }

        public static ObservableCollection<Usek> SelectUsekyZam(int idZam, int idAktualnihoUseku)
        {
            ObservableCollection<Usek> seznam = new ObservableCollection<Usek>();

            string sqlStr = "SELECT DISTINCT a.id, a.nazev FROM Usek as a "
                + "JOIN Matice_OblastVyroby AS b ON b.idUseku = a.id "
                + "JOIN Matice_Pracoviste AS c ON c.idOblasti = b.id "
                + "JOIN Matice_Kompetence AS d ON(d.idZam = " + idZam + " AND d.idPracoviste = c.id) "
                + "WHERE a.id != " + idAktualnihoUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Usek usek;

                    while (reader.Read())
                    {
                        usek = new Usek();
                        usek.id = reader.GetInt32(0);
                        usek.nazev = reader.GetValue(1).ToString();

                        seznam.Add(usek);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
    }
}
