﻿using Support;
using KompetencniMatice.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace KompetencniMatice.Models
{
    public class Zamestnanec: ViewModelBase
    {
        private int _id;
        private string _osCislo;
        private string _jmeno;
        private string _prijmeni;
        private string _stredisko;
        private DateTime _datumNastupu;
        private string _kategorie;
        private string _smenovyModel;
        private string _pozice;
        private string _pohlavi;
        private bool _ukoncen;
        private bool _nabidnut;
        private OblastVyroby _zobrazenaOblastVyroby;
        private bool _aktivni;
        private string _poznamka;
        public int idUseku { get; set; }
        public int idZapujcenehoUseku { get; set; }
        public string komentar { get; set; }
        
        public int id
        {
            get { return _id; }
            set
            {
                if (_id == value)
                    return;
                _id = value;
                OnPropertyChanged("id");
            }
        }
        public string osCislo
        {
            get { return _osCislo; }
            set
            {
                if (_osCislo == value)
                    return;
                _osCislo = value;
                OnPropertyChanged("osCislo");
            }
        }

        public string jmeno
        {
            get { return _jmeno; }
            set
            {
                if (_jmeno == value)
                    return;
                _jmeno = value;
                OnPropertyChanged("jmeno");
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public string prijmeni
        {
            get { return _prijmeni; }
            set
            {
                if (_prijmeni == value)
                    return;
                _prijmeni = value;
                OnPropertyChanged("prijmeni");
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public string stredisko
        {
            get { return _stredisko; }
            set
            {
                if (_stredisko == value)
                    return;
                _stredisko = value;
                OnPropertyChanged("stredisko");
            }
        }
        public DateTime datumNastupu
        {
            get { return _datumNastupu; }
            set
            {
                if (_datumNastupu == value)
                    return;
                _datumNastupu = value;
                OnPropertyChanged("datumNastupu");
            }
        }
        public string kategorie
        {
            get { return _kategorie; }
            set
            {
                if (_kategorie == value)
                    return;
                _kategorie = value;
                OnPropertyChanged("kategorie");
            }
        }
        public string smenovyModel
        {
            get { return _smenovyModel; }
            set
            {
                if (_smenovyModel == value)
                    return;
                _smenovyModel = value;
                OnPropertyChanged("smenovyModel");
            }
        }
        public string pozice
        {
            get { return _pozice; }
            set
            {
                if (_pozice == value)
                    return;
                _pozice = value;
                OnPropertyChanged("pozice");
            }
        }
        public string pohlavi
        {
            get { return _pohlavi; }
            set
            {
                if (_pohlavi == value)
                    return;
                _pohlavi = value;
                OnPropertyChanged("pohlavi");
            }
        }
        public string zobrazeneJmeno
        {
            get { return prijmeni + " " + jmeno; }
            set
            {
                OnPropertyChanged("zobrazeneJmeno");
            }
        }

        public bool ukoncen
        {
            get { return _ukoncen; }
            set
            {
                if (_ukoncen == value)
                    return;
                _ukoncen = value;
                OnPropertyChanged("ukoncen");
            }
        }
        public bool nabidnut
        {
            get { return _nabidnut; }
            set
            {
                if (_nabidnut == value)
                    return;
                _nabidnut = value;
                OnPropertyChanged("nabidnut");
            }
        }
        public OblastVyroby zobrazenaOblastVyroby
        {
            get { return _zobrazenaOblastVyroby; }
            set
            {
                if (_zobrazenaOblastVyroby == value)
                    return;
                _zobrazenaOblastVyroby = value;
                OnPropertyChanged("zobrazenaOblastVyroby");
            }
        }
        public string poznamka
        {
            get { return _poznamka; }
            set
            {
                if (_poznamka == value)
                    return;
                _poznamka = value;
                OnPropertyChanged("poznamka");
            }
        }
        public bool aktivni
        {
            get { return _aktivni; }
            set
            {
                if (_aktivni == value)
                    return;
                _aktivni = value;
                OnPropertyChanged("aktivni");
            }
        }
        public static ObservableCollection<Zamestnanec> SelectZam(int idUseku)
        {

            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT a.id, a.osCislo, a.jmeno, a.prijmeni, a.stredisko, a.datumNastupu, a.pohlavi, a.smenovyModel, a.pozice, a.kategorie, a.idUseku, a.idZapujcenehoUseku, COUNT(b.idZam), c.nazev FROM Zamestnanec AS a "
                + "LEFT JOIN Inzerat_Inzerat as b on (b.idZam = a.id and b.ukonceno = 0) "
                + "LEFT JOIN Usek as c on c.id = a.idZapujcenehoUseku "
                + "WHERE (a.idUseku = " + idUseku + " OR a.idZapujcenehoUseku = " + idUseku + ") AND aktivni = 1 "
                + "GROUP BY a.id, a.osCislo, a.jmeno, a.prijmeni, a.stredisko, a.datumNastupu, a.pohlavi, a.smenovyModel, a.pozice, a.kategorie, a.idUseku, a.idZapujcenehoUseku, b.idZam, c.nazev "
                + "ORDER BY prijmeni";



            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Zamestnanec zamestnanec;

                    while (reader.Read())
                    {
                        zamestnanec = new Zamestnanec();
                        zamestnanec.id = reader.GetInt32(0);
                        zamestnanec.osCislo = reader.GetValue(1).ToString();
                        zamestnanec.jmeno = reader.GetValue(2).ToString();
                        zamestnanec.prijmeni = reader.GetValue(3).ToString();
                        zamestnanec.stredisko = reader.GetValue(4).ToString();
                        zamestnanec.datumNastupu = reader.GetDateTime(5);
                        zamestnanec.pohlavi = reader.GetValue(6).ToString();
                        zamestnanec.smenovyModel = reader.GetValue(7).ToString();
                        zamestnanec.pozice = reader.GetValue(8).ToString();
                        zamestnanec.kategorie = reader.GetValue(9).ToString();
                        zamestnanec.idUseku = reader.GetInt32(10);
                        if (reader.GetValue(11) != DBNull.Value)
                        {
                            zamestnanec.idZapujcenehoUseku = reader.GetInt32(11);
                            zamestnanec.komentar = "Zapůjčen na úsek " + reader.GetValue(13).ToString();
                            //zamestnanec.idUseku = zamestnanec.idZapujcenehoUseku;
                        }
                        else
                        {
                            zamestnanec.idZapujcenehoUseku = 0;
                            if (reader.GetInt32(12) > 0)
                            {
                                zamestnanec.nabidnut = true;
                            }
                        }
                        zamestnanec.aktivni = true;
                        seznam.Add(zamestnanec);
                    }
                    
                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

       
        public static ObservableCollection<Zamestnanec> SelectZamUseku(int idUseku)
        {

            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT id, osCislo, jmeno, prijmeni, stredisko, datumNastupu, kategorie, idZapujcenehoUseku, smenovyModel, pozice, pohlavi, idUseku FROM Zamestnanec WHERE (idUseku = " + idUseku + ") AND aktivni = 1 ORDER BY prijmeni";


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Zamestnanec zamestnanec;

                    while (reader.Read())
                    {
                        zamestnanec = new Zamestnanec();
                        zamestnanec.id = reader.GetInt32(0);
                        zamestnanec.osCislo = reader.GetValue(1).ToString();
                        zamestnanec.jmeno = reader.GetValue(2).ToString();
                        zamestnanec.prijmeni = reader.GetValue(3).ToString();
                        zamestnanec.stredisko = reader.GetValue(4).ToString();
                        zamestnanec.datumNastupu = reader.GetDateTime(5);
                        zamestnanec.kategorie = reader.GetValue(6).ToString();
                        if (reader.GetValue(7) != DBNull.Value)
                        {
                            zamestnanec.idZapujcenehoUseku = reader.GetInt32(7);
                            //zamestnanec.idUseku = zamestnanec.idZapujcenehoUseku;
                        }
                        else zamestnanec.idZapujcenehoUseku = 0;
                        zamestnanec.smenovyModel = reader.GetValue(8).ToString();
                        zamestnanec.pozice = reader.GetValue(9).ToString();
                        zamestnanec.pohlavi = reader.GetValue(10).ToString();
                        zamestnanec.idUseku = reader.GetInt32(11);
                        zamestnanec.aktivni = true;

                        seznam.Add(zamestnanec);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static ObservableCollection<Zamestnanec> HledejZam(string sqlStr)
        {

            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Zamestnanec zamestnanec;

                    while (reader.Read())
                    {
                        zamestnanec = new Zamestnanec();
                        zamestnanec.id = reader.GetInt32(0);
                        zamestnanec.osCislo = reader.GetValue(1).ToString();
                        zamestnanec.jmeno = reader.GetValue(2).ToString();
                        zamestnanec.prijmeni = reader.GetValue(3).ToString();
                        zamestnanec.stredisko = reader.GetValue(4).ToString();
                        zamestnanec.smenovyModel = reader.GetValue(5).ToString();
                        zamestnanec.pozice = reader.GetValue(6).ToString();
                        zamestnanec.pohlavi = reader.GetValue(7).ToString();
                        zamestnanec.idUseku = reader.GetInt32(8);

                        seznam.Add(zamestnanec);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static bool CheckZalozeni(string osCislo, DateTime nastup)
        {
            bool vysledek = false;
            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT COUNT(id) FROM Zamestnanec WHERE osCislo = '" + osCislo + "' AND datumNastupu = '" + nastup.ToString("MM-dd-yyyy") + "'";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        if (reader.GetInt32(0) > 0)
                        {
                            vysledek = true;
                        }
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return vysledek;
        }
        public static int PocetZapujcenychZam(int idUseku)
        {
            int vysledek = 0;
            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT COUNT(id) FROM Zamestnanec WHERE idZapujcenehoUseku = " + idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        vysledek = (reader.GetInt32(0));
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return vysledek;
        }
        public static ObservableCollection<Zamestnanec> SelectFiltrovaniZamestnanci(string sqlStr)
        {

            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Zamestnanec zamestnanec;

                    while (reader.Read())
                    {
                        zamestnanec = new Zamestnanec();
                        zamestnanec.id = reader.GetInt32(0);
                        zamestnanec.osCislo = reader.GetValue(1).ToString();
                        zamestnanec.jmeno = reader.GetValue(2).ToString();
                        zamestnanec.prijmeni = reader.GetValue(3).ToString();
                        zamestnanec.stredisko = reader.GetValue(4).ToString();
                        zamestnanec.datumNastupu = reader.GetDateTime(5);
                        zamestnanec.pohlavi = reader.GetValue(6).ToString();
                        zamestnanec.smenovyModel = reader.GetValue(7).ToString();
                        zamestnanec.pozice = reader.GetValue(8).ToString();
                        zamestnanec.kategorie = reader.GetValue(9).ToString();
                        zamestnanec.idUseku = reader.GetInt32(10);
                        if (reader.GetValue(11) != DBNull.Value)
                        {
                            zamestnanec.idZapujcenehoUseku = reader.GetInt32(11);
                            zamestnanec.komentar = "Zapůjčen na úsek " + reader.GetValue(13).ToString();
                            //zamestnanec.idUseku = zamestnanec.idZapujcenehoUseku;
                        }
                        else
                        {
                            zamestnanec.idZapujcenehoUseku = 0;
                            if (reader.GetInt32(12) > 0)
                            {
                                zamestnanec.nabidnut = true;
                            }
                        }
                        zamestnanec.aktivni = true;
                        seznam.Add(zamestnanec);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static int VlozitZamestnance(Zamestnanec zamestnanec)
        {
            String sqlStr = "INSERT INTO Zamestnanec (osCislo, jmeno, prijmeni, stredisko, datumNastupu, ulozil, casUlozeni, idUseku, aktivni, kategorie, pohlavi, smenovyModel, pozice) "
                + "VALUES (@osCislo, @jmeno, @prijmeni, @stredisko, @datumNastupu, @ulozil, @casUlozeni, @idUseku, @aktivni, @kategorie, @pohlavi, @smenovyModel, @pozice) SELECT SCOPE_IDENTITY();";
            int idOsoby = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@osCislo", zamestnanec.osCislo);
                    cmd.Parameters.AddWithValue("@jmeno", zamestnanec.jmeno);
                    cmd.Parameters.AddWithValue("@prijmeni", zamestnanec.prijmeni);
                    cmd.Parameters.AddWithValue("@stredisko", zamestnanec.stredisko);
                    cmd.Parameters.AddWithValue("@datumNastupu", zamestnanec.datumNastupu);
                    cmd.Parameters.AddWithValue("@ulozil", "fip8jh");
                    cmd.Parameters.AddWithValue("@casUlozeni", DateTime.Now);
                    cmd.Parameters.AddWithValue("@idUseku", Properties.Settings.Default.idUseku);
                    cmd.Parameters.AddWithValue("@aktivni", true);
                    if (zamestnanec.kategorie != null) cmd.Parameters.AddWithValue("@kategorie", zamestnanec.kategorie);
                    else cmd.Parameters.AddWithValue("@kategorie", DBNull.Value);
                    cmd.Parameters.AddWithValue("@pohlavi", zamestnanec.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", zamestnanec.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", zamestnanec.pozice);

                    idOsoby = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                    zamestnanec.id = idOsoby;
                    VlozitZaskoleniZamestnance(zamestnanec);
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return idOsoby;
            }
        }
        public static void VlozitZaskoleniZamestnance(Zamestnanec zamestnanec)
        {
            String sqlStr = "INSERT INTO Zaskoleni (id, idZam, uzavreno, terminZaskoleni) "
                + "VALUES (@id, @idZam, @uzavreno, @terminZaskoleni) SELECT SCOPE_IDENTITY();";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@id", zamestnanec.id);
                    cmd.Parameters.AddWithValue("@idZam", zamestnanec.id);
                    cmd.Parameters.AddWithValue("@uzavreno", false);
                    cmd.Parameters.AddWithValue("@terminZaskoleni", zamestnanec.datumNastupu.AddDays(31));

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
        //public static void NabidnoutZamestnance(Zamestnanec zamestnanec)
        //{
        //    String sqlStr = "UPDATE Zamestnanec SET idNabidky=@idNabidky WHERE id = " + zamestnanec.id;

        //    using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
        //    {
        //        try
        //        {
        //            conn.Open();
        //            SqlCommand cmd = new SqlCommand(sqlStr, conn);

        //            if (zamestnanec.idNabidky != 0) cmd.Parameters.AddWithValue("@idNabidky", zamestnanec.idNabidky);
        //            else cmd.Parameters.AddWithValue("@idNabidky", DBNull.Value);


        //            cmd.ExecuteNonQuery();
        //            cmd.Dispose();

        //        }


        //        catch (Exception ex)
        //        {
        //            MessageBox.Show(ex.Message, "Problém s připojením");
        //        }
        //        finally
        //        {
        //            conn.Close();
        //        }
        //    }
        //}

        public static bool EditaceZamestnanece(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zamestnanec SET osCislo=@osCislo, jmeno=@jmeno, prijmeni=@prijmeni, stredisko=@stredisko, datumNastupu=@datumNastupu, ulozil=@ulozil, casUlozeni=@casUlozeni, " +
                "kategorie=@kategorie, pohlavi=@pohlavi, smenovyModel=@smenovyModel, pozice=@pozice WHERE id = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@osCislo", zamestnanec.osCislo);
                    cmd.Parameters.AddWithValue("@jmeno", zamestnanec.jmeno);
                    cmd.Parameters.AddWithValue("@prijmeni", zamestnanec.prijmeni);
                    cmd.Parameters.AddWithValue("@stredisko", zamestnanec.stredisko);
                    cmd.Parameters.AddWithValue("@datumNastupu", zamestnanec.datumNastupu);
                    cmd.Parameters.AddWithValue("@ulozil", "fip8jh");
                    cmd.Parameters.AddWithValue("@casUlozeni", DateTime.Now);
                    if (zamestnanec.kategorie != null) cmd.Parameters.AddWithValue("@kategorie", zamestnanec.kategorie);
                    else cmd.Parameters.AddWithValue("@kategorie", DBNull.Value);
                    cmd.Parameters.AddWithValue("@pohlavi", zamestnanec.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", zamestnanec.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", zamestnanec.pozice);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool UkoncitZamestnance(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zamestnanec SET aktivni=@aktivni, datumUkonceni=@datumUkonceni WHERE id = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@aktivni", false);
                    cmd.Parameters.AddWithValue("@datumUkonceni", DateTime.Now.Date);
                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool SmazatZamestnance(int idZamestnanece)
        {
            bool test = false;
            String sqlStr = "DELETE Zaskoleni WHERE idZam = " + idZamestnanece
                + " DELETE CheckListZam WHERE idZam = " + idZamestnanece
                + " DELETE CheckListStanice WHERE idZam = " + idZamestnanece
                + " DELETE Hodnoceni WHERE idZam = " + idZamestnanece
                + " DELETE Matice_Kompetence WHERE idZam = " + idZamestnanece
                + " DELETE Zamestnanec WHERE id = " + idZamestnanece;


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                    test = true;
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return test;
        }
    }
}
