﻿using KompetencniMatice.Commands;
using KompetencniMatice.DialogWindows;
using KompetencniMatice.Helpers;
using KompetencniMatice.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace KompetencniMatice.ViewModels.AdministraceVM
{
    class AdministraceControlViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZatmavit Zatmavit = delegate { };

        private ObservableCollection<Pracoviste> seznamProSmazaniPracovist;

        private ObservableCollection<OblastVyroby> _oblastiVyroby;
        private OblastVyroby _novaOblast;
        private OblastVyroby _vybranaOblast;

        private bool _zobrazeniNoveOblasti = false;
        private bool _zobrazeniInfa;
        private string _infoPopis;
        private bool _isBusy;
        private bool _ztmavit;

        private ObservableCollection<Opravneni> _seznamUzivatelu;
        private Opravneni _uzivatel;
        private bool _zobrazenyZadaniOsob = false;
        private ObservableCollection<Opravneni> _seznamUzProVybrani;
        private Opravneni _uzivatelProVybrani;
        private bool _hledam;
        private bool _chyba;
        private string _chybaPopis;
        private string _filtrJmeno;
        private bool _editaceUzivatele = false;

        private List<TypVyroby> _typyVyrobyProCB;
        private List<string> _barvyProCB;
        public RelayCommand PridatOblastCommand { get; private set; }
        public RelayCommand EditovatOblastCommand { get; private set; }
        public RelayCommand UlozitOblastCommand { get; private set; }
        public RelayCommand SmazatOblastCommand { get; private set; }
        public RelayCommand ZavritOblastCommand { get; private set; }
        public RelayCommand<Pracoviste> OdebratRadekPracovisteCommand { get; private set; }
        public RelayCommand PridatRadekPracovisteCommand { get; private set; }
        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public RelayCommand ZavriAdministraciCommand { get; private set; }

        public RelayCommand VlozitNovehoUzivateleCommand { get; private set; }
        public RelayCommand UlozitUzivateleCommand { get; private set; }
        public RelayCommand ZobrazitZadaniUzivateleCommand { get; private set; }
        public RelayCommand SchovatZadaniUzivateleCommand { get; private set; }
        public RelayCommand ZobrazitVybraniZamCommand { get; private set; }
        public RelayCommand<Window> ZavritVybraniZamCommand { get; private set; }
        public RelayCommand<string> HledejZamProVybraniCommand { get; private set; }
        public RelayCommand ZobrazitPridaniStrediskaCommand { get; private set; }
        public RelayCommand SmazatUzivateleCommand { get; private set; }
        public RelayCommand<Window> ZavritOknoCommand { get; private set; }
        public RelayCommand PouzitFiltrCommand { get; private set; }
        public RelayCommand ZrusitFiltrCommand { get; private set; }

        public static event EventHandlerZpet Zpet = delegate { };

        public string Name
        {
            get
            {
                return "Administrace";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Ztmavit
        {
            get { return _ztmavit; }
            set
            {
                if (_ztmavit != value)
                {
                    _ztmavit = value;
                    OnPropertyChanged("Ztmavit");
                }
            }
        }
       
        public ObservableCollection<OblastVyroby> OblastiVyroby
        {
            get { return _oblastiVyroby; }
            set
            {
                if (_oblastiVyroby != value)
                {
                    _oblastiVyroby = value;
                    OnPropertyChanged("OblastiVyroby");
                }
            }
        }
        public OblastVyroby NovaOblast
        {
            get { return _novaOblast; }
            set
            {
                if (_novaOblast != value)
                {
                    _novaOblast = value;
                    OnPropertyChanged("NovaOblast");
                }
            }
        }
        public OblastVyroby VybranaOblast
        {
            get { return _vybranaOblast; }
            set
            {
                if (_vybranaOblast != value)
                {
                    _vybranaOblast = value;
                    OnPropertyChanged("VybranaOblast");
                }
            }
        }
        public bool ZobrazeniNoveOblasti
        {
            get { return _zobrazeniNoveOblasti; }
            set
            {
                if (_zobrazeniNoveOblasti != value)
                {
                    _zobrazeniNoveOblasti = value;
                    OnPropertyChanged("ZobrazeniNoveOblasti");
                }
            }
        }
        public bool ZobrazeniInfa
        {
            get { return _zobrazeniInfa; }
            set
            {
                if (_zobrazeniInfa != value)
                {
                    _zobrazeniInfa = value;
                    OnPropertyChanged("ZobrazeniInfa");
                }
            }
        }
        public string InfoPopis
        {
            get { return _infoPopis; }
            set
            {
                if (_infoPopis != value)
                {
                    _infoPopis = value;
                    OnPropertyChanged("InfoPopis");
                }
            }
        }
        public bool ZobrazenyZadaniOsob
        {
            get { return _zobrazenyZadaniOsob; }
            set
            {
                if (_zobrazenyZadaniOsob != value)
                {
                    _zobrazenyZadaniOsob = value;
                    OnPropertyChanged("ZobrazenyZadaniOsob");
                }
            }
        }
        public ObservableCollection<Opravneni> SeznamUzivatelu
        {
            get { return _seznamUzivatelu; }
            set
            {
                if (_seznamUzivatelu != value)
                {
                    _seznamUzivatelu = value;
                    OnPropertyChanged("SeznamUzivatelu");
                }
            }
        }
        public Opravneni Uzivatel
        {
            get { return _uzivatel; }
            set
            {
                if (_uzivatel != value)
                {
                    _uzivatel = value;
                    OnPropertyChanged("Uzivatel");
                }
            }
        }
        public Opravneni UzivatelProVybrani
        {
            get { return _uzivatelProVybrani; }
            set
            {
                if (_uzivatelProVybrani != value)
                {
                    _uzivatelProVybrani = value;
                    OnPropertyChanged("UzivatelProVybrani");
                }
            }
        }
        public ObservableCollection<Opravneni> SeznamUzProVybrani
        {
            get { return _seznamUzProVybrani; }
            set
            {
                if (_seznamUzProVybrani != value)
                {
                    _seznamUzProVybrani = value;
                    OnPropertyChanged("SeznamUzProVybrani");
                }
            }
        }
        public bool Hledam
        {
            get { return _hledam; }
            set
            {
                if (_hledam != value)
                {
                    _hledam = value;
                    OnPropertyChanged("Hledam");
                }
            }
        }
        public bool Chyba
        {
            get { return _chyba; }
            set
            {
                if (_chyba != value)
                {
                    _chyba = value;
                    OnPropertyChanged("Chyba");
                }
            }
        }
        public string ChybaPopis
        {
            get { return _chybaPopis; }
            set
            {
                if (_chybaPopis != value)
                {
                    _chybaPopis = value;
                    OnPropertyChanged("ChybaPopis");
                }
            }
        }
        public string FiltrJmeno
        {
            get { return _filtrJmeno; }
            set
            {
                if (_filtrJmeno != value)
                {
                    _filtrJmeno = value;
                    OnPropertyChanged("FiltrJmeno");
                }
            }
        }
        public bool EditaceUzivatele
        {
            get { return _editaceUzivatele; }
            set
            {
                if (_editaceUzivatele != value)
                {
                    _editaceUzivatele = value;
                    OnPropertyChanged("EditaceUzivatele");
                }
            }
        }
        public List<TypVyroby> TypyVyrobyProCB
        {
            get { return _typyVyrobyProCB; }
            set
            {
                if (_typyVyrobyProCB != value)
                {
                    _typyVyrobyProCB = value;
                    OnPropertyChanged("TypyVyrobyProCB");
                }
            }
        }
        public List<string> BarvyProCB
        {
            get { return _barvyProCB; }
            set
            {
                if (_barvyProCB != value)
                {
                    _barvyProCB = value;
                    OnPropertyChanged("BarvyProCB");
                }
            }
        }
        public AdministraceControlViewModel()
        {
            Task.Run(() =>
            {
                IsBusy = true;
                NacteniDatOblasti();
                SeznamUzivatelu = Opravneni.SelectUzivatele();
                IsBusy = false;
            });

            OdebratRadekPracovisteCommand = new RelayCommand<Pracoviste>(param => this.OdebratRadekPracoviste(param));
            PridatRadekPracovisteCommand = new RelayCommand(param => this.PridatRadekStanice());
            PridatOblastCommand = new RelayCommand(param => this.PridatOblastVyroby());
            UlozitOblastCommand = new RelayCommand(param => this.UlozitOblastVyroby());
            SmazatOblastCommand = new RelayCommand(param => this.SmazatOblastVyroby());
            ZavritOblastCommand = new RelayCommand(param => this.ZavritOblastVyroby());
            EditovatOblastCommand = new RelayCommand(param => this.EditovatOblastVyroby());
            UlozitOblastCommand = new RelayCommand(param => this.UlozitOblastVyroby());
            ZavriAdministraciCommand = new RelayCommand(param => this.ZavriAdministraci());


            VlozitNovehoUzivateleCommand = new RelayCommand(param => this.VlozitNovehoUzivatele());
            UlozitUzivateleCommand = new RelayCommand(param => this.UlozitUzivatele());
            ZobrazitZadaniUzivateleCommand = new RelayCommand(param => this.ZobrazitZadaniUzivatele());
            SchovatZadaniUzivateleCommand = new RelayCommand(param => this.SchovatZadaniUzivatele());
            ZobrazitVybraniZamCommand = new RelayCommand(param => this.ZobrazitVybraniZam());
            ZavritVybraniZamCommand = new RelayCommand<Window>(param => this.ZavritVybraniZam(param));
            HledejZamProVybraniCommand = new RelayCommand<string>(param => this.HledejZamProVybrani(param));
            SmazatUzivateleCommand = new RelayCommand(param => this.SmazatUzivatele());
            ZavritOknoCommand = new RelayCommand<Window>(param => this.ZavritOkno(param));
            PouzitFiltrCommand = new RelayCommand(param => this.PouzitFiltr());
            ZrusitFiltrCommand = new RelayCommand(param => this.ZrusitFiltr());
        }
        private void NacteniDatOblasti()
        {
            OblastiVyroby = OblastVyroby.SelectOblastiVyrobyUseku();
            ObservableCollection<Pracoviste> seznamPracovistProNacteni = Pracoviste.SelectPracovisteOblasti(OblastiVyroby);
            foreach (var item in OblastiVyroby)
            {
                item.seznamPracovist = new ObservableCollection<Pracoviste>(seznamPracovistProNacteni.Where(d => d.idOblasti == item.id).Select(d => d).ToList().OrderBy(d => d.id));
            }
        }
        private void NacteniComboboxu()
        {
            TypyVyrobyProCB = TypVyroby.SelectTypyVyroby();
            BarvyProCB = new List<string> { "#b90276", "#50237f",  "#005691", "#008ecf", "#00a8b0", "#78be20", " #006249", " #525f6b", "#fcaf17" };

        }
        private void PridatOblastVyroby()
        {
            if (TypyVyrobyProCB == null) NacteniComboboxu();
            ZobrazeniNoveOblasti = true;
            NovaOblast = new OblastVyroby();
            NovaOblast.barva = "#525f6b";
            NovaOblast.idTypu = 1;
            NovaOblast.seznamPracovist = new ObservableCollection<Pracoviste>();
            NovaOblast.seznamPracovist.Add(new Pracoviste());
        }
        private void EditovatOblastVyroby()
        {
            if (TypyVyrobyProCB == null) NacteniComboboxu();
            ZobrazeniNoveOblasti = true;
            NovaOblast = new OblastVyroby();
            NovaOblast.id =VybranaOblast.id;
            NovaOblast.nazev = VybranaOblast.nazev;
            NovaOblast.idUseku = VybranaOblast.idUseku;
            NovaOblast.idTypu = VybranaOblast.idTypu;
            NovaOblast.barva = VybranaOblast.barva;
            NovaOblast.seznamPracovist = new ObservableCollection<Pracoviste>(VybranaOblast.seznamPracovist);
        }
        private void OdebratRadekPracoviste(Pracoviste radek)
        {
            if (radek.id != 0)
            {
                if (seznamProSmazaniPracovist == null) seznamProSmazaniPracovist = new ObservableCollection<Pracoviste>();
                seznamProSmazaniPracovist.Add(radek);
            }
            NovaOblast.seznamPracovist.Remove(radek);
        }
        private void PridatRadekStanice()
        {
            NovaOblast.seznamPracovist.Add(new Pracoviste());
        }
        private void UlozitOblastVyroby()
        {
            Task.Run(() =>
            {
                bool uspesny = true;
                IsBusy = true;
                uspesny = KontrolaPracovist();

                if (uspesny)
                {
                    NovaOblast = OblastVyroby.VlozitOblast(NovaOblast);
                    if (NovaOblast.id != 0)
                    {
                        NovaOblast.seznamPracovist = Pracoviste.VlozitPracoviste(NovaOblast.seznamPracovist, NovaOblast.id);
                        if (seznamProSmazaniPracovist != null)
                        {
                            uspesny = Pracoviste.SmazatPracoviste(seznamProSmazaniPracovist);
                            seznamProSmazaniPracovist = null;
                        }

                    }

                    if (uspesny)
                    {

                        Task.Run(() =>
                        {
                            Zatmavit(true);
                            NacteniDatOblasti();
                            ZobrazeniInfa = true;
                            InfoPopis = "Data byla úspěšně uložena.";
                            System.Threading.Thread.Sleep(2000);
                            ZobrazeniInfa = false;
                            Zatmavit(false);
                            ZobrazeniNoveOblasti = false;
                        });
                    }
                }
                IsBusy = false;
            });
        }
        private void SmazatOblastVyroby()
        {
            if (OblastVyroby.SmazatOblast(VybranaOblast.id))
            {
                Task.Run(() =>
                {
                    Zatmavit(true);
                    NacteniDatOblasti();
                    ZobrazeniInfa = true;
                    InfoPopis = "Oblast výroby byla úspěšně smazána.";
                    System.Threading.Thread.Sleep(2000);
                    ZobrazeniInfa = false;
                    Zatmavit(false);
                    ZobrazeniNoveOblasti = false;
                });
            }

        }
        private void ZavritOblastVyroby()
        {
            ZobrazeniNoveOblasti = false;
        }
        
        private bool KontrolaPracovist()
        {
            int count = NovaOblast.seznamPracovist.Count;
            if (String.IsNullOrEmpty(NovaOblast.nazev))
            {
                return false;
            }
            for (int i = 0; i < count; i++)
            {
                if (NovaOblast.seznamPracovist[i].id == 0 && String.IsNullOrEmpty(NovaOblast.seznamPracovist[i].nazev))
                {
                    App.Current.Dispatcher.Invoke((Action)delegate
                    {
                        NovaOblast.seznamPracovist.Remove(NovaOblast.seznamPracovist[i]);
                    });
                }
            }
            return true;

        }
        public void ZavriAdministraci()
        {
            Zpet();
        }

        public void VlozitNovehoUzivatele()
        {
            Uzivatel = new Opravneni();
            Uzivatel.role = 3;
            ZobrazenyZadaniOsob = true;
        }

        private void ZobrazitVybraniZam()
        {
            UzivatelProVybrani = null;
            SeznamUzProVybrani = null;
            Zatmavit(true);
            Ztmavit = true;
            VybratZam vybraniZam = new VybratZam();
            vybraniZam.DataContext = this;
            vybraniZam.Owner = Application.Current.MainWindow;
            vybraniZam.ShowDialog();
        }
        private void ZavritVybraniZam(Window okno)
        {
            Uzivatel.jmeno = UzivatelProVybrani.jmeno;
            Uzivatel.prijmeni = UzivatelProVybrani.prijmeni;
            Uzivatel.oddeleni = UzivatelProVybrani.oddeleni;
            Uzivatel.email = UzivatelProVybrani.email;
            Uzivatel.nt = UzivatelProVybrani.nt.ToLower();


            Zatmavit(false);
            Ztmavit = false;
            if (okno != null)
                okno.Close();
        }
        private void HledejZamProVybrani(string jmeno)
        {
            Task.Run(() =>
            {
                Hledam = true;
                SeznamUzProVybrani = ActiveDirectory.VyhledejUzivatele(jmeno);
                Hledam = false;
            });
        }
        private void ZobrazitZadaniUzivatele()
        {
            EditaceUzivatele = true;
            ZobrazenyZadaniOsob = true;
        }
        private void SchovatZadaniUzivatele()
        {
            if (EditaceUzivatele) EditaceUzivatele = false;

            ZobrazenyZadaniOsob = false;
            Uzivatel = null;
        }
        public void UlozitUzivatele()
        {
            if (KontrolaUzivatele())
            {
                if (EditaceUzivatele)
                {
                    if (!Opravneni.EditaceUzivatele(Uzivatel))
                    {
                        Task.Run(() =>
                        {
                            Chyba = true;
                            ChybaPopis = "Nastala chyba při ukládání";
                            System.Threading.Thread.Sleep(2000);
                            Chyba = false;
                        });
                    }
                    else
                    {
                        SchovatZadaniUzivatele();
                    }
                }
                else
                {
                    if (!Opravneni.VlozitUzivatele(Uzivatel))
                    {
                        Task.Run(() =>
                        {
                            Chyba = true;
                            ChybaPopis = "Nastala chyba při ukládání";
                            System.Threading.Thread.Sleep(2000);
                            Chyba = false;
                        });
                    }
                    else
                    {
                        if (SeznamUzivatelu.Where(d => d.nt == Uzivatel.nt).ToList().Count == 0) SeznamUzivatelu.Add(Uzivatel);
                        else SeznamUzivatelu.Where(d => d.nt == Uzivatel.nt).Select(d => d).FirstOrDefault().role = Uzivatel.role;
                        SchovatZadaniUzivatele();
                    }
                }
            }
            else
            {
                Task.Run(() =>
                {
                    Chyba = true;
                    ChybaPopis = "Vyberte uživatele";
                    System.Threading.Thread.Sleep(3000);
                    Chyba = false;
                });
            }

        }

        private void SmazatUzivatele()
        {
            if (Opravneni.SmazatUzivatele(Uzivatel.nt)) SeznamUzivatelu.Remove(Uzivatel);
        }
        private bool KontrolaUzivatele()
        {
            if (String.IsNullOrEmpty(Uzivatel.jmeno)) return false;
            if (String.IsNullOrEmpty(Uzivatel.prijmeni)) return false;
            if (String.IsNullOrEmpty(Uzivatel.email)) return false;
            if (String.IsNullOrEmpty(Uzivatel.nt)) return false;
            return true;
        }
        private void PouzitFiltr()
        {
            string sqlStr = "SELECT * FROM Opravneni WHERE nt IS NOT NULL AND idUseku = " + Properties.Settings.Default.idUseku;

            if (!string.IsNullOrWhiteSpace(FiltrJmeno)) sqlStr += " AND CONCAT(prijmeni,' ', jmeno) LIKE CONCAT('%', replace('" + FiltrJmeno + "', ' ', '%'), '%')";

            sqlStr += " ORDER BY prijmeni";
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamUzivatelu = Opravneni.SelectFiltrovaniUzivatele(sqlStr);

                IsBusy = false;
            });
        }
        private void ZrusitFiltr()
        {
            FiltrJmeno = "";
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamUzivatelu = Opravneni.SelectUzivatele();
                IsBusy = false;
            });
        }
        private void ZavritOkno(Window okno)
        {
            Zatmavit(false);
            Ztmavit = false;
            if (okno != null)
                okno.Close();
        }
    }
}
