﻿using KompetencniMatice.Commands;
using KompetencniMatice.DialogWindows;
using KompetencniMatice.Helpers;
using KompetencniMatice.Models;
using KompetencniMatice.ViewModels.AdministraceVM;
using KompetencniMatice.ViewModels.ReportVM;
using KompetencniMatice.ViewModels.ZamVM;
using KompetencniMatice.Views.ZamView;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Deployment.Application;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace KompetencniMatice.ViewModels
{
    public delegate void EventHandlerZpet();
    public delegate void EventHandlerZpetSNovymZam(Zamestnanec zam);
    public delegate void EventHandlerZatmavit(bool status);
    public class MainWindowViewModel : ViewModelBase
    {
        public class Filtr : ViewModelBase
        {
            private string _osCislo;
            private string _jmeno;
            private string _stredisko;
            private string _kategorie;

            public string osCislo
            {
                get { return _osCislo; }
                set
                {
                    if (_osCislo == value)
                        return;
                    _osCislo = value;
                    OnPropertyChanged("osCislo");
                }
            }

            public string jmeno
            {
                get { return _jmeno; }
                set
                {
                    if (_jmeno == value)
                        return;
                    _jmeno = value;
                    OnPropertyChanged("jmeno");
                }
            }
            public string stredisko
            {
                get { return _stredisko; }
                set
                {
                    if (_stredisko == value)
                        return;
                    _stredisko = value;
                    OnPropertyChanged("stredisko");
                }
            }
            public string kategorie
            {
                get { return _kategorie; }
                set
                {
                    if (_kategorie == value)
                        return;
                    _kategorie = value;
                    OnPropertyChanged("kategorie");
                }
            }
        }

        private ObservableCollection<Opravneni> opravneni;
        private ObservableCollection<Zamestnanec> _seznamZam;
        private Zamestnanec _vybranyZam;
        private bool _zobrazenyDetail = false;
        private bool _zobrazitContent = false;
        private bool _zobrazeniZadaniZam = false;
        private bool _zobrazenaAdministrace = false;
        private bool _zobrazitUvodniVyber = false;
        private bool _isBusy = false;
        private bool _zatmavit = false;
        private Filtr _dataFiltr;
        private bool _zadnaData = false;
        private string _verze;
        private bool _administrator = false;
        private ObservableCollection<Usek> _seznamUseku;
        private ObservableCollection<OblastVyroby> _seznamOblastiProCB;
        private OblastVyroby _vybranaOblastProZobrazeni;
        private ObservableCollection<Trida> _seznamTridCB;

        private DetailViewModel _detailVM;
        private Opravneni _opravneniUzivatele;
        private Usek _vybranyUsek;

        private ICommand _changePageCommand;
        private IPageViewModel _currentPageViewModel;
        private List<IPageViewModel> _pageViewModels;
        public RelayCommand AdministraceViewCommand { get; private set; }
        public RelayCommand<string> ZadaniZamCommand { get; private set; }
        public RelayCommand DetailZamCommand { get; private set; }
        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public RelayCommand UkoncitZamCommand { get; private set; }
        public RelayCommand SmazatZamCommand { get; private set; }
        public RelayCommand PouzitFiltrCommand { get; private set; }
        public RelayCommand ZrusitFiltrCommand { get; private set; }
        public RelayCommand<string> ZmenitZobrazeniDetailuCommand { get; private set; }
        public RelayCommand ExportDoExcelCommand { get; private set; }
        public RelayCommand TiskCommand { get; private set; }
        public RelayCommand<Usek> VybratUsekCommand { get; private set; }
        public RelayCommand ZpetNaUvodniVyberCommand { get; private set; }
        public RelayCommand ZadaniReportuCommand { get; private set; }

        public RelayCommand NabidnoutZamCommand { get; private set; }
        public List<IPageViewModel> PageViewModels
        {
            get
            {
                if (_pageViewModels == null)
                    _pageViewModels = new List<IPageViewModel>();

                return _pageViewModels;
            }
        }
        public IPageViewModel CurrentPageViewModel
        {
            get
            {
                return _currentPageViewModel;
            }
            set
            {
                if (_currentPageViewModel != value)
                {
                    _currentPageViewModel = value;
                    OnPropertyChanged("CurrentPageViewModel");
                }
            }
        }
        public ICommand ChangePageCommand
        {
            get
            {
                if (_changePageCommand == null)
                {
                    _changePageCommand = new RelayCommand(
                        p => ChangeViewModel((IPageViewModel)p),
                        p => p is string);
                }

                return _changePageCommand;
            }
        }
        public string Verze
        {
            get { return _verze; }
            set
            {
                if (_verze != value)
                {
                    _verze = value;
                    OnPropertyChanged("Verze");
                }
            }
        }
        public bool Administrator
        {
            get { return _administrator; }
            set
            {
                if (_administrator != value)
                {
                    _administrator = value;
                    OnPropertyChanged("Administrator");
                }
            }
        }
        public bool ZobrazenyDetail
        {
            get { return _zobrazenyDetail; }
            set
            {
                if (_zobrazenyDetail != value)
                {
                    _zobrazenyDetail = value;
                    OnPropertyChanged("ZobrazenyDetail");
                }
            }
        }
        public bool ZobrazitContent
        {
            get { return _zobrazitContent; }
            set
            {
                if (_zobrazitContent != value)
                {
                    _zobrazitContent = value;
                    OnPropertyChanged("ZobrazitContent");
                }
            }
        }
        public bool ZobrazeniZadaniZam
        {
            get { return _zobrazeniZadaniZam; }
            set
            {
                if (_zobrazeniZadaniZam != value)
                {
                    _zobrazeniZadaniZam = value;
                    OnPropertyChanged("ZobrazeniZadaniZam");
                }
            }
        }
        public bool ZobrazenaAdministrace
        {
            get { return _zobrazenaAdministrace; }
            set
            {
                if (_zobrazenaAdministrace != value)
                {
                    _zobrazenaAdministrace = value;
                    OnPropertyChanged("ZobrazenaAdministrace");
                }
            }
        }
        
        public bool ZobrazitUvodniVyber
        {
            get { return _zobrazitUvodniVyber; }
            set
            {
                if (_zobrazitUvodniVyber != value)
                {
                    _zobrazitUvodniVyber = value;
                    OnPropertyChanged("ZobrazitUvodniVyber");
                }
            }
        }
        public ObservableCollection<Zamestnanec> SeznamZam
        {
            get { return _seznamZam; }
            set
            {
                if (_seznamZam != value)
                {
                    _seznamZam = value;
                    OnPropertyChanged("SeznamZam");
                }
            }
        }
        public Zamestnanec VybranyZam
        {
            get { return _vybranyZam; }
            set
            {
                if (_vybranyZam != value)
                {
                    _vybranyZam = value;
                    if (DetailVM != null) DetailVM.Zam = VybranyZam;
                    else DetailVM = new DetailViewModel(VybranyZam);
                    //DetailVM.Zam = VybranyZam;

                    OnPropertyChanged("VybranyZam");
                }
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Zatmavit
        {
            get { return _zatmavit; }
            set
            {
                if (_zatmavit != value)
                {
                    _zatmavit = value;
                    OnPropertyChanged("Zatmavit");
                }
            }
        }
        public Filtr DataFiltr
        {
            get { return _dataFiltr; }
            set
            {
                if (_dataFiltr != value)
                {
                    _dataFiltr = value;
                    OnPropertyChanged("DataFiltr");
                }
            }
        }
        
        public bool ZadnaData
        {
            get { return _zadnaData; }
            set
            {
                if (_zadnaData == value)
                    return;
                _zadnaData = value;
                OnPropertyChanged("ZadnaData");
            }
        }
        public ObservableCollection<Usek> SeznamUseku
        {
            get { return _seznamUseku; }
            set
            {
                if (_seznamUseku == value)
                    return;
                _seznamUseku = value;
                OnPropertyChanged("SeznamUseku");
            }
        }
        public DetailViewModel DetailVM
        {
            get { return _detailVM; }
            set
            {
                if (_detailVM == value)
                    return;
                _detailVM = value;
                OnPropertyChanged("DetailVM");
            }
        }

        public Opravneni OpravneniUzivatele
        {
            get { return _opravneniUzivatele; }
            set
            {
                if (_opravneniUzivatele == value)
                    return;
                _opravneniUzivatele = value;
                OnPropertyChanged("OpravneniUzivatele");
            }
        }
        public Usek VybranyUsek
        {
            get { return _vybranyUsek; }
            set
            {
                if (_vybranyUsek == value)
                    return;
                _vybranyUsek = value;
                OnPropertyChanged("VybranyUsek");
            }
        }
        public ObservableCollection<OblastVyroby> SeznamOblastiProCB
        {
            get { return _seznamOblastiProCB; }
            set
            {
                if (_seznamOblastiProCB == value)
                    return;
                _seznamOblastiProCB = value;
                OnPropertyChanged("SeznamOblastiProCB");
            }
        }
        public OblastVyroby VybranaOblastProZobrazeni
        {
            get { return _vybranaOblastProZobrazeni; }
            set
            {
                if (_vybranaOblastProZobrazeni == value)
                    return;
                _vybranaOblastProZobrazeni = value;
                NacistPracovisteOblasti();
                OnPropertyChanged("VybranaOblastProZobrazeni");
            }
        }
        public ObservableCollection<Trida> SeznamTridCB
        {
            get { return _seznamTridCB; }
            set
            {
                if (_seznamTridCB != value)
                {
                    _seznamTridCB = value;
                    OnPropertyChanged("SeznamTridCB");
                }
            }
        }
        public MainWindowViewModel()
        {

            AdministraceControlViewModel.Zatmavit += ZatmavObrazovku;
            AdministraceControlViewModel.Zpet += ZpetNaUvod;
            ZadaniZamViewModel.Zpet += ZpetNaUvod;
            ZadaniZamViewModel.ZpetSeZam += ZpetNaUvodSeZam;
            DetailZamViewModel.Zpet += ZpetNaUvod;
            PrehledViewModel.Zpet += ZpetNaUvod;
            AdministraceViewCommand = new RelayCommand(param => this.AdministraceView());
            DetailZamCommand = new RelayCommand(param => this.DetailZam());
            ZadaniZamCommand = new RelayCommand<string>(param => this.ZadaniZam(param));
            UkoncitZamCommand = new RelayCommand(param => this.UkoncitZam());
            SmazatZamCommand = new RelayCommand(param => this.SmazatZam());
            NabidnoutZamCommand = new RelayCommand(param => this.NabidnoutZam());
            ZmenitZobrazeniDetailuCommand = new RelayCommand<string>(param => this.ZmenitZobrazeniDetailu(param));
            ExportDoExcelCommand = new RelayCommand(param => this.ExportDoExcel());
            ZpetNaUvodCommand = new RelayCommand(param => this.ZpetNaUvod());
            ZpetNaUvodniVyberCommand = new RelayCommand(param => this.ZpetNaUvodniVyber());
            VybratUsekCommand = new RelayCommand<Usek>(param => this.VybratUsek(param));
            ZadaniReportuCommand = new RelayCommand(param => this.ZadaniReportu());
            PouzitFiltrCommand = new RelayCommand(param => this.PouzitFiltr());
            ZrusitFiltrCommand = new RelayCommand(param => this.ZrusitFiltr());
        }
        public void NactiData()
        {
            ZobrazitContent = false;
            ZobrazeniZadaniZam = false;

            if (Properties.Settings.Default.idUseku == 0)
            {
                Task.Run(() =>
                {
                    ZobrazitUvodniVyber = true;
                    opravneni = Opravneni.SelectUzivatelePodleNT();
                    SeznamUseku = Usek.SelectUseky();
                    foreach (var item in SeznamUseku)
                    {
                        if (opravneni.Where(d => d.idUseku == item.id).ToList().Count > 0 || "fip8jh" == "fip8jh") item.povoleno = true;
                    }
                });
            }
            else
            {
                Task.Run(() =>
                {
                    IsBusy = true;
                    ZobrazitUvodniVyber = false;
                    
                    VybranyUsek = Usek.SelectUsekPodleID(Properties.Settings.Default.idUseku);
                    Properties.Settings.Default.Save();

                    OpravneniUzivatele = Opravneni.SelectOpravneniPodleUseku();
                    ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
                    if (OpravneniUzivatele.role == 1) Administrator = true;
                    else Administrator = false;

                    SeznamTridCB = Trida.SelectTridyProCB();
                    SeznamZam = Zamestnanec.SelectZam(VybranyUsek.id);
                    SeznamOblastiProCB = OblastVyroby.SelectOblastiVyrobyUseku();
                    ObservableCollection<Pracoviste> seznamPrac = Pracoviste.SelectPracovisteOblasti(SeznamOblastiProCB);
                    foreach (var item in SeznamOblastiProCB)
                    {
                        item.seznamPracovist = new ObservableCollection<Pracoviste>(seznamPrac.Where(d => d.idOblasti == item.id).ToList());
                    }
                    DataFiltr = new Filtr();
                    //PrihlasenyUzivatel = ActiveDirectory.VyhledejUzivatelePodleNT(Environment.UserName);
                    IsBusy = false;
                });
            }
           
        }
        private string GetVerze()
        {
            try
            {
                Version ver = ApplicationDeployment.CurrentDeployment.CurrentVersion;
                return string.Format("{0}.{1}.{2}.{3}", ver.Major, ver.Minor, ver.Build, ver.Revision);

            }
            catch (InvalidDeploymentException)
            {
                return "not installed";
            }
        }
        private void ChangeViewModel(IPageViewModel viewModel)
        {
            if (!PageViewModels.Contains(viewModel))
                PageViewModels.Add(viewModel);

            CurrentPageViewModel = PageViewModels
                .FirstOrDefault(vm => vm == viewModel);
        }
        private void DetailZam()
        {
            ChangeViewModel(new DetailZamViewModel(VybranyZam));
            ZobrazitContent = true;
            ZobrazeniZadaniZam = false;   
        }
        private void ZadaniZam(string editace)
        {
            switch (editace)
            {
                case "novy":
                    ChangeViewModel(new ZadaniZamViewModel());

                    break;
                case "editace":
                    ChangeViewModel(new ZadaniZamViewModel(VybranyZam));
                    break;
                default:
                    break;
            }

            ZobrazeniZadaniZam = true;
            ZobrazenyDetail = false;
        }
        private void ZadaniReportu()
        {
            ChangeViewModel(new PrehledViewModel());
            ZobrazeniZadaniZam = true;
            ZobrazenyDetail = false;
        }
        private void ZpetNaUvod()
        {
            ZobrazeniZadaniZam = false;
            ZobrazitContent = false;
            Zatmavit = false;
            ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
            if (VybranyZam != null)
            {
                DetailVM = new DetailViewModel(VybranyZam);
            }
        }
        private void ZpetNaUvodSeZam(Zamestnanec zam)
        {
            App.Current.Dispatcher.Invoke((Action)delegate
            {
                SeznamZam.Insert(0,zam);
            });

            ZobrazeniZadaniZam = false;
            ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
        }
        private void UkoncitZam()
        {
            Zatmavit = true;
            eTraining.Helpers.UkonceniZamWindow ukonceni = new eTraining.Helpers.UkonceniZamWindow();
            ukonceni.DataContext = this;
            ukonceni.Owner = System.Windows.Application.Current.MainWindow;
            ukonceni.ShowDialog();
            if (ukonceni.ukoncit != 0)
            {
                switch (ukonceni.ukoncit)
                {
                    case 1:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Ukončen z důvodu převodu na jiné KST; ";
                        break;
                    case 2:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Ukončen na žádost zaměstnavatele; ";
                        break;
                    case 3:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Ukončen na žádost zaměstnance; ";
                        break;
                    default:
                        break;
                }
                
                
                VybranyZam.aktivni = false;
                Zamestnanec.UkoncitZamestnance(VybranyZam);
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    SeznamZam.Remove(VybranyZam);
                });
            }
            Zatmavit = false;
        }
        private void SmazatZam()
        {
            Zatmavit = true;
            WarningWindow warninng = new WarningWindow();
            warninng.Owner = System.Windows.Application.Current.MainWindow;
            warninng.TextVarovani = "Opravdu chcete smazat tohoto zaměstnance?" + Environment.NewLine + "Data budou ztracena!!!";
            warninng.ShowDialog();
            if (warninng.OK)
            {
                Zamestnanec.SmazatZamestnance(VybranyZam.id);
                SeznamZam.Remove(VybranyZam);
            }
            Zatmavit = false;
        }
        private void NabidnoutZam()
        {
            Zatmavit = true;
            NabidkaZam nabidka = new NabidkaZam();
            nabidka.DataContext = new NabidkaZamViewModel(VybranyZam);
            nabidka.Owner = Application.Current.MainWindow;
            nabidka.ShowDialog();

            VybranyZam.nabidnut = true;
            Zatmavit = false;
        }
        private void AdministraceView()
        {
            Task.Run(() =>
            {
                ChangeViewModel(new AdministraceControlViewModel());
                ZobrazitContent = true;
                ZobrazeniZadaniZam = false;
            });
        }
        private void ZmenitZobrazeniDetailu(string zavrit)
        {
            if (zavrit == "0") ZobrazenyDetail = false;
            else ZobrazenyDetail = true;
            Properties.Settings.Default.zobrazenyDetail = ZobrazenyDetail;
            Properties.Settings.Default.Save();
        }
        private void ZavriAdministraci()
        {
            ZobrazeniZadaniZam = false;
        }
        private void ZatmavObrazovku(bool status)
        {
            Zatmavit = status;
        }

        private void PouzitFiltr()
        {
            ZadnaData = false;
            string sqlStr = "";
            sqlStr += "SELECT a.id, a.osCislo, a.jmeno, a.prijmeni, a.stredisko, a.datumNastupu, a.pohlavi, a.smenovyModel, a.pozice, a.kategorie, a.idUseku, a.idZapujcenehoUseku, COUNT(b.idZam), c.nazev FROM Zamestnanec AS a "
                + "LEFT JOIN Inzerat_Inzerat as b on (b.idZam = a.id and b.ukonceno = 0) "
                + "LEFT JOIN Usek as c on c.id = a.idZapujcenehoUseku "
                + "WHERE (a.idUseku = " + Properties.Settings.Default.idUseku + " OR a.idZapujcenehoUseku = " + Properties.Settings.Default.idUseku + ") AND aktivni = 1 ";

            if (!string.IsNullOrWhiteSpace(DataFiltr.osCislo)) sqlStr += " AND a.osCislo LIKE '" + DataFiltr.osCislo + "%' ";
            if (!string.IsNullOrWhiteSpace(DataFiltr.kategorie)) sqlStr += " AND a.kategorie LIKE '" + DataFiltr.osCislo + "%' ";
            if (!string.IsNullOrWhiteSpace(DataFiltr.jmeno))
            {
                string[] Deltmp = DataFiltr.jmeno.Split(' ');
                if (Deltmp.Length > 1)
                {
                    sqlStr += " AND a.prijmeni LIKE '" + Deltmp[0] + "' ";
                    sqlStr += " AND a.jmeno LIKE '" + Deltmp[1] + "%' ";
                }
                else sqlStr += " AND a.prijmeni LIKE '" + DataFiltr.jmeno + "%' ";

            }
            if (DataFiltr.stredisko != null && DataFiltr.stredisko != "")
            {
                DataFiltr.stredisko = DataFiltr.stredisko.Replace(" ", string.Empty);
                string[] kst = DataFiltr.stredisko.Split(',');
                sqlStr += " AND ( a.stredisko LIKE '%" + kst[0] + "%'";
                for (int i = 1; i < kst.Length; i++)
                {
                    sqlStr += "OR a.stredisko LIKE '%" + kst[i] + "%' ";
                }
                sqlStr += ")";
            }

            sqlStr += " GROUP BY a.id, a.osCislo, a.jmeno, a.prijmeni, a.stredisko, a.datumNastupu, a.pohlavi, a.smenovyModel, a.pozice, a.kategorie, a.idUseku, a.idZapujcenehoUseku, b.idZam, c.nazev";
            sqlStr += " ORDER BY a.prijmeni";

            Task.Run(() =>
            {
                IsBusy = true;
                SeznamZam = Zamestnanec.SelectFiltrovaniZamestnanci(sqlStr);
                if (SeznamZam.Count == 0)
                {
                    ZadnaData = true;
                }
                IsBusy = false;
            });
        }
        private void ExportDoExcel()
        {

            Task.Run(() =>
            {
                IsBusy = true;
                PraceSExcel.ListToExcelSeznam(SeznamZam);
                IsBusy = false;
            });
        }

        private void NacistPracovisteOblasti()
        {
            Task.Run(() =>
            {
                //IsBusy = true;
                //if (VybranaOblastProZobrazeni != null)
                //{
                //    seznamHodnoceni = Kompetentce.SelectKompetenceVsechDaneOblasti(VybranaOblastProZobrazeni.id);
                //    foreach (var item in SeznamZam)
                //    {
                //        item.zobrazenaOblastVyroby = new OblastVyroby();
                //        //item.ZobrazenaOblastVyroby = VybranaOblastProZobrazeni;
                //        item.zobrazenaOblastVyroby.seznamPracovist = new ObservableCollection<Pracoviste>(seznamHodnoceni.Where(d => d.kompetence.idZam == item.id && d.idOblasti == VybranaOblastProZobrazeni.id));
                //    }
                //}
                //IsBusy = false;
            });
        }
        private void ZrusitFiltr()
        {
            ZadnaData = false;
            DataFiltr.jmeno = "";
            DataFiltr.osCislo = "";
            DataFiltr.kategorie = "";

            Task.Run(() =>
            {
                IsBusy = true;
                SeznamZam = Zamestnanec.SelectZam(VybranyUsek.id);
                if (SeznamZam.Count == 0)
                {
                    ZadnaData = true;
                }
                IsBusy = false;
            });
        }

        private void VybratUsek(Usek usek)
        {
            VybranyUsek = usek;
            Properties.Settings.Default.idUseku = usek.id;
            Properties.Settings.Default.Save();
            NactiData();
        }
        private void ZpetNaUvodniVyber()
        {
            if (!ZobrazitContent)
            {
                Properties.Settings.Default.idUseku = 0;
                Properties.Settings.Default.Save();
                if (SeznamUseku == null || SeznamUseku.Count == 0)
                {
                    Task.Run(() =>
                    {
                        IsBusy = true;
                        SeznamUseku = Usek.SelectUseky();
                        opravneni = Opravneni.SelectUzivatelePodleNT();
                        foreach (var item in SeznamUseku)
                        {
                            if (opravneni.Where(d => d.idUseku == item.id).ToList().Count > 0 || "fip8jh" == "fip8jh") item.povoleno = true;
                        }
                        IsBusy = false;
                    });
                }
                ZobrazitUvodniVyber = true;
            }
            else
            {
                ZpetNaUvod();
            }

        }
    }
}
