﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using KompetencniMatice.Helpers;
using KompetencniMatice.Models;
using System.Collections.ObjectModel;
using KompetencniMatice.Commands;
namespace KompetencniMatice.ViewModels.ZamVM
{
    public class DetailViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZpet Zpet = delegate { };

        private ObservableCollection<Pracoviste> seznamPracovist;
        private bool _isBusy;
        private Zamestnanec _zam;
        private ObservableCollection<OblastVyroby> _seznamOblasti;
        private ObservableCollection<Trida> _seznamTridCB;

        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public string Name
        {
            get
            {
                return "DetailView";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public Zamestnanec Zam
        {
            get { return _zam; }
            set
            {
                if (_zam != value)
                {
                    _zam = value;
                    NactiData();
                    OnPropertyChanged("Zam");
                }
            }
        }
        public ObservableCollection<OblastVyroby> SeznamOblasti
        {
            get { return _seznamOblasti; }
            set
            {
                if (_seznamOblasti != value)
                {
                    _seznamOblasti = value;
                    OnPropertyChanged("SeznamOblasti");
                }
            }
        }
        public ObservableCollection<Trida> SeznamTridCB
        {
            get { return _seznamTridCB; }
            set
            {
                if (_seznamTridCB != value)
                {
                    _seznamTridCB = value;
                    OnPropertyChanged("SeznamTridCB");
                }
            }
        }
        public DetailViewModel(Zamestnanec zamestnanec)
        {
            if (zamestnanec != null)
            {
                ZpetNaUvodCommand = new RelayCommand(param => this.ZpetNaUvod());

                Zam = zamestnanec;
            }
        }
        private void NactiData()
        {
            
            if (Zam != null)
            {
                
                Task.Run(() =>
                {
                    SeznamTridCB = Trida.SelectTridyProCB();
                    IsBusy = true;
                    seznamPracovist = Pracoviste.SelectPracovisteZamestnanceUseku(Zam);
                    SeznamOblasti = OblastVyroby.SelectOblastiVyrobyUseku();
                    foreach (var item in SeznamOblasti)
                    {
                        item.seznamPracovist = new ObservableCollection<Pracoviste>(seznamPracovist.Where(d => d.idOblasti == item.id).ToList());
                    }

                    IsBusy = false;
                });
            }
        }
        private void ZpetNaUvod()
        {
            Zpet();
        }
    }
}

