﻿using KompetencniMatice.Commands;
using KompetencniMatice.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace KompetencniMatice.ViewModels.ZamVM
{
    class NabidkaZamViewModel: ViewModelBase
    {
        private bool _update;
        private Inzerat _novyInzerat;
        private bool _chyba;
        private string _chybaPopis;
        private bool _isBusy;
        private bool _zatmavit = false;
        private string _duvodText;
        private string _casOdText;
        private string _casDoText;
        private string _jinyDuvodText;
        private string _jinyCasOdText;
        private string _jinyCasDoText;

        private ObservableCollection<KontaktniOsoba> _seznamKontaktuProVybrani;
        private KontaktniOsoba _kontaktProVybrani;

        ObservableCollection<Duvod> _duvodyNabidky;
        ObservableCollection<Cas> _casyOd;
        ObservableCollection<Cas> _casyDo;
        public RelayCommand<Window> UlozitCommand { get; private set; }
        public RelayCommand<Window> VybratZamestnanceCommand { get; private set; }
        public RelayCommand<Window> VybratKontaktCommand { get; private set; }
        public RelayCommand ZavriZadaniCommand { get; private set; }

        public RelayCommand<string> HledejKontaktProVybraniCommand { get; private set; }
        public RelayCommand<Window> PriraditKontaktCommand { get; private set; }

        public bool Update
        {
            get { return _update; }
            set
            {
                if (_update != value)
                {
                    _update = value;
                    OnPropertyChanged("Update");
                }
            }
        }
        public Inzerat NovyInzerat
        {
            get { return _novyInzerat; }
            set
            {
                if (_novyInzerat != value)
                {
                    _novyInzerat = value;
                    OnPropertyChanged("NovyInzerat");
                }
            }
        }
        public bool Chyba
        {
            get { return _chyba; }
            set
            {
                if (_chyba != value)
                {
                    _chyba = value;
                    OnPropertyChanged("Chyba");
                }
            }
        }
        public string ChybaPopis
        {
            get { return _chybaPopis; }
            set
            {
                if (_chybaPopis != value)
                {
                    _chybaPopis = value;
                    OnPropertyChanged("ChybaPopis");
                }
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Zatmavit
        {
            get { return _zatmavit; }
            set
            {
                if (_zatmavit != value)
                {
                    _zatmavit = value;
                    OnPropertyChanged("Zatmavit");
                }
            }
        }
        
        public ObservableCollection<KontaktniOsoba> SeznamKontaktuProVybrani
        {
            get { return _seznamKontaktuProVybrani; }
            set
            {
                if (_seznamKontaktuProVybrani != value)
                {
                    _seznamKontaktuProVybrani = value;
                    OnPropertyChanged("SeznamKontaktuProVybrani");
                }
            }
        }
        public KontaktniOsoba KontaktProVybrani
        {
            get { return _kontaktProVybrani; }
            set
            {
                if (_kontaktProVybrani != value)
                {
                    _kontaktProVybrani = value;
                    OnPropertyChanged("KontaktProVybrani");
                }
            }
        }
        public ObservableCollection<Duvod> DuvodyNabidky
        {
            get { return _duvodyNabidky; }
            set
            {
                if (_duvodyNabidky != value)
                {
                    _duvodyNabidky = value;
                    OnPropertyChanged("DuvodyNabidky");
                }
            }
        }
        public ObservableCollection<Cas> CasyOd
        {
            get { return _casyOd; }
            set
            {
                if (_casyOd != value)
                {
                    _casyOd = value;
                    OnPropertyChanged("CasyOd");
                }
            }
        }
        public ObservableCollection<Cas> CasyDo
        {
            get { return _casyDo; }
            set
            {
                if (_casyDo != value)
                {
                    _casyDo = value;
                    OnPropertyChanged("CasyDo");
                }
            }
        }
        public string DuvodText
        {
            get { return _duvodText; }
            set
            {
                if (_duvodText != value)
                {
                    _duvodText = value;
                    OnPropertyChanged("DuvodText");
                }
            }
        }
        public string CasOdText
        {
            get { return _casOdText; }
            set
            {
                if (_casOdText != value)
                {
                    _casOdText = value;
                    OnPropertyChanged("CasOdText");
                }
            }
        }
        public string CasDoText
        {
            get { return _casDoText; }
            set
            {
                if (_casDoText != value)
                {
                    _casDoText = value;
                    OnPropertyChanged("CasDoText");
                }
            }
        }
        public string JinyDuvodText
        {
            get { return _jinyDuvodText; }
            set
            {
                if (_jinyDuvodText != value)
                {
                    _jinyDuvodText = value;
                    OnPropertyChanged("JinyDuvodText");
                }
            }
        }
        public string JinyCasOdText
        {
            get { return _jinyCasOdText; }
            set
            {
                if (_jinyCasOdText != value)
                {
                    _jinyCasOdText = value;
                    OnPropertyChanged("JinyCasOdText");
                }
            }
        }
        public string JinyCasDoText
        {
            get { return _jinyCasDoText; }
            set
            {
                if (_jinyCasDoText != value)
                {
                    _jinyCasDoText = value;
                    OnPropertyChanged("JinyCasDoText");
                }
            }
        }
        public NabidkaZamViewModel(Zamestnanec zam)
        {

            
            Update = false;
            NovyInzerat = new Inzerat();
            NovyInzerat.datumVytvoreni = DateTime.Now;
            NovyInzerat.datumOd = DateTime.Now.AddDays(7);
            NovyInzerat.datumDo = DateTime.Now.AddDays(8);
            NovyInzerat.zadavajici = KontaktniOsoba.HledejKontaktPodleNT();
            NovyInzerat.typ = 1;
            NovyInzerat.status = 1;
            NovyInzerat.zamestnanec = zam;

            Inicializace();
        }

        private void Inicializace()
        {
            Task.Run(() =>
            {
                IsBusy = true;
                DuvodyNabidky = Duvod.SelectDuvodyNabidky();
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    DuvodyNabidky.Add(new Duvod { duvod = "Jiné..." });
                });
                CasyOd = Cas.SelectCasy();
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    CasyOd.Add(new Cas { cas = "Jiné..." });
                });
                CasyDo = new ObservableCollection<Cas>(CasyOd);
                if (Update)
                {
                    DuvodText = NovyInzerat.duvod;
                    CasOdText = NovyInzerat.casOd;
                    CasDoText = NovyInzerat.casDo;
                    if (DuvodyNabidky.Where(d => d.duvod == DuvodText).Count() == 0)
                    {
                        JinyDuvodText = DuvodText;
                        DuvodText = "Jiné...";
                    }
                    if (CasyOd.Where(d => d.cas == CasOdText).Count() == 0)
                    {
                        JinyCasOdText = CasOdText;
                        CasOdText = "Jiné...";
                    }
                    if (CasyDo.Where(d => d.cas == CasDoText).Count() == 0)
                    {
                        JinyCasDoText = CasDoText;
                        CasDoText = "Jiné...";
                    }
                }
                IsBusy = false;
            });

            UlozitCommand = new RelayCommand<Window>(param => this.Ulozit(param));
            VybratKontaktCommand = new RelayCommand<Window>(param => this.VybratKontakt(param));

            HledejKontaktProVybraniCommand = new RelayCommand<string>(param => this.HledejKontaktProVybrani(param));
            PriraditKontaktCommand = new RelayCommand<Window>(param => this.PriraditKontakt(param));
        }

        private void VybratKontakt(Window okno)
        {
            okno.Hide();
            SeznamKontaktuProVybrani = null;
            DialogWindows.VybratKontakt vybraniZam = new DialogWindows.VybratKontakt();
            vybraniZam.DataContext = this;
            vybraniZam.Owner = Application.Current.MainWindow;
            vybraniZam.ShowDialog();
            okno.ShowDialog();
        }

        private void Ulozit(Window okno)
        {
            if (Kontrola())
            {
                if (Update)
                {
                    //if (!Zamestnanec.EditaceZamestnanece(Zam))
                    //{
                    //    Task.Run(() =>
                    //    {
                    //        Chyba = true;
                    //        ChybaPopis = "Nastala chyba při ukládání";
                    //        System.Threading.Thread.Sleep(2000);
                    //        Chyba = false;
                    //    });
                    //}
                    //else
                    //{
                    //    ZavriZadani();
                    //}
                }
                else
                {
                    NovyInzerat.id = Inzerat.VlozitNabidku(NovyInzerat);

                    if (NovyInzerat.id == 0)
                    {
                        Task.Run(() =>
                        {
                            Chyba = true;
                            ChybaPopis = "Nastala chyba při ukládání";
                            System.Threading.Thread.Sleep(2000);
                            Chyba = false;
                        });
                    }
                    else
                    {
                        if (okno != null)
                            okno.Close();
                    }
                }
            }
            else
            {
                Task.Run(() =>
                {
                    Chyba = true;
                    System.Threading.Thread.Sleep(3000);
                    Chyba = false;
                });
            }
        }
        private bool Kontrola()
        {
            if (DuvodText == "Jiné...") NovyInzerat.duvod = JinyDuvodText;
            else NovyInzerat.duvod = DuvodText;
            if (CasOdText == "Jiné...") NovyInzerat.casOd = JinyCasOdText;
            else NovyInzerat.casOd = CasOdText;
            if (CasDoText == "Jiné...") NovyInzerat.casDo = JinyCasDoText;
            else NovyInzerat.casDo = CasDoText;
            if (NovyInzerat.zadavajici.idUseku != NovyInzerat.zamestnanec.idUseku)
            {
                ChybaPopis = "Zaměstnanec nespadá pod kontaktní osobu!";
                return false;
            }

            return true;
        }

        #region Dialogova okna


        private void HledejKontaktProVybrani(string jmeno)
        {
            Task.Run(() =>
            {
                IsBusy = true;
                string query = "SELECT id, jmeno, oddeleni, stredisko, usek, klapka, mobil, email, pozice, smenovyModel, zavod, hala, vchod, mistoVyzvednuti, uzivatel FROM Inzerat_KontaktniOsoba WHERE id > 0";
                if (jmeno != null)
                {
                    query += " AND jmeno LIKE '" + jmeno + "%'";

                }


                SeznamKontaktuProVybrani = KontaktniOsoba.HledejKontakt(query);
                IsBusy = false;
            });
        }
        private void PriraditKontakt(Window okno)
        {
            if (NovyInzerat.zadavajici == null) NovyInzerat.zadavajici = new KontaktniOsoba();

            NovyInzerat.zadavajici.id = KontaktProVybrani.id;
            NovyInzerat.zadavajici.jmeno = KontaktProVybrani.jmeno;
            NovyInzerat.zadavajici.stredisko = KontaktProVybrani.stredisko;
            NovyInzerat.zadavajici.oddeleni = KontaktProVybrani.oddeleni;
            NovyInzerat.zadavajici.usek = KontaktProVybrani.usek;
            NovyInzerat.zadavajici.zavod = KontaktProVybrani.zavod;
            NovyInzerat.zadavajici.hala = KontaktProVybrani.hala;
            NovyInzerat.zadavajici.klapka = KontaktProVybrani.klapka;
            NovyInzerat.zadavajici.mobil = KontaktProVybrani.mobil;
            NovyInzerat.zadavajici.mistoVyzvednuti = KontaktProVybrani.mistoVyzvednuti;
            if (okno != null)
                okno.Close();
        }
        #endregion
    }
}



