﻿using KompetencniMatice.Commands;
using Nabidka.Helpers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Nabidka.ViewModels.AdministraceVM
{
    
    class AdministraceControlViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZpet Zpet = delegate { };
        public RelayCommand<string> ZmenitAdministraciCommand { get; private set; }
        public RelayCommand ZavriAdministraciCommand { get; private set; }

        private IPageViewModel _currentPageViewModel;

        public string Name
        {
            get
            {
                return "Administrace";
            }
        }
        
        public IPageViewModel CurrentPageViewModel
        {
            get
            {
                return _currentPageViewModel;
            }
            set
            {
                if (_currentPageViewModel != value)
                {
                    _currentPageViewModel = value;
                    OnPropertyChanged("CurrentPageViewModel");
                }
            }
        }
        
        public AdministraceControlViewModel()
        {
            ZmenitAdministraciCommand = new RelayCommand<string>(param => this.ZmenitAdministraci(param));
            ZavriAdministraciCommand = new RelayCommand(param => this.ZavriAdministraci());
        }
        
        private void ZmenitAdministraci(string admnistraceCeho)
        {
            switch (admnistraceCeho)
            {
                case "casy":
                    CurrentPageViewModel = new AdministraceCasuViewModel();
                    break;
                case "duvody":
                    CurrentPageViewModel = new AdministraceDuvoduViewModel();
                    break;
                case "smeny":
                    CurrentPageViewModel = new AdministraceSmenViewModel();
                    break;
                case "pozice":
                    CurrentPageViewModel = new AdministracePozicViewModel();
                    break;
                case "kontakty":
                    CurrentPageViewModel = new AdministraceKontaktuViewModel();
                    break;
                default:
                    break;
            }
        }
        private void ZavriAdministraci()
        {
            Zpet();
        }
    }
}
