﻿using KompetencniMatice.Commands;
using Nabidka.Helpers;
using KompetencniMatice.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Nabidka.DialogWindows;

namespace Nabidka.ViewModels.AdministraceVM
{
    class AdministraceKontaktuViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZatmavit Zatmavit = delegate { };

        private bool editace = false;

        private bool _isBusy;
        private ObservableCollection<KontaktniOsoba> _seznamKontaktnichOsob;
        private KontaktniOsoba _novaKontaktniOsoba;
        private KontaktniOsoba _vybranaKontaktniOsoba;
        private bool _zobrazeniNoveKontaktniOsoby = false;
        private string _nazev;

        public RelayCommand PridatKontaktniOsobuCommand { get; private set; }
        public RelayCommand EditovatKontaktniOsobuCommand { get; private set; }
        public RelayCommand UlozitKontaktniOsobuCommand { get; private set; }
        public RelayCommand SmazatKontaktniOsobuCommand { get; private set; }
        public RelayCommand ZavritKontaktniOsobuCommand { get; private set; }

        public string Name
        {
            get
            {
                return "Administrace Kontaktních Osob";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public ObservableCollection<KontaktniOsoba> SeznamKontaktnichOsob
        {
            get { return _seznamKontaktnichOsob; }
            set
            {
                if (_seznamKontaktnichOsob != value)
                {
                    _seznamKontaktnichOsob = value;
                    OnPropertyChanged("SeznamKontaktnichOsob");
                }
            }
        }
        public KontaktniOsoba NovaKontaktniOsoba
        {
            get { return _novaKontaktniOsoba; }
            set
            {
                if (_novaKontaktniOsoba != value)
                {
                    _novaKontaktniOsoba = value;
                    OnPropertyChanged("NovaKontaktniOsoba");
                }
            }
        }
        public KontaktniOsoba VybranaKontaktniOsoba
        {
            get { return _vybranaKontaktniOsoba; }
            set
            {
                if (_vybranaKontaktniOsoba != value)
                {
                    _vybranaKontaktniOsoba = value;
                    OnPropertyChanged("VybranaKontaktniOsoba");
                }
            }
        }
        public bool ZobrazeniNoveKontaktniOsoby
        {
            get { return _zobrazeniNoveKontaktniOsoby; }
            set
            {
                if (_zobrazeniNoveKontaktniOsoby != value)
                {
                    _zobrazeniNoveKontaktniOsoby = value;
                    OnPropertyChanged("ZobrazeniNoveKontaktniOsoby");
                }
            }
        }
        public string Nazev
        {
            get { return _nazev; }
            set
            {
                if (_nazev != value)
                {
                    _nazev = value;
                    OnPropertyChanged("Nazev");
                }
            }
        }
        public AdministraceKontaktuViewModel()
        {

            PridatKontaktniOsobuCommand = new RelayCommand(param => this.PridatKontaktniOsobu());
            EditovatKontaktniOsobuCommand = new RelayCommand(param => this.EditovatKontaktniOsobu());
            UlozitKontaktniOsobuCommand = new RelayCommand(param => this.UlozitKontaktniOsobu());
            SmazatKontaktniOsobuCommand = new RelayCommand(param => this.SmazatKontaktniOsobu());
            ZavritKontaktniOsobuCommand = new RelayCommand(param => this.ZavritKontaktniOsobu());
            Nazev = "Aktuální seznam kontaktních osob";
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamKontaktnichOsob = KontaktniOsoba.SelectKontakty();
                IsBusy = false;
            });

        }

        private void PridatKontaktniOsobu()
        {
            editace = false;
            Nazev = "Nová kontaktní osoba";
            NovaKontaktniOsoba = new KontaktniOsoba();
            ZobrazeniNoveKontaktniOsoby = true;
        }
        private void EditovatKontaktniOsobu()
        {
            editace = true;
            Nazev = "Editace kontaktní osoby";
            NovaKontaktniOsoba = new KontaktniOsoba(VybranaKontaktniOsoba);
            ZobrazeniNoveKontaktniOsoby = true;
        }
        private void UlozitKontaktniOsobu()
        {
            Task.Run(() =>
            {
                if (!editace)
                {
                    NovaKontaktniOsoba.id = KontaktniOsoba.UlozitKontaktniOsobu(NovaKontaktniOsoba);
                    App.Current.Dispatcher.Invoke((Action)delegate
                    {
                        SeznamKontaktnichOsob.Add(NovaKontaktniOsoba);
                    });


                }
                else
                {
                    KontaktniOsoba.UlozitKontaktniOsobu(NovaKontaktniOsoba);
                    VybranaKontaktniOsoba.jmeno = NovaKontaktniOsoba.jmeno;
                    VybranaKontaktniOsoba.oddeleni = NovaKontaktniOsoba.oddeleni;
                    VybranaKontaktniOsoba.stredisko = NovaKontaktniOsoba.stredisko;
                    VybranaKontaktniOsoba.usek = NovaKontaktniOsoba.usek;
                    VybranaKontaktniOsoba.klapka = NovaKontaktniOsoba.klapka;
                    VybranaKontaktniOsoba.mobil = NovaKontaktniOsoba.mobil;
                    VybranaKontaktniOsoba.email = NovaKontaktniOsoba.email;
                    VybranaKontaktniOsoba.pozice = NovaKontaktniOsoba.pozice;
                    VybranaKontaktniOsoba.smenovyModel = NovaKontaktniOsoba.smenovyModel;
                    VybranaKontaktniOsoba.zavod = NovaKontaktniOsoba.zavod;
                    VybranaKontaktniOsoba.hala = NovaKontaktniOsoba.hala;
                    VybranaKontaktniOsoba.vchod = NovaKontaktniOsoba.vchod;
                    VybranaKontaktniOsoba.mistoVyzvednuti = NovaKontaktniOsoba.mistoVyzvednuti;
                    VybranaKontaktniOsoba.uzivatel = NovaKontaktniOsoba.uzivatel;
                    VybranaKontaktniOsoba.idUseku = NovaKontaktniOsoba.idUseku;
                    VybranaKontaktniOsoba.nazevUseku = NovaKontaktniOsoba.nazevUseku;
                }
                ZobrazeniNoveKontaktniOsoby = false;
                Nazev = "Aktuální seznam kontaktních osob";
            });
        }
        private void SmazatKontaktniOsobu()
        {
            Zatmavit(true);
            WarningWindow warninng = new WarningWindow();
            warninng.Owner = System.Windows.Application.Current.MainWindow;
            warninng.TextVarovani = "Opravdu chcete smazat tuto kontaktní osobu?" + Environment.NewLine + "Uživatel nebude moci spravovat inzeráty!!!";
            warninng.ShowDialog();
            if (warninng.OK)
            {
                KontaktniOsoba.SmazatKontaktniOsobu(VybranaKontaktniOsoba);
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    SeznamKontaktnichOsob.Remove(VybranaKontaktniOsoba);
                });
            }
            Zatmavit(false);

        }
        private void ZavritKontaktniOsobu()
        {
            ZobrazeniNoveKontaktniOsoby = false;
            Nazev = "Aktuální seznam kontaktních osob";
        }


    }
}
