﻿using KompetencniMatice.Commands;
using Nabidka.Helpers;
using KompetencniMatice.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Nabidka.DialogWindows;

namespace Nabidka.ViewModels.AdministraceVM
{
    class AdministracePozicViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZatmavit Zatmavit = delegate { };

        private bool editace = false;

        private bool _isBusy;
        private ObservableCollection<Pozice> _seznamPozic;
        private Pozice _novaPozice;
        private Pozice _vybranaPozice;
        private bool _zobrazeniNovePozice = false;
        private string _nazev;

        public RelayCommand PridatPoziciCommand { get; private set; }
        public RelayCommand EditovatPoziciCommand { get; private set; }
        public RelayCommand UlozitPoziciCommand { get; private set; }
        public RelayCommand SmazatPoziciCommand { get; private set; }
        public RelayCommand ZavritPoziciCommand { get; private set; }

        public string Name
        {
            get
            {
                return "Administrace pozic";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public ObservableCollection<Pozice> SeznamPozic
        {
            get { return _seznamPozic; }
            set
            {
                if (_seznamPozic != value)
                {
                    _seznamPozic = value;
                    OnPropertyChanged("SeznamPozic");
                }
            }
        }
        public Pozice NovaPozice
        {
            get { return _novaPozice; }
            set
            {
                if (_novaPozice != value)
                {
                    _novaPozice = value;
                    OnPropertyChanged("NovaPozice");
                }
            }
        }
        public Pozice VybranaPozice
        {
            get { return _vybranaPozice; }
            set
            {
                if (_vybranaPozice != value)
                {
                    _vybranaPozice = value;
                    OnPropertyChanged("VybranaPozice");
                }
            }
        }
        public bool ZobrazeniNovePozice
        {
            get { return _zobrazeniNovePozice; }
            set
            {
                if (_zobrazeniNovePozice != value)
                {
                    _zobrazeniNovePozice = value;
                    OnPropertyChanged("ZobrazeniNovePozice");
                }
            }
        }
        public string Nazev
        {
            get { return _nazev; }
            set
            {
                if (_nazev != value)
                {
                    _nazev = value;
                    OnPropertyChanged("Nazev");
                }
            }
        }
        public AdministracePozicViewModel()
        {

            PridatPoziciCommand = new RelayCommand(param => this.PridatPozici());
            EditovatPoziciCommand = new RelayCommand(param => this.EditovatPozici());
            UlozitPoziciCommand = new RelayCommand(param => this.UlozitPozici());
            SmazatPoziciCommand = new RelayCommand(param => this.SmazatPozici());
            ZavritPoziciCommand = new RelayCommand(param => this.ZavritPozici());
            Nazev = "Aktuální seznam pozic";
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamPozic = Pozice.SelectPoziceProCB();
                IsBusy = false;
            });

        }

        private void PridatPozici()
        {
            editace = false;
            Nazev = "Nový pozice";
            NovaPozice = new Pozice();
            ZobrazeniNovePozice = true;
        }
        private void EditovatPozici()
        {
            editace = true;
            Nazev = "Editace pozice";
            NovaPozice = new Pozice(VybranaPozice);
            ZobrazeniNovePozice = true;
        }
        private void UlozitPozici()
        {
            Task.Run(() =>
            {
                if (!editace)
                {
                    NovaPozice.id = Pozice.VlozitPozici(NovaPozice);
                    App.Current.Dispatcher.Invoke((Action)delegate
                    {
                        SeznamPozic.Add(NovaPozice);
                    });


                }
                else
                {
                    Pozice.UpravitPozici(NovaPozice);
                    VybranaPozice.nazev = NovaPozice.nazev;
                }
                ZobrazeniNovePozice = false;
                Nazev = "Aktuální seznam pozic";
            });
        }
        private void SmazatPozici()
        {
            Zatmavit(true);
            WarningWindow warninng = new WarningWindow();
            warninng.Owner = System.Windows.Application.Current.MainWindow;
            warninng.TextVarovani = "Opravdu chcete smazat tento směnový model?" + Environment.NewLine + "Data budou ztracena!!!";
            warninng.ShowDialog();
            if (warninng.OK)
            {
                Pozice.SmazatPozici(VybranaPozice);
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    SeznamPozic.Remove(VybranaPozice);
                });
            }
            Zatmavit(false);

        }
        private void ZavritPozici()
        {
            ZobrazeniNovePozice = false;
            Nazev = "Aktuální seznam pozic";
        }


    }
}
