﻿using Nabidka.Helpers;
using KompetencniMatice.Models;
using Nabidka.Commands;
using Nabidka.DialogWindows;
using Nabidka.ViewModels.AdministraceVM;
using Nabidka.ViewModels.NabidkaVM;
using Nabidka.ViewModels.PoptavkaVM;
using Nabidka.ViewModels.ZamestnanecVM;
using Nabidka.Views.NabidkaView;
using Nabidka.Views.PoptavkaView;
using Nabidka.Views.ZamestnanecView;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Deployment.Application;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace Nabidka.ViewModels
{
    public delegate void EventHandlerZpet();
    public delegate void EventHandlerZpetSNovymInzeratem(Inzerat inzerat);
    public delegate void EventHandlerZpetSNovymiInzeraty(ObservableCollection<Inzerat> inzeraty);
    public delegate void EventHandlerZatmavit(bool status);
    public class MainWindowViewModel : ViewModelBase
    {
        public class Filtr : ViewModelBase
        {
            private DateTime? _datumOd;
            private DateTime? _datumDo;
            private string _pozice;
            private string _smModel;
            private bool _pouzeVolne = false;

            
            public DateTime? datumOd
            {
                get { return _datumOd; }
                set
                {
                    if (_datumOd == value)
                        return;
                    _datumOd = value;
                    OnPropertyChanged("datumOd");
                }
            }
            public DateTime? datumDo
            {
                get { return _datumDo; }
                set
                {
                    if (_datumDo == value)
                        return;
                    _datumDo = value;
                    OnPropertyChanged("datumDo");
                }
            }
            public string pozice
            {
                get { return _pozice; }
                set
                {
                    if (_pozice == value)
                        return;
                    _pozice = value;
                    OnPropertyChanged("pozice");
                }
            }

            public string smModel
            {
                get { return _smModel; }
                set
                {
                    if (_smModel == value)
                        return;
                    _smModel = value;
                    OnPropertyChanged("smModel");
                }
            }
            
            public bool pouzeVolne
            {
                get { return _pouzeVolne; }
                set
                {
                    if (_pouzeVolne == value)
                        return;
                    _pouzeVolne = value;
                    OnPropertyChanged("pouzeVolne");
                }
            }
        }

        private ObservableCollection<Inzerat> _seznamInzeratu;

        private KontaktniOsoba _detailKontaktu;
        private KontaktniOsoba _prihlasenyUzivatel;
        private Inzerat _vybranyInzerat;
        private string _verze;
        private bool _isBusy = false;
        private bool _zatmavit = false;
        private bool _zobrazenHlavniObrazovky = true;
        private bool _zadnaData = false;
        private string _duvodZruseni;
        private bool _zobrazenyContent = false;
        private Filtr _dataFiltr;
        private bool _administrator = false;

        private IPageViewModel _currentPageViewModel;

        public RelayCommand<string> ZadaniNabidkyCommand { get; private set; }
        public RelayCommand<string> ZadaniPoptavkyCommand { get; private set; }
        public RelayCommand ReagovatCommand { get; private set; }
        public RelayCommand ZobrazitDetailZamestanaceCommand { get; private set; }
        public RelayCommand EditaceInzeratuCommand { get; private set; }
        public RelayCommand ZrusitInzeratCommand { get; private set; }
        public RelayCommand<string> ZobrazitDetailKontaktuCommand { get; private set; }
        public RelayCommand ZobrazitAdministraciCommand { get; private set; }
        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public RelayCommand PoslatEmailCommand { get; private set; }
        public RelayCommand PouzitFiltrCommand { get; private set; }
        public RelayCommand ZrusitFiltrCommand { get; private set; }
        public IPageViewModel CurrentPageViewModel
        {
            get
            {
                return _currentPageViewModel;
            }
            set
            {
                if (_currentPageViewModel != value)
                {
                    _currentPageViewModel = value;
                    OnPropertyChanged("CurrentPageViewModel");
                }
            }
        }
        public ObservableCollection<Inzerat> SeznamInzeratu
        {
            get { return _seznamInzeratu; }
            set
            {
                if (_seznamInzeratu != value)
                {
                    _seznamInzeratu = value;
                    OnPropertyChanged("SeznamInzeratu");
                }
            }
        }

        public KontaktniOsoba DetailKontaktu
        {
            get { return _detailKontaktu; }
            set
            {
                if (_detailKontaktu != value)
                {
                    _detailKontaktu = value;
                    OnPropertyChanged("DetailKontaktu");
                }
            }
        }
        public KontaktniOsoba PrihlasenyUzivatel
        {
            get { return _prihlasenyUzivatel; }
            set
            {
                if (_prihlasenyUzivatel != value)
                {
                    _prihlasenyUzivatel = value;
                    OnPropertyChanged("PrihlasenyUzivatel");
                }
            }
        }
        public Inzerat VybranyInzerat
        {
            get { return _vybranyInzerat; }
            set
            {
                if (_vybranyInzerat != value)
                {
                    _vybranyInzerat = value;
                    OnPropertyChanged("VybranyInzerat");
                }
            }
        }
        public string Verze
        {
            get { return _verze; }
            set
            {
                if (_verze != value)
                {
                    _verze = value;
                    OnPropertyChanged("Verze");
                }
            }
        }
        
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Zatmavit
        {
            get { return _zatmavit; }
            set
            {
                if (_zatmavit != value)
                {
                    _zatmavit = value;
                    OnPropertyChanged("Zatmavit");
                }
            }
        }
        public bool Administrator
        {
            get { return _administrator; }
            set
            {
                if (_administrator != value)
                {
                    _administrator = value;
                    OnPropertyChanged("Administrator");
                }
            }
        }
        public bool ZadnaData
        {
            get { return _zadnaData; }
            set
            {
                if (_zadnaData != value)
                {
                    _zadnaData = value;
                    OnPropertyChanged("ZadnaData");
                }
            }
        }
        public string DuvodZruseni
        {
            get { return _duvodZruseni; }
            set
            {
                if (_duvodZruseni != value)
                {
                    _duvodZruseni = value;
                    OnPropertyChanged("DuvodZruseni");
                }
            }
        }
        public bool ZobrazenHlavniObrazovky
        {
            get { return _zobrazenHlavniObrazovky; }
            set
            {
                if (_zobrazenHlavniObrazovky != value)
                {
                    _zobrazenHlavniObrazovky = value;
                    OnPropertyChanged("ZobrazenHlavniObrazovky");
                }
            }
        }
        public bool ZobrazenyContent
        {
            get { return _zobrazenyContent; }
            set
            {
                if (_zobrazenyContent != value)
                {
                    _zobrazenyContent = value;
                    OnPropertyChanged("ZobrazenyContent");
                }
            }
        }
        public Filtr DataFiltr
        {
            get { return _dataFiltr; }
            set
            {
                if (_dataFiltr != value)
                {
                    _dataFiltr = value;
                    OnPropertyChanged("DataFiltr");
                }
            }
        }

        public MainWindowViewModel()
        {
            NovaNabidkaViewModel.ZpetSInzeratem += ZpetNaUvodSInzeratem;
            NovaPoptavkaViewModel.ZpetSInzeratem += ZpetNaUvodSInzeratem;
            NovaPoptavkaViewModel.ZpetSInzeraty += ZpetNaUvodSInzeraty;
            AdministraceControlViewModel.Zpet += ZpetNaUvod;
            AdministraceCasuViewModel.Zatmavit += ZatmavObrazovku;
            AdministraceDuvoduViewModel.Zatmavit += ZatmavObrazovku;
            AdministraceSmenViewModel.Zatmavit += ZatmavObrazovku;
            AdministracePozicViewModel.Zatmavit += ZatmavObrazovku;
            ZadaniNabidkyCommand = new RelayCommand<string>(param => this.ZadaniNabidky(param));
            ZadaniPoptavkyCommand = new RelayCommand<string>(param => this.ZadaniPoptavky(param));
            EditaceInzeratuCommand = new RelayCommand(param => this.EditaceInzeratu());
            ZrusitInzeratCommand = new RelayCommand(param => this.ZrusitInzerat());
            ReagovatCommand = new RelayCommand(param => this.Reagovat());
            ZpetNaUvodCommand = new RelayCommand(param => this.ZpetNaUvod());
            ZobrazitDetailZamestanaceCommand = new RelayCommand(param => this.ZobrazitDetailZamestanace());
            ZobrazitDetailKontaktuCommand = new RelayCommand<string>(param => this.ZobrazitDetailKontaktu(param));
            ZobrazitAdministraciCommand = new RelayCommand(param => this.ZobrazitAdministraci());
            PoslatEmailCommand = new RelayCommand(param => this.PoslatEmail());
            PouzitFiltrCommand = new RelayCommand(param => this.PouzitFiltr());
            ZrusitFiltrCommand = new RelayCommand(param => this.ZrusitFiltr());
        }

        public void NactiData()
        {
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamInzeratu = Inzerat.SelectInzeraty();
                PrihlasenyUzivatel = KontaktniOsoba.HledejKontaktPodleNT();
                if (SeznamInzeratu.Count == 0) ZadnaData = true;
                Administrator = true;
                DataFiltr = new Filtr();
                IsBusy = false;
            });
            DataFiltr = new Filtr();
        }
        private string GetVerze()
        {
            try
            {
                Version ver = ApplicationDeployment.CurrentDeployment.CurrentVersion;
                return string.Format("{0}.{1}.{2}.{3}", ver.Major, ver.Minor, ver.Build, ver.Revision);

            }
            catch (InvalidDeploymentException)
            {
                return "not installed";
            }
        }
        
        private void ZobrazitAdministraci()
        {
            Task.Run(() =>
            {
                CurrentPageViewModel = new AdministraceControlViewModel();
                ZobrazenyContent = true;
            });
        }

        private void ZadaniNabidky(string editace)
        {
            NovaNabidkaWindow nabidka = new NovaNabidkaWindow();
            switch (editace)
            {
                case "novy":
                    Zatmavit = true;
                    nabidka.DataContext = new NovaNabidkaViewModel();
                    nabidka.Owner = Application.Current.MainWindow;
                    nabidka.ShowDialog();
                    Zatmavit = false;
                    break;
                case "editace":
                    Zatmavit = true;
                    nabidka.DataContext = new NovaNabidkaViewModel(VybranyInzerat);
                    nabidka.Owner = Application.Current.MainWindow;
                    nabidka.ShowDialog();
                    Zatmavit = false;
                    break;
                default:
                    break;
            }
        }
        private void ZadaniPoptavky(string editace)
        {
            NovaPoptavkaWindow poptavka = new NovaPoptavkaWindow();
            switch (editace)
            {
                case "novy":
                    Zatmavit = true;
                    poptavka.DataContext = new NovaPoptavkaViewModel();
                    poptavka.Owner = Application.Current.MainWindow;
                    poptavka.ShowDialog();
                    Zatmavit = false;
                    break;
                case "editace":
                    Zatmavit = true;
                    poptavka.DataContext = new NovaPoptavkaViewModel(VybranyInzerat);
                    poptavka.Owner = Application.Current.MainWindow;
                    poptavka.ShowDialog();
                    Zatmavit = false;
                    break;
                default:
                    break;
            }
        }

        private void EditaceInzeratu()
        {
            if (PrihlasenyUzivatel.idUseku == VybranyInzerat.zadavajici.idUseku)
            {
                if (VybranyInzerat.typ == 1)
                {
                    ZadaniNabidky("editace");
                }
                else
                {
                    ZadaniPoptavky("editace");
                }
            }
            else
            {
                Zatmavit = true;
                ErrorWindow error = new ErrorWindow();
                error.Owner = Application.Current.MainWindow;
                error.TextVarovani = "Nemáte dostatečná opravnění pro editaci tohoto inzerátu!!!";
                error.ShowDialog();
                Zatmavit = false;
            }
            
        }
        private void ZrusitInzerat()
        {
            if (VybranyInzerat.reagujici == null)
            {
                Zatmavit = true;
                WarningWindow warninng = new WarningWindow();
                warninng.Owner = Application.Current.MainWindow;
                warninng.TextVarovani = "Opravdu chcete smazat tento inzerát?" + Environment.NewLine + "Data budou ztracena!!!";
                warninng.ShowDialog();
                if (warninng.OK)
                {
                    Inzerat.SmazatInzarat(VybranyInzerat.id);
                    SeznamInzeratu.Remove(VybranyInzerat);
                }
                Zatmavit = false;
            }
            else
            {
                Zatmavit = true;
                ZruseniInzeratu zruseni = new ZruseniInzeratu();
                zruseni.Owner = Application.Current.MainWindow;
                zruseni.ShowDialog();
                if (zruseni.OK)
                {
                    
                }
                Zatmavit = false;

            }
        }
        private void Reagovat()
        {
            
            Zatmavit = true;
            if (VybranyInzerat.typ == 1)
            {
                ReakceNaNabidku reakce = new ReakceNaNabidku();
                ReakceNaNabidkuViewModel reakceVM = new ReakceNaNabidkuViewModel(VybranyInzerat);
                reakce.DataContext = reakceVM;
                reakce.Owner = Application.Current.MainWindow;
                reakce.ShowDialog();
                if (reakce.Ulozit)
                {
                    VybranyInzerat.status = 2;
                    VybranyInzerat.reagujici = reakceVM.Reagujici;
                    Inzerat.ReagovatNaNabidku(VybranyInzerat);
                }
            }
           else
            {
                ReakceNaPoptavku reakce = new ReakceNaPoptavku();
                ReakceNaPoptavkuViewModel reakceVM = new ReakceNaPoptavkuViewModel(VybranyInzerat);
                reakce.DataContext = reakceVM;
                reakce.Owner = Application.Current.MainWindow;
                reakce.ShowDialog();
                if (reakce.Ulozit)
                {
                    VybranyInzerat.status = 2;
                    VybranyInzerat.reagujici = reakceVM.Reagujici;
                    VybranyInzerat.zamestnanec = reakceVM.ZamestnanecNaPoptavku;
                    Inzerat.ReagovatNaNabidku(VybranyInzerat);
                }
            }
            Zatmavit = false;
        }
        private void ZobrazitDetailZamestanace()
        {
            Zatmavit = true;
            DetailZam detail = new DetailZam();
            detail.DataContext = new DetailZamViewModel(VybranyInzerat.zamestnanec);
            detail.Owner = Application.Current.MainWindow;
            detail.ShowDialog();
            Zatmavit = false;
        }
        private void ZobrazitDetailKontaktu(string ktereho)
        {
            Zatmavit = true;
            DetailKontaktu detail = new DetailKontaktu();
            detail.DataContext = this;
            detail.Owner = Application.Current.MainWindow;
            if (ktereho == "Nabizejici") DetailKontaktu = VybranyInzerat.zadavajici;
            else if (ktereho == "Reagujici") DetailKontaktu = VybranyInzerat.reagujici;

            detail.ShowDialog();
            Zatmavit = false;
        }
        private void PouzitFiltr()
        {
            ZadnaData = false;
            string sqlStr = "";
            sqlStr += "SELECT a.id, a.datumVytvoreni, a.datumOd, a.datumDo, a.casOd, a.casDo, a.duvod, b.id, b.jmeno, b.prijmeni, b.osCislo, b.pohlavi, b.stredisko, b.smenovyModel, b.pozice,"
                + " c.id, c.jmeno, c.stredisko, c.oddeleni, c.usek, c.klapka, c.mobil, c.email, c.pozice, c.smenovyModel, c.zavod, c.hala, c.vchod, c.mistoVyzvednuti, c.uzivatel,"
                + " d.id, d.jmeno, d.stredisko, d.oddeleni, d.usek, d.klapka, d.mobil, d.email, d.pozice, d.smenovyModel, d.zavod, d.hala, d.vchod, d.mistoVyzvednuti, d.uzivatel, a.typ, a.ntReagujiciho, a.status, c.idUseku, a.smenovyModel, a.pohlavi, a.pozice, b.idUseku, a.dobaReakce FROM Inzerat_Inzerat AS a"
                + " LEFT JOIN Zamestnanec AS b ON b.id = a.idZam"
                + " JOIN Inzerat_KontaktniOsoba AS c ON c.id = a.idZadavajiciho"
                + " LEFT JOIN Inzerat_KontaktniOsoba AS d ON d.id = a.idReagujiciho"
                + " WHERE a.ukonceno = 0";


            if (!string.IsNullOrWhiteSpace(DataFiltr.pozice)) sqlStr += " AND (b.pozice LIKE '" + DataFiltr.pozice + "%' OR a.pozice LIKE '" + DataFiltr.pozice + "%')";
            if (!string.IsNullOrWhiteSpace(DataFiltr.smModel)) sqlStr += " AND (b.pozice LIKE '" + DataFiltr.pozice + "%' OR a.pozice LIKE '" + DataFiltr.pozice + "%')";

            if (DataFiltr.pouzeVolne) sqlStr += " AND status = 1";
            if (DataFiltr.datumOd.HasValue) sqlStr += " AND datumOd >= '" + DataFiltr.datumOd.Value.ToString("MM-dd-yyyy") + "'";
            if (DataFiltr.datumDo.HasValue) sqlStr += " AND datumDo <= '" + DataFiltr.datumDo.Value.ToString("MM-dd-yyyy 23:59") + "'";

            sqlStr += " ORDER BY datumOd";

            Task.Run(() =>
            {
                IsBusy = true;
                SeznamInzeratu = Inzerat.SelectFiltrovaneInzeraty(sqlStr);
                if (SeznamInzeratu.Count == 0) ZadnaData = true;
                IsBusy = false;
            });
        }
        private void ZrusitFiltr()
        {
            ZadnaData = false;
            DataFiltr.datumOd = null;
            DataFiltr.datumDo = null;
            DataFiltr.pozice = "";
            DataFiltr.smModel = "";
            DataFiltr.pouzeVolne = false;

            Task.Run(() =>
            {
                IsBusy = true;
                SeznamInzeratu = Inzerat.SelectInzeraty();
                if (SeznamInzeratu.Count == 0) ZadnaData = true;
                IsBusy = false;
            });
        }

        private void PoslatEmail()
        {  
            Outlook.Application outlookApp = new Outlook.Application();
            Outlook.MailItem mailItem = (Outlook.MailItem)outlookApp.CreateItem(Outlook.OlItemType.olMailItem);

            mailItem.To = DetailKontaktu.email;

            mailItem.Display(false);

        }
        private void ZpetNaUvod()
        {
            ZobrazenHlavniObrazovky = true;
            ZobrazenyContent = false;
            Zatmavit = false;
        }
        
        private void ZpetNaUvodSInzeratem(Inzerat inz)
        {
            App.Current.Dispatcher.Invoke((Action)delegate
            {
                SeznamInzeratu.Insert(0, inz);
            });
            if (ZadnaData) ZadnaData = false;
            
            ZobrazenHlavniObrazovky = true;

        }
        private void ZpetNaUvodSInzeraty(ObservableCollection<Inzerat> inzeraty)
        {
            App.Current.Dispatcher.Invoke((Action)delegate
            {
                foreach (var item in inzeraty)
                {
                    SeznamInzeratu.Insert(0, item);
                }
                
            });
            if (ZadnaData) ZadnaData = false;

            ZobrazenHlavniObrazovky = true;

        }
        private void ZatmavObrazovku(bool status)
        {
            Zatmavit = status;
        }
    }
}

