﻿using KompetencniMatice.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Nabidka.ViewModels.NabidkaVM
{
    class ReakceNaNabidkuViewModel : ViewModelBase
    {
        private KontaktniOsoba _reagujici;
        private ObservableCollection<KontaktniOsoba> _seznamKontaktnichOsob;
        private Inzerat vybranyInzerat;
        private bool _chybaReakce = false;
        public KontaktniOsoba Reagujici
        {
            get { return _reagujici; }
            set
            {
                if (_reagujici != value)
                {
                    _reagujici = value;
                    KontrolaReakce();
                    OnPropertyChanged("Reagujici");
                }
            }
        }
        public ObservableCollection<KontaktniOsoba> SeznamKontaktnichOsob
        {
            get { return _seznamKontaktnichOsob; }
            set
            {
                if (_seznamKontaktnichOsob != value)
                {
                    _seznamKontaktnichOsob = value;
                    OnPropertyChanged("SeznamKontaktnichOsob");
                }
            }
        }

        public bool ChybaReakce
        {
            get { return _chybaReakce; }
            set
            {
                if (_chybaReakce != value)
                {
                    _chybaReakce = value;
                    OnPropertyChanged("ChybaReakce");
                }
            }
        }
        public ReakceNaNabidkuViewModel(Inzerat inzerat)
        {
            vybranyInzerat = inzerat;
            Task.Run(() =>
            {
                SeznamKontaktnichOsob = KontaktniOsoba.SelectKontakty();
                Reagujici = SeznamKontaktnichOsob.Where(d => d.uzivatel == "fip8jh").FirstOrDefault();
                KontrolaReakce();
            });
        }
        private void KontrolaReakce()
        {
            if (Reagujici.idUseku == vybranyInzerat.zadavajici.idUseku) ChybaReakce = true;
            else ChybaReakce = false;
        }
    }
}
