﻿using KompetencniMatice.DialogWindows;
using KompetencniMatice.Models;
using Nabidka.Commands;
using Nabidka.Helpers;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace Nabidka.ViewModels.PoptavkaVM
{
    class NovaPoptavkaViewModel : ViewModelBase
    {
        public static event EventHandlerZpet Zpet = delegate { };
        public static event EventHandlerZpetSNovymInzeratem ZpetSInzeratem = delegate { };
        public static event EventHandlerZpetSNovymiInzeraty ZpetSInzeraty = delegate { };

        private bool _update;
        private Inzerat _novyInzerat;
        private bool _chyba;
        private string _chybaPopis;
        private bool _isBusy;
        private bool _zatmavit = false;
        private string _duvodText;
        private string _casOdText;
        private string _casDoText;
        private string _jinyDuvodText;
        private string _jinyCasOdText;
        private string _jinyCasDoText;
        private int _pocetKopii;

        private ObservableCollection<KontaktniOsoba> _seznamKontaktuProVybrani;
        private KontaktniOsoba _kontaktProVybrani;

        ObservableCollection<Duvod> _duvodyPoptavky;
        ObservableCollection<SmenovyModel> _smenoveModely;
        ObservableCollection<Pozice> _poziceProVyber;
        ObservableCollection<Cas> _casyOd;
        ObservableCollection<Cas> _casyDo;
        public RelayCommand<Window> UlozitCommand { get; private set; }
        public RelayCommand<string> ZmenitPocetDniReakceCommand { get; private set; }
        public RelayCommand<string> ZmenitPocetKopiiCommand { get; private set; }
        public RelayCommand<Window> VybratKontaktCommand { get; private set; }
        public RelayCommand ZavriZadaniCommand { get; private set; }

        public RelayCommand<string> HledejKontaktProVybraniCommand { get; private set; }
        public RelayCommand<Window> PriraditKontaktCommand { get; private set; }

        public bool Update
        {
            get { return _update; }
            set
            {
                if (_update != value)
                {
                    _update = value;
                    OnPropertyChanged("Update");
                }
            }
        }
        public Inzerat NovyInzerat
        {
            get { return _novyInzerat; }
            set
            {
                if (_novyInzerat != value)
                {
                    _novyInzerat = value;
                    OnPropertyChanged("NovyInzerat");
                }
            }
        }
        public bool Chyba
        {
            get { return _chyba; }
            set
            {
                if (_chyba != value)
                {
                    _chyba = value;
                    OnPropertyChanged("Chyba");
                }
            }
        }
        public string ChybaPopis
        {
            get { return _chybaPopis; }
            set
            {
                if (_chybaPopis != value)
                {
                    _chybaPopis = value;
                    OnPropertyChanged("ChybaPopis");
                }
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Zatmavit
        {
            get { return _zatmavit; }
            set
            {
                if (_zatmavit != value)
                {
                    _zatmavit = value;
                    OnPropertyChanged("Zatmavit");
                }
            }
        }

        public ObservableCollection<KontaktniOsoba> SeznamKontaktuProVybrani
        {
            get { return _seznamKontaktuProVybrani; }
            set
            {
                if (_seznamKontaktuProVybrani != value)
                {
                    _seznamKontaktuProVybrani = value;
                    OnPropertyChanged("SeznamKontaktuProVybrani");
                }
            }
        }
        public KontaktniOsoba KontaktProVybrani
        {
            get { return _kontaktProVybrani; }
            set
            {
                if (_kontaktProVybrani != value)
                {
                    _kontaktProVybrani = value;
                    OnPropertyChanged("KontaktProVybrani");
                }
            }
        }
        public ObservableCollection<Duvod> DuvodyPoptavky
        {
            get { return _duvodyPoptavky; }
            set
            {
                if (_duvodyPoptavky != value)
                {
                    _duvodyPoptavky = value;
                    OnPropertyChanged("DuvodyPoptavky");
                }
            }
        }
        public ObservableCollection<SmenovyModel> SmenoveModely
        {
            get { return _smenoveModely; }
            set
            {
                if (_smenoveModely != value)
                {
                    _smenoveModely = value;
                    OnPropertyChanged("SmenoveModely");
                }
            }
        }
        public ObservableCollection<Pozice> PoziceProVyber
        {
            get { return _poziceProVyber; }
            set
            {
                if (_poziceProVyber != value)
                {
                    _poziceProVyber = value;
                    OnPropertyChanged("PoziceProVyber");
                }
            }
        }
        public ObservableCollection<Cas> CasyOd
        {
            get { return _casyOd; }
            set
            {
                if (_casyOd != value)
                {
                    _casyOd = value;
                    OnPropertyChanged("CasyOd");
                }
            }
        }
        public ObservableCollection<Cas> CasyDo
        {
            get { return _casyDo; }
            set
            {
                if (_casyDo != value)
                {
                    _casyDo = value;
                    OnPropertyChanged("CasyDo");
                }
            }
        }
        public string DuvodText
        {
            get { return _duvodText; }
            set
            {
                if (_duvodText != value)
                {
                    _duvodText = value;
                    OnPropertyChanged("DuvodText");
                }
            }
        }
        public string CasOdText
        {
            get { return _casOdText; }
            set
            {
                if (_casOdText != value)
                {
                    _casOdText = value;
                    OnPropertyChanged("CasOdText");
                }
            }
        }
        public string CasDoText
        {
            get { return _casDoText; }
            set
            {
                if (_casDoText != value)
                {
                    _casDoText = value;
                    OnPropertyChanged("CasDoText");
                }
            }
        }
        public string JinyDuvodText
        {
            get { return _jinyDuvodText; }
            set
            {
                if (_jinyDuvodText != value)
                {
                    _jinyDuvodText = value;
                    OnPropertyChanged("JinyDuvodText");
                }
            }
        }
        public string JinyCasOdText
        {
            get { return _jinyCasOdText; }
            set
            {
                if (_jinyCasOdText != value)
                {
                    _jinyCasOdText = value;
                    OnPropertyChanged("JinyCasOdText");
                }
            }
        }
        public string JinyCasDoText
        {
            get { return _jinyCasDoText; }
            set
            {
                if (_jinyCasDoText != value)
                {
                    _jinyCasDoText = value;
                    OnPropertyChanged("JinyCasDoText");
                }
            }
        }
        public int PocetKopii
        {
            get { return _pocetKopii; }
            set
            {
                if (_pocetKopii != value)
                {
                    _pocetKopii = value;
                    OnPropertyChanged("PocetKopii");
                }
            }
        }
        public NovaPoptavkaViewModel()
        {
            Update = false;
            NovyInzerat = new Inzerat();
            NovyInzerat.datumVytvoreni = DateTime.Now;
            NovyInzerat.datumOd = DateTime.Now.AddDays(7);
            NovyInzerat.datumDo = DateTime.Now.AddDays(8);
            NovyInzerat.zadavajici = KontaktniOsoba.HledejKontaktPodleNT();
            NovyInzerat.typ = 2;
            NovyInzerat.status = 1;
            PocetKopii = 1;
            NovyInzerat.dobaReakce = 3;

            Inicializace();
        }
        public NovaPoptavkaViewModel(Inzerat inzerat)
        {
            Update = true;
            NovyInzerat = inzerat;
            Inicializace();
        }

        private void Inicializace()
        {
            Task.Run(() =>
            {
                IsBusy = true;
                DuvodyPoptavky = Duvod.SelectDuvodyPoptavky();
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    DuvodyPoptavky.Add(new Duvod { duvod = "Jiné..." });
                });

                SmenoveModely = SmenovyModel.SelectSmenoveModelyProCB();
                PoziceProVyber = Pozice.SelectPoziceProCB();

                CasyOd = Cas.SelectCasy();
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    CasyOd.Add(new Cas { cas = "Jiné..." });
                });

                CasyDo = new ObservableCollection<Cas>(CasyOd);
                if (Update)
                {
                    DuvodText = NovyInzerat.duvod;
                    CasOdText = NovyInzerat.casOd;
                    CasDoText = NovyInzerat.casDo;
                    if (DuvodyPoptavky.Where(d => d.duvod == DuvodText).Count() == 0)
                    {
                        JinyDuvodText = DuvodText;
                        DuvodText = "Jiné...";
                    }
                    if (CasyOd.Where(d => d.cas == CasOdText).Count() == 0)
                    {
                        JinyCasOdText = CasOdText;
                        CasOdText = "Jiné...";
                    }
                    if (CasyDo.Where(d => d.cas == CasDoText).Count() == 0)
                    {
                        JinyCasDoText = CasDoText;
                        CasDoText = "Jiné...";
                    }
                }
                IsBusy = false;
            });



            UlozitCommand = new RelayCommand<Window>(param => this.Ulozit(param));
            VybratKontaktCommand = new RelayCommand<Window>(param => this.VybratKontakt(param));
            ZavriZadaniCommand = new RelayCommand(param => this.ZavriZadani());
            ZmenitPocetDniReakceCommand = new RelayCommand<string>(param => this.ZmenitPocetDniReakce(param));
            ZmenitPocetKopiiCommand = new RelayCommand<string>(param => this.ZmenitPocetKopii(param));

            HledejKontaktProVybraniCommand = new RelayCommand<string>(param => this.HledejKontaktProVybrani(param));
            PriraditKontaktCommand = new RelayCommand<Window>(param => this.PriraditKontakt(param));
        }

        private void VybratKontakt(Window okno)
        {
            okno.Hide();
            SeznamKontaktuProVybrani = null;
            DialogWindows.VybratKontakt vybraniZam = new DialogWindows.VybratKontakt();
            vybraniZam.DataContext = this;
            vybraniZam.Owner = Application.Current.MainWindow;
            vybraniZam.ShowDialog();
            okno.ShowDialog();
        }

        private void Ulozit(Window okno)
        {
            if (Kontrola())
            {
                if (Update)
                {
                    if (!Inzerat.UpravitPoptavku(NovyInzerat))
                    {
                        Task.Run(() =>
                        {
                            Chyba = true;
                            ChybaPopis = "Nastala chyba při ukládání";
                            System.Threading.Thread.Sleep(2000);
                            Chyba = false;
                        });
                    }
                    else
                    {
                        if (okno != null)
                            okno.Close();
                    }
                }
                else
                {

                    if (PocetKopii == 1)
                    {
                        NovyInzerat.id = Inzerat.VlozitPoptavku(NovyInzerat);

                        if (NovyInzerat.id == 0)
                        {
                            Task.Run(() =>
                            {
                                Chyba = true;
                                ChybaPopis = "Nastala chyba při ukládání";
                                System.Threading.Thread.Sleep(2000);
                                Chyba = false;
                            });
                        }
                        else
                        {
                            ZpetSInzeratem(NovyInzerat);
                            if (okno != null)
                                okno.Close();
                        }

                    }
                    else
                    {
                        ObservableCollection<Inzerat> seznam = new ObservableCollection<Inzerat>();
                        for (int i = 0; i < PocetKopii; i++)
                        {
                            NovyInzerat.id = Inzerat.VlozitPoptavku(NovyInzerat);
                            seznam.Add(NovyInzerat);
                            
                        }
                        ZpetSInzeraty(seznam);
                        if (okno != null)
                            okno.Close();
                    }
                }
            }
            else
            {
                Task.Run(() =>
                {
                    Chyba = true;
                    System.Threading.Thread.Sleep(3000);
                    Chyba = false;
                });
            }
        }
        private void ZmenitPocetDniReakce(string operace)
        {
            if (operace == "plus")
            {
                if (NovyInzerat.dobaReakce < 5)
                {
                    NovyInzerat.dobaReakce += 1;
                }
            }
            else
            {
                if (NovyInzerat.dobaReakce > 0)
                {
                    NovyInzerat.dobaReakce -= 1;
                }
            }
        }
        private void ZmenitPocetKopii(string operace)
        {
            if (operace == "plus")
            {
                PocetKopii += 1;    
            }
            else
            {
                if (PocetKopii > 1)
                {
                    PocetKopii -= 1;
                }
            }
        }
        private bool Kontrola()
        {
            if (DuvodText == "Jiné...") NovyInzerat.duvod = JinyDuvodText;
            else NovyInzerat.duvod = DuvodText;
            if (CasOdText == "Jiné...") NovyInzerat.casOd = JinyCasOdText;
            else NovyInzerat.casOd = CasOdText;
            if (CasDoText == "Jiné...") NovyInzerat.casDo = JinyCasDoText;
            else NovyInzerat.casDo = CasDoText;
            if (NovyInzerat.datumOd > NovyInzerat.datumDo)
            {
                ChybaPopis = "Datum do nesmí být menší jak datum od";
                return false;
            }
            if (NovyInzerat.datumOd < DateTime.Now.AddDays(3).Date)
            {
                ChybaPopis = "Datum od může být nastaveno nejméně 3 dny dopředu";
                return false;
            }            
            
            return true;
        }
        private void ZavriZadani()
        {
            Zpet();
        }

        #region Dialogova okna


        private void HledejKontaktProVybrani(string jmeno)
        {
            Task.Run(() =>
            {
                IsBusy = true;
                string query = "SELECT id, jmeno, oddeleni, stredisko, usek, klapka, mobil, email, pozice, smenovyModel, zavod, hala, vchod, mistoVyzvednuti, uzivatel FROM Inzerat_KontaktniOsoba WHERE id = " + NovyInzerat.zadavajici.idUseku;
                if (jmeno != null)
                {
                    query += " AND jmeno LIKE '" + jmeno + "%'";

                }


                SeznamKontaktuProVybrani = KontaktniOsoba.HledejKontakt(query);
                IsBusy = false;
            });
        }
        private void PriraditKontakt(Window okno)
        {
            if (NovyInzerat.zadavajici == null) NovyInzerat.zadavajici = new KontaktniOsoba();

            NovyInzerat.zadavajici.id = KontaktProVybrani.id;
            NovyInzerat.zadavajici.jmeno = KontaktProVybrani.jmeno;
            NovyInzerat.zadavajici.stredisko = KontaktProVybrani.stredisko;
            NovyInzerat.zadavajici.oddeleni = KontaktProVybrani.oddeleni;
            NovyInzerat.zadavajici.usek = KontaktProVybrani.usek;
            NovyInzerat.zadavajici.zavod = KontaktProVybrani.zavod;
            NovyInzerat.zadavajici.hala = KontaktProVybrani.hala;
            NovyInzerat.zadavajici.klapka = KontaktProVybrani.klapka;
            NovyInzerat.zadavajici.mobil = KontaktProVybrani.mobil;
            NovyInzerat.zadavajici.mistoVyzvednuti = KontaktProVybrani.mistoVyzvednuti;
            if (okno != null)
                okno.Close();
        }
        #endregion
    }
}



