﻿using KompetencniMatice.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Nabidka.ViewModels.PoptavkaVM
{
    class ReakceNaPoptavkuViewModel : ViewModelBase
    {
        private KontaktniOsoba _reagujici;
        private ObservableCollection<KontaktniOsoba> _seznamKontaktnichOsob;
        private ObservableCollection<Zamestnanec> _seznamZamestnancu;
        private Zamestnanec _zamestnanecNaPoptavku;
        private Inzerat vybranyInzerat;
        private bool _chybaReakce = false;
        private string _popisChyby = "";
        public KontaktniOsoba Reagujici
        {
            get { return _reagujici; }
            set
            {
                if (_reagujici != value)
                {
                    _reagujici = value;
                    KontrolaReakce();
                    ZmenaKontaktniOsoby();
                    OnPropertyChanged("Reagujici");
                }
            }
        }
        public ObservableCollection<KontaktniOsoba> SeznamKontaktnichOsob
        {
            get { return _seznamKontaktnichOsob; }
            set
            {
                if (_seznamKontaktnichOsob != value)
                {
                    _seznamKontaktnichOsob = value;
                    OnPropertyChanged("SeznamKontaktnichOsob");
                }
            }
        }
        public ObservableCollection<Zamestnanec> SeznamZamestnancu
        {
            get { return _seznamZamestnancu; }
            set
            {
                if (_seznamZamestnancu != value)
                {
                    _seznamZamestnancu = value;
                    OnPropertyChanged("SeznamZamestnancu");
                }
            }
        }
        public Zamestnanec ZamestnanecNaPoptavku
        {
            get { return _zamestnanecNaPoptavku; }
            set
            {
                if (_zamestnanecNaPoptavku != value)
                {
                    _zamestnanecNaPoptavku = value;
                    KontrolaReakce();
                    OnPropertyChanged("ZamestnanecNaPoptavku");
                }
            }
        }
        public bool ChybaReakce
        {
            get { return _chybaReakce; }
            set
            {
                if (_chybaReakce != value)
                {
                    _chybaReakce = value;
                    OnPropertyChanged("ChybaReakce");
                }
            }
        }
        public string PopisChyby
        {
            get { return _popisChyby; }
            set
            {
                if (_popisChyby != value)
                {
                    _popisChyby = value;
                    OnPropertyChanged("PopisChyby");
                }
            }
        }
        public ReakceNaPoptavkuViewModel(Inzerat inzerat)
        {
            vybranyInzerat = inzerat;
            Task.Run(() =>
            {
                SeznamKontaktnichOsob = KontaktniOsoba.SelectKontakty();
                Reagujici = SeznamKontaktnichOsob.Where(d => d.uzivatel == "fip8jh").FirstOrDefault();
                SeznamZamestnancu = Zamestnanec.SelectZamUseku(Reagujici.idUseku);
                KontrolaReakce();
            });
        }
        public void ZmenaKontaktniOsoby()
        {
            Task.Run(() =>
            {
                SeznamZamestnancu = Zamestnanec.SelectZamUseku(Reagujici.idUseku);
                KontrolaReakce();
            });
        }
        private void KontrolaReakce()
        {
            if (Reagujici != null && ZamestnanecNaPoptavku != null)
            {

                if (Reagujici.idUseku != ZamestnanecNaPoptavku.idUseku)
                {
                    ChybaReakce = true;
                    PopisChyby = "Vybraný zaměstnanec nespadá pod kontaktní osobu!";
                }
                else
                {
                    if (Reagujici.idUseku == vybranyInzerat.zadavajici.idUseku)
                    {
                        ChybaReakce = true;
                        PopisChyby = "Nelze zapůjčit zaměstnance na stejný úsek, na kterém pracuje!";
                    }
                    else
                        ChybaReakce = false;
                }
            }
        }
    }
}
