﻿using eTraining.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Data.OleDb;
using System.Globalization;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Excel = Microsoft.Office.Interop.Excel;

namespace eTraining.Helpers
{
    class PraceSExcel
    {
        private static DataTable ToDataTableSeznam(ObservableCollection<Zamestnanec> data)
        {
            DataTable exportTable = new DataTable();
            exportTable.Columns.Add(new DataColumn("Os. číslo", typeof(string)));
            exportTable.Columns.Add(new DataColumn("Příjmení", typeof(string)));
            exportTable.Columns.Add(new DataColumn("Jméno", typeof(string)));
            exportTable.Columns.Add(new DataColumn("Datum nástupu", typeof(string)));
            exportTable.Columns.Add(new DataColumn("Uzavřeno", typeof(string)));
            exportTable.Columns.Add(new DataColumn("Uzavřeno datum", typeof(DateTime)));
            foreach (var row in data)
            {
                DataRow dr = exportTable.NewRow();
                dr["Os. číslo"] = row.osCislo;
                dr["Příjmení"] = row.prijmeni;
                dr["Jméno"] = row.jmeno;
                dr["Datum nástupu"] = row.datumNastupu.ToShortDateString();
                dr["Uzavřeno"] = (row.uzavreno) ? "x" : "";
                if (row.uzavrenoDatum != null) dr["Uzavřeno datum"] = row.uzavrenoDatum;                
                exportTable.Rows.Add(dr);
            }
            return exportTable;
        }

        public static void ListToExcelSeznam(ObservableCollection<Zamestnanec> data)
        {
            DataTable dt = ToDataTableSeznam(data);
            Excel.Application excel = null;
            Excel.Workbook wb = null;

            object missing = Type.Missing;
            Excel.Worksheet ws = null;

            try
            {
                excel = new Excel.Application();
                wb = excel.Workbooks.Add();
                ws = (Excel.Worksheet)wb.ActiveSheet;

                for (int Idx = 0; Idx < dt.Columns.Count; Idx++)
                {
                    ws.Range["A1"].Offset[0, Idx].Value = dt.Columns[Idx].ColumnName;
                    ws.Range["A1"].Offset[0, Idx].Font.Bold = true;
                }

                for (int Idx = 0; Idx < dt.Rows.Count; Idx++)
                {  // <small>hey! I did not invent this line of code, 
                    // I found it somewhere on CodeProject.</small> 
                    // <small>It works to add the whole row at once, pretty cool huh?</small>
                    ws.Range["A2"].Offset[Idx].Resize[1, dt.Columns.Count].Value = dt.Rows[Idx].ItemArray;
                }

                ws.Columns.AutoFit();
                excel.Visible = true;
            }
            catch (COMException ex)
            {
                MessageBox.Show("Error accessing Excel: " + ex.ToString());
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error: " + ex.ToString());
            }
        }
    }
}
