﻿using System;
using System.Printing;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace eTraining.Helpers
{
    class TiskGrid
    {
        public static void Tisk(Grid grid, string nazevTisku, double height)
        {
            double puvodniHeight;
            puvodniHeight = grid.Height;
            ScrollViewer sv = FindVisualChild<ScrollViewer>(grid);
            if (sv.ComputedVerticalScrollBarVisibility == Visibility.Visible)
            {
                grid.Height = sv.ExtentHeight + 50;
            }
            else grid.Height = grid.ActualHeight;

            PrintDialog print = new PrintDialog();
            if (print.ShowDialog() == true)
            {

                PrintCapabilities capabilities = print.PrintQueue.GetPrintCapabilities(print.PrintTicket);

                double scale = Math.Min(capabilities.PageImageableArea.ExtentWidth / grid.ActualWidth,
                                        capabilities.PageImageableArea.ExtentHeight / grid.Height);

                Transform oldTransform = grid.LayoutTransform;

                grid.LayoutTransform = new ScaleTransform(scale, scale);

                Size oldSize = new Size(grid.ActualWidth, grid.Height);
                Size sz = new Size(capabilities.PageImageableArea.ExtentWidth, capabilities.PageImageableArea.ExtentHeight);
                grid.Measure(sz);
                ((UIElement)grid).Arrange(new Rect(new Point(capabilities.PageImageableArea.OriginWidth, capabilities.PageImageableArea.OriginHeight),
                    sz));

                print.PrintVisual(grid, nazevTisku);
                grid.LayoutTransform = oldTransform;
                grid.Measure(oldSize);
                ((UIElement)grid).Arrange(new Rect(new Point(0, 0),
                    oldSize));
            }

            grid.Height = puvodniHeight;
        }


        public static T FindVisualChild<T>(DependencyObject depObj) where T : DependencyObject
        {
            if (depObj != null)
            {
                for (int i = 0; i < VisualTreeHelper.GetChildrenCount(depObj); i++)
                {
                    DependencyObject child = VisualTreeHelper.GetChild(depObj, i);
                    if (child != null && child is T)
                    {
                        return (T)child;
                    }

                    T childItem = FindVisualChild<T>(child);
                    if (childItem != null) return childItem;
                }
            }
            return null;
        }
    }
}
