﻿using Support;
using eTraining.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    class CheckList
    {
        public int id { get; set; }
        public string otazka { get; set; }
        public bool aktivni { get; set; }
        public int zalozka { get; set; }
        public DateTime datumZadani { get; set; }
        public int idUseku { get; set; }
        public static ObservableCollection<CheckList> SelectCheckList(int zalozka)
        {

            ObservableCollection<CheckList> seznam = new ObservableCollection<CheckList>();
            String sqlStr = "SELECT * FROM CheckList WHERE zalozka = " + zalozka + " AND idUseku = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    CheckList checkList;

                    while (reader.Read())
                    {
                        checkList = new CheckList();
                        checkList.id = reader.GetInt32(0);
                        checkList.otazka = reader.GetValue(1).ToString();
                        checkList.aktivni = reader.GetBoolean(2);
                        checkList.zalozka = reader.GetInt32(3);
                        checkList.datumZadani = reader.GetDateTime(4);

                        seznam.Add(checkList);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static ObservableCollection<CheckList> VlozitCheckList(ObservableCollection<CheckList> checkListy)
        {
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;
                    foreach (CheckList checkList in checkListy)
                    {

                        sqlStr = "UPDATE CheckList SET otazka=@otazka, aktivni=@aktivni, zalozka=@zalozka, datumZadani=@datumZadani, idUseku=@idUseku WHERE id = " + checkList.id
                        + " IF @@ROWCOUNT=0 INSERT INTO CheckList (otazka, aktivni, zalozka, datumZadani, idUseku) VALUES (@otazka, @aktivni, @zalozka, @datumZadani, @idUseku) SELECT SCOPE_IDENTITY();";
                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.Parameters.AddWithValue("@otazka", checkList.otazka);
                        cmd.Parameters.AddWithValue("@aktivni", checkList.aktivni);
                        cmd.Parameters.AddWithValue("@zalozka", checkList.zalozka);
                        cmd.Parameters.AddWithValue("@datumZadani", checkList.datumZadani);
                        cmd.Parameters.AddWithValue("@idUseku", Properties.Settings.Default.idUseku);
                       

                        if (checkList.id != 0)
                        {
                            cmd.ExecuteNonQuery();
                        }
                        else checkList.id = Convert.ToInt32(cmd.ExecuteScalar());
                        cmd.Dispose();
                    }
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return checkListy;
            }
        }
        public static bool EditaceCheckListu(CheckList checkList)
        {
            bool test = true;
            String sqlStr = "UPDATE CheckList SET otazka=@otazka, aktivni=@aktivni, zalozka=@zalozka, datumZadani=@datumZadani WHERE id = " + checkList.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@otazka", checkList.otazka);
                    cmd.Parameters.AddWithValue("@aktivni", checkList.aktivni);
                    cmd.Parameters.AddWithValue("@zalozka", checkList.zalozka);
                    cmd.Parameters.AddWithValue("@datumZadani", checkList.datumZadani);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = true;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }

        }
        public static bool SmazatCheckListy(ObservableCollection<CheckList> checkListy)
        {
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;
                    foreach (CheckList checkList in checkListy)
                    {

                        sqlStr = "DELETE FROM CheckList WHERE id = " + checkList.id;

                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.ExecuteNonQuery();
                        cmd.Dispose();
                    }
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    return false;
                }
                finally
                {
                    conn.Close();
                }
                return true;
            }
        }
    }
}
