﻿using Support;
using eTraining.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class CheckListStanice
    {
        public int id { get; set; }
        public int idZam { get; set; }
        public string stanice { get; set; }
        public bool seznamen { get; set; }
        public int hodnoceni { get; set; }
        public string poznamka { get; set; }
        public DateTime datumVlozeni { get; set; }

        public static ObservableCollection<CheckListStanice> SelectCheckListStaniceZam(int idZam)
        {

            ObservableCollection<CheckListStanice> seznam = new ObservableCollection<CheckListStanice>();
            String sqlStr = "SELECT * FROM CheckListStanice WHERE idZam = " + idZam;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    CheckListStanice checkList;

                    while (reader.Read())
                    {
                        checkList = new CheckListStanice();
                        checkList.id = reader.GetInt32(0);
                        checkList.idZam = reader.GetInt32(1);
                        checkList.stanice = reader.GetValue(2).ToString();
                        checkList.seznamen = reader.GetBoolean(3);
                        checkList.hodnoceni = reader.GetInt32(4);
                        checkList.poznamka = reader.GetValue(5).ToString();
                        checkList.datumVlozeni = reader.GetDateTime(6);

                        seznam.Add(checkList);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        
        public static ObservableCollection<CheckListStanice> VlozitCheckListStanicZam(ObservableCollection<CheckListStanice> checkListy)
        {
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;

                    foreach (CheckListStanice checkList in checkListy)
                    {
                        
                        sqlStr = "UPDATE CheckListStanice SET idZam=@idZam, stanice=@stanice, seznamen=@seznamen, hodnoceni=@hodnoceni, poznamka=@poznamka, datumVlozeni=@datumVlozeni WHERE id = " + checkList.id
                        + " IF @@ROWCOUNT=0 INSERT INTO CheckListStanice (idZam, stanice, seznamen, hodnoceni, poznamka, datumVlozeni) VALUES (@idZam, @stanice, @seznamen, @hodnoceni, @poznamka, @datumVlozeni) SELECT SCOPE_IDENTITY();";
                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.Parameters.AddWithValue("@idZam", checkList.idZam);
                        cmd.Parameters.AddWithValue("@stanice", checkList.stanice);
                        cmd.Parameters.AddWithValue("@seznamen", checkList.seznamen);
                        cmd.Parameters.AddWithValue("@hodnoceni", checkList.hodnoceni);
                        if (checkList.poznamka != null) cmd.Parameters.AddWithValue("@poznamka", checkList.poznamka);
                        else cmd.Parameters.AddWithValue("@poznamka", DBNull.Value);
                        cmd.Parameters.AddWithValue("@datumVlozeni", checkList.datumVlozeni);

                        if (checkList.id != 0)
                        {
                            cmd.ExecuteNonQuery();
                        }
                        else checkList.id = Convert.ToInt32(cmd.ExecuteScalar());
                        cmd.Dispose();
                    }

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return checkListy;
            }
        }
        public static bool SmazatStanice(ObservableCollection<CheckListStanice> checkListy)
        {
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;
                    foreach (CheckListStanice checkList in checkListy)
                    {

                        sqlStr = "DELETE FROM CheckListStanice WHERE id = " + checkList.id;

                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.ExecuteNonQuery();
                        cmd.Dispose();
                    }
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    return false;
                }
                finally
                {
                    conn.Close();
                }
                return true;
            }
        }
    }
}
