﻿using Support;
using eTraining.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class CheckListZam 
    {
        public int id { get; set; }
        public int idZam { get; set; }
        public string otazka { get; set; }
        public int splneno { get; set; }
        public int zalozka { get; set; }
        public DateTime datumZadani { get; set; }

        public static ObservableCollection<CheckListZam> SelectCheckListZam(int idZam, int zalozka)
        {

            ObservableCollection<CheckListZam> seznam = new ObservableCollection<CheckListZam>();
            String sqlStr = "SELECT * FROM CheckListZam WHERE idZam = " + idZam + " AND zalozka = " + zalozka;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    CheckListZam checkList;

                    while (reader.Read())
                    {
                        checkList = new CheckListZam();
                        checkList.id = reader.GetInt32(0);
                        checkList.idZam= reader.GetInt32(1);
                        checkList.otazka = reader.GetValue(2).ToString();
                        checkList.zalozka = reader.GetInt32(3);
                        checkList.splneno = reader.GetInt32(4);

                        seznam.Add(checkList);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static ObservableCollection<CheckListZam> SelectCheckListProNovehoZam(int idZam)
        {

            ObservableCollection<CheckListZam> seznam = new ObservableCollection<CheckListZam>();
            String sqlStr = "SELECT otazka, zalozka FROM CheckList WHERE idUseku = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    CheckListZam checkList;

                    while (reader.Read())
                    {
                        checkList = new CheckListZam();
                        checkList.otazka = reader.GetValue(0).ToString();           
                        checkList.zalozka = reader.GetInt32(1);
                        checkList.idZam = idZam;

                        seznam.Add(checkList);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static void VlozitPrvniDataProKartu(ObservableCollection<CheckListZam> checkListy)
        {
            String sqlStr = "INSERT INTO CheckListZam (idZam, otazka, zalozka, splneno) VALUES (@idZam, @otazka, @zalozka, @splneno)";
                

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    foreach (CheckListZam checkList in checkListy)
                    {
                        cmd.Parameters.Clear();
                        cmd.Parameters.AddWithValue("@idZam", checkList.idZam);
                        cmd.Parameters.AddWithValue("@otazka", checkList.otazka);
                        cmd.Parameters.AddWithValue("@zalozka", checkList.zalozka);
                        cmd.Parameters.AddWithValue("@splneno", checkList.splneno);

                        cmd.ExecuteNonQuery();
                        cmd.Dispose();
                    }
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
        public static bool EditaceCheckListuZam(CheckListZam checkList)
        {
            bool test = true;
            String sqlStr = "UPDATE CheckListZam SET idZam=@idZam, otazka=@otazka, zalozka=@zalozka, splneno=@splneno WHERE id = " + checkList.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@idZam", checkList.idZam);
                    cmd.Parameters.AddWithValue("@otazka", checkList.otazka);
                    cmd.Parameters.AddWithValue("@zalozka", checkList.zalozka);
                    cmd.Parameters.AddWithValue("@splneno", checkList.splneno);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool EditaceHromadnaCheckListuZam(ObservableCollection<CheckListZam> checkListy)
        {
            bool test = true;
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;

                    foreach (CheckListZam checkList in checkListy)
                    {
                        sqlStr = "UPDATE CheckListZam SET idZam=@idZam, otazka=@otazka, zalozka=@zalozka, splneno=@splneno WHERE id = " + checkList.id;
                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.Parameters.AddWithValue("@idZam", checkList.idZam);
                        cmd.Parameters.AddWithValue("@otazka", checkList.otazka);
                        cmd.Parameters.AddWithValue("@zalozka", checkList.zalozka);
                        cmd.Parameters.AddWithValue("@splneno", checkList.splneno);

                        cmd.ExecuteNonQuery();
                        cmd.Dispose();
                    }

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
    }
}
