﻿using eTraining.ViewModels;
using System;
using Support;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class Hodnoceni: ViewModelBase
    {
        public int id { get; set; }
        public int idZam { get; set; }
        private string _poznamka;
        private int _hodnoceniStanic;
        private bool _chlPrvniDen;
        private bool _chlPravidla;
        private bool _chlStanice;
        private int _pocetStanic;
        private bool _uzavreno;
        private DateTime _datumHodnoceni;
        private int _pocetSeznamen;
        public string poznamka
        {
            get { return _poznamka; }
            set
            {
                if (_poznamka == value)
                    return;
                _poznamka = value;
                OnPropertyChanged("poznamka");
            }
        }
        public int hodnoceniStanic
        {
            get { return _hodnoceniStanic; }
            set
            {
                if (_hodnoceniStanic == value)
                    return;
                _hodnoceniStanic = value;
                OnPropertyChanged("hodnoceniStanic");
            }
        }
        public bool chlPrvniDen
        {
            get { return _chlPrvniDen; }
            set
            {
                if (_chlPrvniDen == value)
                    return;
                _chlPrvniDen = value;
                OnPropertyChanged("chlPrvniDen");
            }
        }
        public bool chlPravidla
        {
            get { return _chlPravidla; }
            set
            {
                if (_chlPravidla == value)
                    return;
                _chlPravidla = value;
                OnPropertyChanged("chlPravidla");
            }
        }
        public bool chlStanice
        {
            get { return _chlStanice; }
            set
            {
                if (_chlStanice == value)
                    return;
                _chlStanice = value;
                OnPropertyChanged("chlStanice");
            }
        }
        public int pocetStanic
        {
            get { return _pocetStanic; }
            set
            {
                if (_pocetStanic == value)
                    return;
                _pocetStanic = value;
                OnPropertyChanged("pocetStanic");
            }
        }
        public bool uzavreno
        {
            get { return _uzavreno; }
            set
            {
                if (_uzavreno == value)
                    return;
                _uzavreno = value;
                OnPropertyChanged("uzavreno");
            }
        }
        public DateTime datumHodnoceni
        {
            get { return _datumHodnoceni; }
            set
            {
                if (_datumHodnoceni == value)
                    return;
                _datumHodnoceni = value;
                OnPropertyChanged("datumHodnoceni");
            }
        }
        public int pocetSeznamen
        {
            get { return _pocetSeznamen; }
            set
            {
                if (_pocetSeznamen == value)
                    return;
                _pocetSeznamen = value;
                OnPropertyChanged("pocetSeznamen");
            }
        }
        public static ObservableCollection<Hodnoceni> SelectHistorieHodnoceniZam(int idZam)
        {

            ObservableCollection<Hodnoceni> seznam = new ObservableCollection<Hodnoceni>();
            String sqlStr = "SELECT * FROM Hodnoceni WHERE idZam = " + idZam + " AND uzavreno = 1";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Hodnoceni hodnoceni;

                    while (reader.Read())
                    {
                        hodnoceni = new Hodnoceni();
                        hodnoceni.id = reader.GetInt32(0);
                        hodnoceni.idZam = reader.GetInt32(1);
                        hodnoceni.poznamka = reader.GetValue(2).ToString();
                        hodnoceni.hodnoceniStanic = reader.GetInt32(3);
                        hodnoceni.chlPrvniDen = reader.GetBoolean(4);
                        hodnoceni.chlPravidla = reader.GetBoolean(5);
                        hodnoceni.chlStanice = reader.GetBoolean(6);
                        hodnoceni.pocetStanic = reader.GetInt32(7);
                        hodnoceni.uzavreno = reader.GetBoolean(8);
                        if (reader.GetValue(9) != DBNull.Value) hodnoceni.datumHodnoceni = reader.GetDateTime(9);


                        seznam.Add(hodnoceni);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static ObservableCollection<Hodnoceni> SelectVsechnaHodnoceniZam(int idZam)
        {

            ObservableCollection<Hodnoceni> seznam = new ObservableCollection<Hodnoceni>();
            String sqlStr = "SELECT * FROM Hodnoceni WHERE idZam = " + idZam + " ORDER BY uzavreno DESC, id";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Hodnoceni hodnoceni;

                    while (reader.Read())
                    {
                        hodnoceni = new Hodnoceni();
                        hodnoceni.id = reader.GetInt32(0);
                        hodnoceni.idZam = reader.GetInt32(1);
                        hodnoceni.poznamka = reader.GetValue(2).ToString();
                        hodnoceni.hodnoceniStanic = reader.GetInt32(3);
                        hodnoceni.chlPrvniDen = reader.GetBoolean(4);
                        hodnoceni.chlPravidla = reader.GetBoolean(5);
                        hodnoceni.chlStanice = reader.GetBoolean(6);
                        hodnoceni.pocetStanic = reader.GetInt32(7);
                        hodnoceni.uzavreno = reader.GetBoolean(8);
                        if (reader.GetValue(9) != DBNull.Value) hodnoceni.datumHodnoceni = reader.GetDateTime(9);


                        seznam.Add(hodnoceni);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static Hodnoceni SelectAktualniHodnoceniZam(int idZam)
        {

            Hodnoceni hodnoceni = new Hodnoceni();
            String sqlStr = "SELECT * FROM Hodnoceni WHERE idZam = " + idZam + " AND uzavreno = 0";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        hodnoceni = new Hodnoceni();
                        hodnoceni.id = reader.GetInt32(0);
                        hodnoceni.idZam = reader.GetInt32(1);
                        hodnoceni.poznamka = reader.GetValue(2).ToString();
                        hodnoceni.hodnoceniStanic = reader.GetInt32(3);
                        hodnoceni.chlPrvniDen = reader.GetBoolean(4);
                        hodnoceni.chlPravidla = reader.GetBoolean(5);
                        hodnoceni.chlStanice = reader.GetBoolean(6);
                        hodnoceni.pocetStanic = reader.GetInt32(7);
                        hodnoceni.uzavreno = reader.GetBoolean(8);
                        if (reader.GetValue(9) != DBNull.Value) hodnoceni.datumHodnoceni = reader.GetDateTime(9);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return hodnoceni;
        }
        public static void VlozitPrvniHodnoceni(int idZam)
        {
            String sqlStr = "INSERT INTO Hodnoceni (idZam, hodnoceniStanic, chlPrvniDen, chlPravidla, chlStanice, pocetStanic, uzavreno) VALUES (" + idZam + ", 0, 0, 0, 0, 1, 0)";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }

        public static int VlozitNoveHodnoceni(Hodnoceni hodnoceni)
        {
            int idHod = 0;
            String sqlStr = "INSERT INTO Hodnoceni (idZam, hodnoceniStanic, chlPrvniDen, chlPravidla, chlStanice, pocetStanic, uzavreno) VALUES (@idZam, @hodnoceniStanic, @chlPrvniDen, @chlPravidla, @chlStanice, @pocetStanic, @uzavreno) SELECT SCOPE_IDENTITY();";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@idZam", hodnoceni.idZam);
                    cmd.Parameters.AddWithValue("@hodnoceniStanic", hodnoceni.hodnoceniStanic);
                    cmd.Parameters.AddWithValue("@chlPrvniDen", hodnoceni.chlPrvniDen);
                    cmd.Parameters.AddWithValue("@chlPravidla", hodnoceni.chlPravidla);
                    cmd.Parameters.AddWithValue("@chlStanice", hodnoceni.chlStanice);
                    cmd.Parameters.AddWithValue("@pocetStanic", hodnoceni.pocetStanic);
                    cmd.Parameters.AddWithValue("@uzavreno", 0);
                    idHod = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();

                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                
            }
            return idHod;
        }

        public static Hodnoceni UlozitHodnoceni(Hodnoceni hodnoceni, bool uzavrit)
        {
            String sqlStr = "UPDATE Hodnoceni SET poznamka=@poznamka, hodnoceniStanic=@hodnoceniStanic, chlPrvniDen=@chlPrvniDen, chlPravidla=@chlPravidla, chlStanice=@chlStanice, pocetStanic=@pocetStanic, uzavreno=@uzavreno, datumHodnoceni=@datumHodnoceni WHERE id = " + hodnoceni.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    
                    if (hodnoceni.poznamka != null) cmd.Parameters.AddWithValue("@poznamka", hodnoceni.poznamka);
                    else cmd.Parameters.AddWithValue("@poznamka", DBNull.Value);
                    cmd.Parameters.AddWithValue("@hodnoceniStanic", hodnoceni.hodnoceniStanic);
                    cmd.Parameters.AddWithValue("@chlPrvniDen", hodnoceni.chlPrvniDen);
                    cmd.Parameters.AddWithValue("@chlPravidla", hodnoceni.chlPravidla);
                    cmd.Parameters.AddWithValue("@chlStanice", hodnoceni.chlStanice);
                    cmd.Parameters.AddWithValue("@pocetStanic", hodnoceni.pocetStanic);
                    cmd.Parameters.AddWithValue("@uzavreno", uzavrit);
                    if (uzavrit) cmd.Parameters.AddWithValue("@datumHodnoceni", DateTime.Now);
                    else cmd.Parameters.AddWithValue("@datumHodnoceni", DBNull.Value);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return hodnoceni;
            }
        }
    }
}