﻿using Support;
using eTraining.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class MaskaStanic: ViewModelBase
    {
        public int id { get; set; }
        private string _nazev;
        public int idUseku { get; set; }
        private ObservableCollection<Stanice> _seznamStanic;


        public string nazev
        {
            get { return _nazev; }
            set
            {
                if (_nazev == value)
                    return;
                _nazev = value;
                OnPropertyChanged("nazev");
            }
        }
        public ObservableCollection<Stanice> seznamStanic
        {
            get { return _seznamStanic; }
            set
            {
                if (_seznamStanic == value)
                    return;
                _seznamStanic = value;
                OnPropertyChanged("seznamStanic");
            }
        }
        public static ObservableCollection<MaskaStanic> SelectMasky()
        {

            ObservableCollection<MaskaStanic> seznam = new ObservableCollection<MaskaStanic>();
            String sqlStr = "SELECT * FROM MaskaStanic WHERE idUseku = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    MaskaStanic maska;

                    while (reader.Read())
                    {
                        maska = new MaskaStanic();
                        maska.id = reader.GetInt32(0);
                        maska.nazev = reader.GetValue(1).ToString();
                        maska.idUseku = reader.GetInt32(2);

                        seznam.Add(maska);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static MaskaStanic VlozitMasku(MaskaStanic maska)
        {
            String sqlStr = "UPDATE MaskaStanic SET nazev=@nazev, idUseku=@idUseku WHERE id = " + maska.id
                        + " IF @@ROWCOUNT=0 INSERT INTO MaskaStanic (nazev, idUseku) VALUES (@nazev, @idUseku) SELECT SCOPE_IDENTITY();";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@nazev", maska.nazev);
                    cmd.Parameters.AddWithValue("@idUseku", Properties.Settings.Default.idUseku);

                    if (maska.id != 0)
                    {
                        cmd.ExecuteNonQuery();
                    }
                    else maska.id = Convert.ToInt32(cmd.ExecuteScalar());

                    cmd.Dispose();
                    
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return maska;
            }
        }

        public static bool SmazatMasku(int idMasky)
        {
            String sqlStr = "DELETE FROM MaskaStanic WHERE id = " + idMasky
                + " DELETE FROM Stanice WHERE idMasky = " + idMasky;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd= new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    return false;
                }
                finally
                {
                    conn.Close();
                }
                return true;
            }
        }
    }
}
