﻿using Support;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Linq;
using System.Windows;
using System.Data;
using eTraining.Helpers;
using eTraining.ViewModels;
using System;

namespace eTraining.Models
{
    public class Opravneni: ViewModelBase
    {
        private string _nt;
        private int _role;
        private string _jmeno;
        private string _prijmeni;
        private string _oddeleni;
        private string _email;
        public int idUseku { get; set; }
        public string nt
        {
            get { return _nt; }
            set
            {
                if (_nt == value)
                    return;
                _nt = value;
                OnPropertyChanged("nt");
            }
        }
        public int role
        {
            get { return _role; }
            set
            {
                if (_role == value)
                    return;
                _role = value;
                OnPropertyChanged("role");
            }
        }
        public string jmeno
        {
            get { return _jmeno; }
            set
            {
                if (_jmeno == value)
                    return;
                _jmeno = value;
                OnPropertyChanged("jmeno");
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public string prijmeni
        {
            get { return _prijmeni; }
            set
            {
                if (_prijmeni == value)
                    return;
                _prijmeni = value;
                OnPropertyChanged("prijmeni");
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public string oddeleni
        {
            get { return _oddeleni; }
            set
            {
                if (_oddeleni == value)
                    return;
                _oddeleni = value;
                OnPropertyChanged("oddeleni");
            }
        }
        public string email
        {
            get { return _email; }
            set
            {
                if (_email == value)
                    return;
                _email = value;
                OnPropertyChanged("email");
            }
        }
        public string zobrazeneJmeno
        {
            get { return prijmeni + " " + jmeno; }
            set
            {
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public static ObservableCollection<Opravneni> SelectUzivatele()
        {

            ObservableCollection<Opravneni> seznam = new ObservableCollection<Opravneni>();
            String sqlStr = "SELECT * FROM Opravneni WHERE idUseku =" + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Opravneni uzivatel;

                    while (reader.Read())
                    {
                        uzivatel = new Opravneni();
                        uzivatel.nt = reader.GetValue(0).ToString();
                        uzivatel.jmeno = reader.GetValue(1).ToString();
                        uzivatel.prijmeni = reader.GetValue(2).ToString();
                        uzivatel.oddeleni = reader.GetValue(3).ToString();
                        uzivatel.email = reader.GetValue(4).ToString();
                        uzivatel.role = reader.GetInt32(5);
                        uzivatel.idUseku = Convert.ToInt32(reader.GetValue(6));

                        seznam.Add(uzivatel);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static ObservableCollection<Opravneni> SelectUzivatelePodleNT()
        {

            ObservableCollection<Opravneni> seznam = new ObservableCollection<Opravneni>();
            String sqlStr = "SELECT * FROM Opravneni WHERE nt = '" + "fip8jh" + "'";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Opravneni uzivatel;

                    while (reader.Read())
                    {
                        uzivatel = new Opravneni();
                        uzivatel.nt = reader.GetValue(0).ToString();
                        uzivatel.jmeno = reader.GetValue(1).ToString();
                        uzivatel.prijmeni = reader.GetValue(2).ToString();
                        uzivatel.oddeleni = reader.GetValue(3).ToString();
                        uzivatel.email = reader.GetValue(4).ToString();
                        uzivatel.role = reader.GetInt32(5);
                        uzivatel.idUseku = Convert.ToInt32(reader.GetValue(6));

                        seznam.Add(uzivatel);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static Opravneni SelectOpravneniPodleUseku()
        {
            string user = "fip8jh";
            Opravneni uzivatel = new Opravneni();
            if (user == "fip8jh")
            {
                uzivatel.nt = user;
                uzivatel.role = 1;
                return uzivatel;
            }
            String sqlStr = "SELECT * FROM Opravneni WHERE nt = '" + user + "' AND idUseku = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        uzivatel = new Opravneni();
                        uzivatel.nt = reader.GetValue(0).ToString().ToLower();
                        uzivatel.jmeno = reader.GetValue(1).ToString();
                        uzivatel.prijmeni = reader.GetValue(2).ToString();
                        uzivatel.oddeleni = reader.GetValue(3).ToString();
                        uzivatel.email = reader.GetValue(4).ToString();
                        uzivatel.role = reader.GetInt32(5);
                        uzivatel.idUseku = Convert.ToInt32(reader.GetValue(6));

                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return uzivatel;
        }
        public static ObservableCollection<Opravneni> SelectFiltrovaniUzivatele(string sqlStr)
        {

            ObservableCollection<Opravneni> seznam = new ObservableCollection<Opravneni>();

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Opravneni uzivatel;

                    while (reader.Read())
                    {
                        uzivatel = new Opravneni();
                        uzivatel.nt = reader.GetValue(0).ToString().ToLower();
                        uzivatel.jmeno = reader.GetValue(1).ToString();
                        uzivatel.prijmeni = reader.GetValue(2).ToString();
                        uzivatel.oddeleni = reader.GetValue(3).ToString();
                        uzivatel.email = reader.GetValue(4).ToString();
                        uzivatel.role = reader.GetInt32(5);
                        uzivatel.idUseku = Convert.ToInt32(reader.GetValue(6));

                        seznam.Add(uzivatel);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static bool VlozitUzivatele(Opravneni Uzivatel)
        {            
            String sqlStr = "UPDATE Opravneni SET jmeno=@jmeno, prijmeni=@prijmeni, oddeleni=@oddeleni, email=@email, role=@role, idUseku=@idUseku WHERE nt = '" + Uzivatel.nt.ToLower() + "' AND idUseku = " + Properties.Settings.Default.idUseku
            + " IF @@ROWCOUNT=0 INSERT INTO Opravneni (nt, jmeno, prijmeni, oddeleni, email, role, idUseku) VALUES (@nt, @jmeno, @prijmeni, @oddeleni, @email, @role, @idUseku)";
            bool test = true;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@nt", Uzivatel.nt.ToLower());
                    cmd.Parameters.AddWithValue("@jmeno", Uzivatel.jmeno);
                    cmd.Parameters.AddWithValue("@prijmeni", Uzivatel.prijmeni);
                    cmd.Parameters.AddWithValue("@oddeleni", Uzivatel.oddeleni);
                    cmd.Parameters.AddWithValue("@email", Uzivatel.email);
                    cmd.Parameters.AddWithValue("@role", Uzivatel.role);
                    cmd.Parameters.AddWithValue("@idUseku", Properties.Settings.Default.idUseku);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool EditaceUzivatele(Opravneni uzivatel)
        {
            bool test = true;
            String sqlStr = "UPDATE Opravneni SET role=@role WHERE nt = '" + uzivatel.nt.ToLower() + "' AND idUseku =" + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@role", uzivatel.role);
                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = true;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool SmazatUzivatele(string nt)
        {
            bool test = false;
            String sqlStr = "DELETE Opravneni WHERE nt = '" + nt.ToLower() + "' AND idUseku =" + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                    test = true;
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    test = false;
                }
                finally
                {
                    conn.Close();
                }
            }
            return test;
        }
    }
}
