﻿using Support;
using eTraining.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class SmenovyModel : ViewModelBase
    {
        public int id { get; set; }
        private string _nazev;

        public string nazev
        {
            get { return _nazev; }
            set
            {
                if (_nazev == value)
                    return;
                _nazev = value;
                OnPropertyChanged("nazev");
            }
        }

        public SmenovyModel() { }
        public SmenovyModel(SmenovyModel smena)
        {
            this.id = smena.id;
            this.nazev = smena.nazev;
        }

        public static ObservableCollection<SmenovyModel> SelectSmenoveModelyProCB()
        {
            ObservableCollection<SmenovyModel> seznam = new ObservableCollection<SmenovyModel>();

            String sqlStr = "SELECT id, nazev FROM Matice_SmenovyModel";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    SmenovyModel item;

                    while (reader.Read())
                    {
                        item = new SmenovyModel();
                        item.id = reader.GetInt32(0);
                        item.nazev = reader.GetValue(1).ToString();

                        seznam.Add(item);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
    }
}

