﻿using Support;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class Stanice
    {
        public int id { get; set; }
        public string nazev { get; set; }
        public int idMasky { get; set; }

        public static ObservableCollection<Stanice> SelectStaniceMasek(ObservableCollection<MaskaStanic> seznamMasek)
        {
            ObservableCollection<Stanice> seznam = new ObservableCollection<Stanice>();
            if (seznamMasek == null || seznamMasek.Count == 0) return seznam;

            String sqlStr = "SELECT * FROM Stanice WHERE "
                + " idMasky IN (";

            foreach (var item in seznamMasek)
            {
                sqlStr += "'" + item.id + "',";
            }
            sqlStr = sqlStr.Remove(sqlStr.Length - 1);
            sqlStr += " )"

            + " ORDER BY nazev";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Stanice stanice;

                    while (reader.Read())
                    {
                        stanice = new Stanice();
                        stanice.id = reader.GetInt32(0);
                        stanice.nazev = reader.GetValue(1).ToString();
                        stanice.idMasky = reader.GetInt32(2);

                        seznam.Add(stanice);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }

        public static ObservableCollection<Stanice> VlozitStanice(ObservableCollection<Stanice> seznam, int idMasky)
        {
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;
                    foreach (Stanice stanice in seznam)
                    {

                        sqlStr = "UPDATE Stanice SET nazev=@nazev, idMasky=@idMasky WHERE id = " + stanice.id
                        + " IF @@ROWCOUNT=0 INSERT INTO Stanice (nazev, idMasky) VALUES (@nazev, @idMasky) SELECT SCOPE_IDENTITY();";
                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.Parameters.AddWithValue("@nazev", stanice.nazev);
                        cmd.Parameters.AddWithValue("@idMasky", idMasky);

                        if (stanice.id != 0)
                        {
                            cmd.ExecuteNonQuery();
                        }
                        else stanice.id = Convert.ToInt32(cmd.ExecuteScalar());
                        cmd.Dispose();
                    }
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return seznam;
            }
        }
        public static bool SmazatStanice(ObservableCollection<Stanice> seznam)
        {
            String sqlStr;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd;
                    foreach (Stanice stanice in seznam)
                    {

                        sqlStr = "DELETE FROM Stanice WHERE id = " + stanice.id;

                        cmd = new SqlCommand(sqlStr, conn);

                        cmd.Parameters.Clear();
                        cmd.ExecuteNonQuery();
                        cmd.Dispose();
                    }
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                    return false;
                }
                finally
                {
                    conn.Close();
                }
                return true;
            }
        }
    }
}
