﻿using Support;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class Usek
    {
        public int id { get; set; }
        public string nazev { get; set; }
        public string poznamka { get; set; }
        public string zaskolovaciInstrukce { get; set; }
        public string priruckyMA { get; set; }
        public string manual { get; set; }
        public bool povoleno { get; set; }
        public bool nastupniPokyny { get; set; }
        public bool proskoleniStanic { get; set; }
        public bool pravidla { get; set; }
        public bool vyhodnoceni { get; set; }
        public bool kontrolaSkoliteleStanice { get; set; }
        public int pocetZam { get; set; }
        public int pocetZaskoleni { get; set; }
        public static ObservableCollection<Usek> SelectUseky()
        {

            ObservableCollection<Usek> seznam = new ObservableCollection<Usek>();
            String sqlStr = "SELECT * FROM Usek";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Usek usek;

                    while (reader.Read())
                    {
                        usek = new Usek();
                        usek.id = reader.GetInt32(0);
                        usek.nazev = reader.GetValue(1).ToString();
                        usek.poznamka = reader.GetValue(2).ToString();
                        usek.zaskolovaciInstrukce = reader.GetValue(3).ToString();
                        usek.priruckyMA = reader.GetValue(4).ToString();
                        usek.nastupniPokyny = reader.GetBoolean(5);
                        usek.proskoleniStanic = reader.GetBoolean(6);
                        usek.pravidla = reader.GetBoolean(7);
                        usek.vyhodnoceni = reader.GetBoolean(8);
                        usek.manual = reader.GetValue(9).ToString();
                        usek.kontrolaSkoliteleStanice = reader.GetBoolean(10);
                        seznam.Add(usek);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static Usek SelectUsekPodleID(int idUseku)
        {

            Usek usek = new Usek();
            String sqlStr = "SELECT * FROM Usek WHERE id = " + idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        usek = new Usek();
                        usek.id = reader.GetInt32(0);
                        usek.nazev = reader.GetValue(1).ToString();
                        usek.poznamka = reader.GetValue(2).ToString();
                        usek.zaskolovaciInstrukce = reader.GetValue(3).ToString();
                        usek.priruckyMA = reader.GetValue(4).ToString();
                        usek.nastupniPokyny = reader.GetBoolean(5);
                        usek.proskoleniStanic = reader.GetBoolean(6);
                        usek.pravidla = reader.GetBoolean(7);
                        usek.vyhodnoceni = reader.GetBoolean(8);
                        usek.manual = reader.GetValue(9).ToString();
                        usek.kontrolaSkoliteleStanice = reader.GetBoolean(10);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return usek;
        }

        public static ObservableCollection<Usek> SelectUsekyPodleNT(string ntUser)
        {
            ObservableCollection<Usek> seznam = new ObservableCollection<Usek>();
            Usek usek;
            String sqlStr = "SELECT a.id, a.nazev, a.poznamka, a.zaskolovaciInstrukce, a.priruckyMA, a.nastupniPokyny, a.proskoleniStanic, a.pravidla, a.vyhodnoceni, a.manual, COUNT(c.id) FROM Usek AS a "
                + "JOIN Opravneni AS b ON a.id = b.idUseku "
                + "JOIN Zamestnanec AS c ON c.idUseku = a.id "
                + "WHERE b.nt = '" + ntUser + "' AND c.aktivni = 1 "
                + "GROUP BY a.id, a.nazev, a.poznamka, a.zaskolovaciInstrukce, a.priruckyMA, a.nastupniPokyny, a.proskoleniStanic, a.pravidla, a.vyhodnoceni, a.manual";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        usek = new Usek();
                        usek.id = reader.GetInt32(0);
                        usek.nazev = reader.GetValue(1).ToString();
                        usek.poznamka = reader.GetValue(2).ToString();
                        usek.zaskolovaciInstrukce = reader.GetValue(3).ToString();
                        usek.priruckyMA = reader.GetValue(4).ToString();
                        usek.nastupniPokyny = reader.GetBoolean(5);
                        usek.proskoleniStanic = reader.GetBoolean(6);
                        usek.pravidla = reader.GetBoolean(7);
                        usek.vyhodnoceni = reader.GetBoolean(8);
                        usek.manual = reader.GetValue(9).ToString();
                        usek.pocetZam = reader.GetInt32(10);
                        seznam.Add(usek);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static string SelectZaskolovaciInstrukcePath()
        {

            string instrukcePath = "";
            String sqlStr = "SELECT zaskolovaciInstrukce FROM Usek WHERE id = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        instrukcePath = reader.GetValue(0).ToString();
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return instrukcePath;
        }
        public static string SelectPriruckyMAPath()
        {

            string priruckyPath = "";
            String sqlStr = "SELECT priruckyMA FROM Usek WHERE id = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        priruckyPath = reader.GetValue(0).ToString();
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return priruckyPath;
        }

        public static string SelecManualPath()
        {

            string priruckyPath = "";
            String sqlStr = "SELECT manual FROM Usek WHERE id = " + Properties.Settings.Default.idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        priruckyPath = reader.GetValue(0).ToString();
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return priruckyPath;
        }
    }
}
