﻿using Support;
using eTraining.ViewModels;
using System;
using System.Collections.ObjectModel;
using System.Data.SqlClient;
using System.Windows;

namespace eTraining.Models
{
    public class Zamestnanec : ViewModelBase
    {
        private int _id;
        private string _osCislo;
        private string _jmeno;
        private string _prijmeni;
        private string _stredisko;
        private DateTime _datumNastupu;
        private string _kategorie;
        private string _smenovyModel;
        private string _pozice;
        private string _pohlavi;
        public string ulozil { get; set; }
        public DateTime casUlozeni { get; set; }
        public string ocSkolitele { get; set; }
        public string jmenoSkolitele { get; set; }
        public string linka { get; set; }
        private bool _uzavreno;
        private DateTime? _uzavrenoDatum;
        private string _poznamka;
        public int idUseku { get; set; }
        private ObservableCollection<Hodnoceni> _seznamHodnoceni;
        private DateTime? _terminZaskoleni;
        private bool _aktivni;
        public int _verzeZaskoleni;
        public int pocetDniZaskoleni { get; set; }

        public Zamestnanec() { }
        public Zamestnanec(Zamestnanec zam)
        {
            _id = zam.id;
            _osCislo = zam.osCislo;
            _jmeno = zam.jmeno;
            _prijmeni = zam.prijmeni;
            _stredisko = zam.stredisko;
            _datumNastupu = zam.datumNastupu;
            _kategorie = zam.kategorie;
            _smenovyModel = zam.smenovyModel;
            _pozice = zam.pozice;
            _pohlavi = zam.pohlavi;
            ulozil = zam.ulozil;
            casUlozeni = zam.casUlozeni;
            ocSkolitele = zam.ocSkolitele;
            jmenoSkolitele = zam.jmenoSkolitele;
            linka = zam.linka;
            _uzavreno = zam.uzavreno;
            _uzavrenoDatum = zam.uzavrenoDatum;
            poznamka = zam.poznamka;
            if (zam.seznamHodnoceni != null) _seznamHodnoceni = new ObservableCollection<Hodnoceni>(zam.seznamHodnoceni);
            _aktivni = zam.aktivni;
            _terminZaskoleni = zam.terminZaskoleni;
        }
        public int id
        {
            get { return _id; }
            set
            {
                if (_id == value)
                    return;
                _id = value;
                OnPropertyChanged("id");
            }
        }
        public string osCislo
        {
            get { return _osCislo; }
            set
            {
                if (_osCislo == value)
                    return;
                _osCislo = value;
                OnPropertyChanged("osCislo");
            }
        }

        public string jmeno
        {
            get { return _jmeno; }
            set
            {
                if (_jmeno == value)
                    return;
                _jmeno = value;
                OnPropertyChanged("jmeno");
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public string prijmeni
        {
            get { return _prijmeni; }
            set
            {
                if (_prijmeni == value)
                    return;
                _prijmeni = value;
                OnPropertyChanged("prijmeni");
                OnPropertyChanged("zobrazeneJmeno");
            }
        }
        public string stredisko
        {
            get { return _stredisko; }
            set
            {
                if (_stredisko == value)
                    return;
                _stredisko = value;
                OnPropertyChanged("stredisko");
            }
        }
        public DateTime datumNastupu
        {
            get { return _datumNastupu; }
            set
            {
                if (_datumNastupu == value)
                    return;
                _datumNastupu = value;
                OnPropertyChanged("datumNastupu");
            }
        }
        public string kategorie
        {
            get { return _kategorie; }
            set
            {
                if (_kategorie == value)
                    return;
                _kategorie = value;
                OnPropertyChanged("kategorie");
            }
        }
        public string smenovyModel
        {
            get { return _smenovyModel; }
            set
            {
                if (_smenovyModel == value)
                    return;
                _smenovyModel = value;
                OnPropertyChanged("smenovyModel");
            }
        }
        public string pozice
        {
            get { return _pozice; }
            set
            {
                if (_pozice == value)
                    return;
                _pozice = value;
                OnPropertyChanged("pozice");
            }
        }
        public string pohlavi
        {
            get { return _pohlavi; }
            set
            {
                if (_pohlavi == value)
                    return;
                _pohlavi = value;
                OnPropertyChanged("pohlavi");
            }
        }
        public string zobrazeneJmeno
        {
            get { return prijmeni + " " + jmeno; }
            set
            {
                OnPropertyChanged("zobrazeneJmeno");
            }
        }

        public bool uzavreno
        {
            get { return _uzavreno; }
            set
            {
                if (_uzavreno == value)
                    return;
                _uzavreno = value;
                OnPropertyChanged("uzavreno");
            }
        }
        public DateTime? uzavrenoDatum
        {
            get { return _uzavrenoDatum; }
            set
            {
                if (_uzavrenoDatum == value)
                    return;
                _uzavrenoDatum = value;
                OnPropertyChanged("uzavrenoDatum");
            }
        }
        public string poznamka
        {
            get { return _poznamka; }
            set
            {
                if (_poznamka == value)
                    return;
                _poznamka = value;
                OnPropertyChanged("poznamka");
            }
        }
        public DateTime? terminZaskoleni
        {
            get { return _terminZaskoleni; }
            set
            {
                if (_terminZaskoleni == value)
                    return;
                _terminZaskoleni = value;
                OnPropertyChanged("terminZaskoleni");
            }
        }
        public ObservableCollection<Hodnoceni> seznamHodnoceni
        {
            get { return _seznamHodnoceni; }
            set
            {
                if (_seznamHodnoceni == value)
                    return;
                _seznamHodnoceni = value;
                OnPropertyChanged("seznamHodnoceni");
            }
        }
        public bool aktivni
        {
            get { return _aktivni; }
            set
            {
                if (_aktivni == value)
                    return;
                _aktivni = value;
                OnPropertyChanged("aktivni");
            }
        }
        public int verzeZaskoleni
        {
            get { return _verzeZaskoleni; }
            set
            {
                if (_verzeZaskoleni == value)
                    return;
                _verzeZaskoleni = value;
                OnPropertyChanged("verzeZaskoleni");
            }
        }
        public static ObservableCollection<Zamestnanec> SelectZam()
        {

            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT a.id, a.osCislo, a.jmeno, a.prijmeni, a.stredisko, a.datumNastupu, a.ulozil, a.casUlozeni,b.ocSkolitele, b.jmenoSkolitele, b.linka, b.uzavreno, b.uzavrenoDatum, b.poznamka, a.idUseku, b.terminZaskoleni, a.aktivni, " +
                "a.pohlavi, a.smenovyModel, a.pozice, a.kategorie FROM Zamestnanec AS a " +
                "JOIN Zaskoleni AS b ON b.idZam = a.id " +
                "WHERE a.iduseku = " + Properties.Settings.Default.idUseku + " AND a.aktivni = 1 ORDER BY b.uzavreno, a.datumNastupu DESC, a.prijmeni";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Zamestnanec zamestnanec;

                    while (reader.Read())
                    {
                        zamestnanec = new Zamestnanec();
                        zamestnanec.id = reader.GetInt32(0);
                        zamestnanec.osCislo = reader.GetValue(1).ToString();
                        zamestnanec.jmeno = reader.GetValue(2).ToString();
                        zamestnanec.prijmeni = reader.GetValue(3).ToString();
                        zamestnanec.stredisko = reader.GetValue(4).ToString();
                        zamestnanec.datumNastupu = reader.GetDateTime(5);
                        zamestnanec.ulozil = reader.GetValue(6).ToString();
                        zamestnanec.casUlozeni = reader.GetDateTime(7);
                        zamestnanec.ocSkolitele = reader.GetValue(8).ToString();
                        zamestnanec.jmenoSkolitele = reader.GetValue(9).ToString();
                        zamestnanec.linka = reader.GetValue(10).ToString();
                        zamestnanec.uzavreno = reader.GetBoolean(11);
                        if (reader.GetValue(12) != DBNull.Value) zamestnanec.uzavrenoDatum = reader.GetDateTime(12);
                        zamestnanec.poznamka = reader.GetValue(13).ToString();
                        if (reader.GetValue(15) != DBNull.Value) zamestnanec.terminZaskoleni = reader.GetDateTime(15);
                        
                        if (zamestnanec.uzavrenoDatum.HasValue)
                        {
                            zamestnanec.pocetDniZaskoleni = (zamestnanec.uzavrenoDatum.Value.Date - zamestnanec.datumNastupu).Days;
                            if (zamestnanec.uzavrenoDatum.Value.Date <= zamestnanec.terminZaskoleni)
                            {
                                if (zamestnanec.pocetDniZaskoleni <= 14) zamestnanec.verzeZaskoleni = 4;
                                else if (zamestnanec.pocetDniZaskoleni > 14 && zamestnanec.pocetDniZaskoleni <= 31) zamestnanec.verzeZaskoleni = 5;
                                else zamestnanec.verzeZaskoleni = 6;
                            }
                            else
                                zamestnanec.verzeZaskoleni = 7;

                        }
                        else
                        {
                            zamestnanec.pocetDniZaskoleni = (DateTime.Now.Date - zamestnanec.datumNastupu).Days;
                            if (zamestnanec.pocetDniZaskoleni < 0 && DateTime.Now.Date <= zamestnanec.terminZaskoleni) zamestnanec.pocetDniZaskoleni = 0;
                            if (zamestnanec.pocetDniZaskoleni < 15 && DateTime.Now.Date <= zamestnanec.terminZaskoleni) zamestnanec.verzeZaskoleni = 1;
                            else if (zamestnanec.pocetDniZaskoleni >= 15 && DateTime.Now.Date <= zamestnanec.terminZaskoleni) zamestnanec.verzeZaskoleni = 2;
                            else zamestnanec.verzeZaskoleni = 3;
                        }
                        zamestnanec.aktivni = reader.GetBoolean(16);
                        zamestnanec.pohlavi = reader.GetValue(17).ToString();
                        zamestnanec.smenovyModel = reader.GetValue(18).ToString();
                        zamestnanec.pozice = reader.GetValue(19).ToString();
                        zamestnanec.kategorie = reader.GetValue(20).ToString();
                        seznam.Add(zamestnanec);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static bool CheckZalozeni(string osCislo, DateTime nastup)
        {
            bool vysledek = false;
            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT COUNT(id) FROM Zamestnanec WHERE osCislo = '" + osCislo + "' AND datumNastupu = '" + nastup.ToString("MM-dd-yyyy") + "'";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        if (reader.GetInt32(0) > 0)
                        {
                            vysledek = true;
                        }
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return vysledek;
        }

        public static int PocetOtevrenychZaskoleni(int idUseku)
        {
            int vysledek = 0;
            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();
            String sqlStr = "SELECT COUNT(a.id) FROM Zamestnanec AS a " +
                "JOIN Zaskoleni AS b ON b.idZam = a.id WHERE b.uzavreno = 0 AND a.aktivni = 1 AND a.idUseku = " + idUseku;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();

                    while (reader.Read())
                    {
                        vysledek = (reader.GetInt32(0));
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return vysledek;
        }
        public static ObservableCollection<Zamestnanec> SelectFiltrovaniZamestnanci(string sqlStr)
        {

            ObservableCollection<Zamestnanec> seznam = new ObservableCollection<Zamestnanec>();

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);
                    SqlDataReader reader = cmd.ExecuteReader();
                    Zamestnanec zamestnanec;

                    while (reader.Read())
                    {
                        zamestnanec = new Zamestnanec();
                        zamestnanec.id = reader.GetInt32(0);
                        zamestnanec.osCislo = reader.GetValue(1).ToString();
                        zamestnanec.jmeno = reader.GetValue(2).ToString();
                        zamestnanec.prijmeni = reader.GetValue(3).ToString();
                        zamestnanec.stredisko = reader.GetValue(4).ToString();
                        zamestnanec.datumNastupu = reader.GetDateTime(5);
                        zamestnanec.ulozil = reader.GetValue(6).ToString();
                        zamestnanec.casUlozeni = reader.GetDateTime(7);
                        zamestnanec.ocSkolitele = reader.GetValue(8).ToString();
                        zamestnanec.jmenoSkolitele = reader.GetValue(9).ToString();
                        zamestnanec.linka = reader.GetValue(10).ToString();
                        zamestnanec.uzavreno = reader.GetBoolean(11);
                        if (reader.GetValue(12) != DBNull.Value) zamestnanec.uzavrenoDatum = reader.GetDateTime(12);
                        zamestnanec.poznamka = reader.GetValue(13).ToString();
                        if (reader.GetValue(15) != DBNull.Value) zamestnanec.terminZaskoleni = reader.GetDateTime(15);

                        if (zamestnanec.uzavrenoDatum.HasValue)
                        {
                            zamestnanec.pocetDniZaskoleni = (zamestnanec.uzavrenoDatum.Value.Date - zamestnanec.datumNastupu).Days;
                            if (zamestnanec.uzavrenoDatum.Value.Date <= zamestnanec.terminZaskoleni)
                            {
                                if (zamestnanec.pocetDniZaskoleni <= 14) zamestnanec.verzeZaskoleni = 4;
                                else if (zamestnanec.pocetDniZaskoleni > 14 && zamestnanec.pocetDniZaskoleni <= 31) zamestnanec.verzeZaskoleni = 5;
                                else zamestnanec.verzeZaskoleni = 6;
                            }
                            else
                                zamestnanec.verzeZaskoleni = 7;

                        }
                        else
                        {
                            zamestnanec.pocetDniZaskoleni = (DateTime.Now - zamestnanec.datumNastupu).Days;
                            if (zamestnanec.pocetDniZaskoleni < 0 && DateTime.Now <= zamestnanec.terminZaskoleni) zamestnanec.pocetDniZaskoleni = 0;
                            if (zamestnanec.pocetDniZaskoleni < 15 && DateTime.Now <= zamestnanec.terminZaskoleni) zamestnanec.verzeZaskoleni = 1;
                            else if (zamestnanec.pocetDniZaskoleni >= 15 && DateTime.Now <= zamestnanec.terminZaskoleni) zamestnanec.verzeZaskoleni = 2;
                            else zamestnanec.verzeZaskoleni = 3;
                        }
                        zamestnanec.aktivni = reader.GetBoolean(16);
                        zamestnanec.aktivni = reader.GetBoolean(16);
                        zamestnanec.pohlavi = reader.GetValue(17).ToString();
                        zamestnanec.smenovyModel = reader.GetValue(18).ToString();
                        zamestnanec.pozice = reader.GetValue(19).ToString();
                        zamestnanec.kategorie = reader.GetValue(20).ToString();

                        seznam.Add(zamestnanec);
                    }

                    cmd.Dispose();

                }

                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return seznam;
        }
        public static int VlozitZamestnance(Zamestnanec zamestnanec)
        {
            String sqlStr = "INSERT INTO Zamestnanec (osCislo, jmeno, prijmeni, stredisko, datumNastupu, ulozil, casUlozeni, idUseku, aktivni, kategorie, pohlavi, smenovyModel, pozice) "
                + "VALUES (@osCislo, @jmeno, @prijmeni, @stredisko, @datumNastupu, @ulozil, @casUlozeni, @idUseku, @aktivni, @kategorie, @pohlavi, @smenovyModel, @pozice) SELECT SCOPE_IDENTITY();";

            int idOsoby = 0;
            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@osCislo", zamestnanec.osCislo);
                    cmd.Parameters.AddWithValue("@jmeno", zamestnanec.jmeno);
                    cmd.Parameters.AddWithValue("@prijmeni", zamestnanec.prijmeni);
                    cmd.Parameters.AddWithValue("@stredisko", zamestnanec.stredisko);
                    cmd.Parameters.AddWithValue("@datumNastupu", zamestnanec.datumNastupu);
                    cmd.Parameters.AddWithValue("@ulozil", "fip8jh");
                    cmd.Parameters.AddWithValue("@casUlozeni", DateTime.Now);
                    cmd.Parameters.AddWithValue("@idUseku", Properties.Settings.Default.idUseku);
                    cmd.Parameters.AddWithValue("@aktivni", true);
                    if(zamestnanec.kategorie != null) cmd.Parameters.AddWithValue("@kategorie", zamestnanec.kategorie);
                    else cmd.Parameters.AddWithValue("@kategorie", DBNull.Value);
                    cmd.Parameters.AddWithValue("@pohlavi", zamestnanec.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", zamestnanec.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", zamestnanec.pozice);

                    idOsoby = Convert.ToInt32(cmd.ExecuteScalar());
                    cmd.Dispose();
                    zamestnanec.id = idOsoby;
                    VlozitZaskoleniZamestnance(zamestnanec);
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return idOsoby;
            }
        }
        public static void VlozitZaskoleniZamestnance(Zamestnanec zamestnanec)
        {
            String sqlStr = "INSERT INTO Zaskoleni (id, idZam, uzavreno, terminZaskoleni) "
                + "VALUES (@id, @idZam, @uzavreno, @terminZaskoleni) SELECT SCOPE_IDENTITY();";

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@id", zamestnanec.id);
                    cmd.Parameters.AddWithValue("@idZam", zamestnanec.id);
                    cmd.Parameters.AddWithValue("@uzavreno", false);
                    cmd.Parameters.AddWithValue("@terminZaskoleni", zamestnanec.terminZaskoleni);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
        public static bool UlozitHodnoceni(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zaskoleni SET ocSkolitele=@ocSkolitele, jmenoSkolitele=@jmenoSkolitele, linka=@linka WHERE idZam = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    if (zamestnanec.ocSkolitele != null) cmd.Parameters.AddWithValue("@ocSkolitele", zamestnanec.ocSkolitele);
                    else cmd.Parameters.AddWithValue("@ocSkolitele", DBNull.Value);
                    if (zamestnanec.jmenoSkolitele != null) cmd.Parameters.AddWithValue("@jmenoSkolitele", zamestnanec.jmenoSkolitele);
                    else cmd.Parameters.AddWithValue("@jmenoSkolitele", DBNull.Value);
                    if (zamestnanec.linka != null) cmd.Parameters.AddWithValue("@linka", zamestnanec.linka);
                    else cmd.Parameters.AddWithValue("@linka", DBNull.Value);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool EditaceZamestnanece(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zamestnanec SET osCislo=@osCislo, jmeno=@jmeno, prijmeni=@prijmeni, stredisko=@stredisko, datumNastupu=@datumNastupu, ulozil=@ulozil, casUlozeni=@casUlozeni, " +
                "kategorie=@kategorie, pohlavi=@pohlavi, smenovyModel=@smenovyModel, pozice=@pozice WHERE id = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@osCislo", zamestnanec.osCislo);
                    cmd.Parameters.AddWithValue("@jmeno", zamestnanec.jmeno);
                    cmd.Parameters.AddWithValue("@prijmeni", zamestnanec.prijmeni);
                    cmd.Parameters.AddWithValue("@stredisko", zamestnanec.stredisko);
                    cmd.Parameters.AddWithValue("@datumNastupu", zamestnanec.datumNastupu);
                    cmd.Parameters.AddWithValue("@ulozil", "fip8jh");
                    cmd.Parameters.AddWithValue("@casUlozeni", DateTime.Now);
                    if (zamestnanec.kategorie != null) cmd.Parameters.AddWithValue("@kategorie", zamestnanec.kategorie);
                    else cmd.Parameters.AddWithValue("@kategorie", DBNull.Value);
                    cmd.Parameters.AddWithValue("@pohlavi", zamestnanec.pohlavi);
                    cmd.Parameters.AddWithValue("@smenovyModel", zamestnanec.smenovyModel);
                    cmd.Parameters.AddWithValue("@pozice", zamestnanec.pozice);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();
                    EditaceZaskoleniZamestnanece(zamestnanec);
                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static void EditaceZaskoleniZamestnanece(Zamestnanec zamestnanec)
        {
            String sqlStr = "UPDATE Zaskoleni SET terminZaskoleni=@terminZaskoleni, poznamka=@poznamka WHERE idZam = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@terminZaskoleni", zamestnanec.terminZaskoleni);
                    if (zamestnanec.poznamka != null) cmd.Parameters.AddWithValue("@poznamka", zamestnanec.poznamka);
                    else cmd.Parameters.AddWithValue("@poznamka", DBNull.Value);


                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
        }
        public static bool UzavritZamestnance(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zaskoleni SET uzavreno=@uzavreno, uzavrenoDatum=@uzavrenoDatum, poznamka=@poznamka WHERE idZam = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@uzavreno", zamestnanec.uzavreno);
                    if (zamestnanec.uzavrenoDatum != null) cmd.Parameters.AddWithValue("@uzavrenoDatum", zamestnanec.uzavrenoDatum);
                    else cmd.Parameters.AddWithValue("@uzavrenoDatum", DBNull.Value);
                    if (zamestnanec.poznamka != null) cmd.Parameters.AddWithValue("@poznamka", zamestnanec.poznamka);
                    else cmd.Parameters.AddWithValue("@poznamka", DBNull.Value);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool UpdateTerminZaskoleni(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zaskoleni SET terminZaskoleni=@terminZaskoleni, poznamka=@poznamka WHERE idZam = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@terminZaskoleni", zamestnanec.terminZaskoleni);
                    if (zamestnanec.poznamka != null) cmd.Parameters.AddWithValue("@poznamka", zamestnanec.poznamka);
                    else cmd.Parameters.AddWithValue("@poznamka", DBNull.Value);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool UkoncitZamestnance(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zamestnanec SET aktivni=@aktivni, datumUkonceni=@datumUkonceni WHERE id = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@aktivni", false);
                    cmd.Parameters.AddWithValue("@datumUkonceni", DateTime.Now.Date);
                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool ObnovitZamestance(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zamestnanec SET aktivni=@aktivni WHERE id = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@aktivni", true);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = true;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool posunoutTerminZaskoleni(Zamestnanec zamestnanec)
        {
            bool test = true;
            String sqlStr = "UPDATE Zaskoleni SET poznamka=@poznamka, terminZaskoleni=@terminZaskoleni WHERE idZam = " + zamestnanec.id;

            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.Parameters.AddWithValue("@poznamka", zamestnanec.poznamka);
                    cmd.Parameters.AddWithValue("@terminZaskoleni", zamestnanec.terminZaskoleni);

                    cmd.ExecuteNonQuery();
                    cmd.Dispose();

                }


                catch (Exception ex)
                {
                    test = false;
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
                return test;
            }
        }
        public static bool SmazatZamestnance(int idZamestnanece)
        {
            bool test = false;
            String sqlStr = "DELETE Zaskoleni WHERE idZam = " + idZamestnanece
                 + " DELETE CheckListZam WHERE idZam = " + idZamestnanece
                 + " DELETE CheckListStanice WHERE idZam = " + idZamestnanece
                 + " DELETE Hodnoceni WHERE idZam = " + idZamestnanece
                 + " DELETE Matice_Kompetence WHERE idZam = " + idZamestnanece
                 + " DELETE Zamestnanec WHERE id = " + idZamestnanece;


            using (SqlConnection conn = new SqlConnection(ConnectionString.connectionString))
            {
                try
                {
                    conn.Open();
                    SqlCommand cmd = new SqlCommand(sqlStr, conn);

                    cmd.ExecuteNonQuery();

                    cmd.Dispose();
                    test = true;
                }


                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Problém s připojením");
                }
                finally
                {
                    conn.Close();
                }
            }
            return test;
        }
    }
}
