﻿using eTraining.Commands;
using eTraining.Helpers;
using eTraining.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace eTraining.ViewModels.AdministraceVM
{
    class AdministraceControlViewModel : ViewModelBase, IPageViewModel
    {
        
        public static event EventHandlerZatmavit Zatmavit = delegate { };
        private ObservableCollection<CheckList> seznamProSmazani;
        private ObservableCollection<Stanice> seznamProSmazaniStanic;

        private ObservableCollection<CheckList> _chlPrvniDen;
        private ObservableCollection<CheckList> _chlPravidla;
        private ObservableCollection<MaskaStanic> _maskyStanic;
        private MaskaStanic _novaMaska;
        private MaskaStanic _vybranaMaska;

        private bool _zobrazeniNoveMasky = false;
        private bool _zobrazeniInfa;
        private string _infoPopis;
        private bool _isBusy;
        private bool _ztmavit;

        private ObservableCollection<Opravneni> _seznamUzivatelu;
        private Opravneni _uzivatel;
        private bool _zobrazenyZadaniOsob = false;
        private ObservableCollection<Opravneni> _seznamUzProVybrani;
        private Opravneni _uzivatelProVybrani;
        private bool _hledam;
        private bool _chyba;
        private string _chybaPopis;
        private string _filtrJmeno;
        private bool _editaceUzivatele = false;

        public RelayCommand<CheckList> OdebratRadekPrvniDenCommand { get; private set; }
        public RelayCommand PridatRadekPrvniDenCommand { get; private set; }
        public RelayCommand<CheckList> OdebratRadekPravidlaCommand { get; private set; }
        public RelayCommand PridatRadekPravidlaCommand { get; private set; }
        public RelayCommand PridatMaskuStanicCommand { get; private set; }
        public RelayCommand EditovatMaskuStanicCommand { get; private set; }
        public RelayCommand UlozitMaskuStanicCommand { get; private set; }
        public RelayCommand SmazatMaskuStanicCommand { get; private set; }
        public RelayCommand ZavritMaskuStanicCommand { get; private set; }
        public RelayCommand<Stanice> OdebratRadekStaniceCommand { get; private set; }
        public RelayCommand PridatRadekStaniceCommand { get; private set; }
        public RelayCommand UlozitCommand { get; private set; }
        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public RelayCommand ZavriAdministraciCommand { get; private set; }

        public RelayCommand VlozitNovehoUzivateleCommand { get; private set; }
        public RelayCommand UlozitUzivateleCommand { get; private set; }
        public RelayCommand ZobrazitZadaniUzivateleCommand { get; private set; }
        public RelayCommand SchovatZadaniUzivateleCommand { get; private set; }
        public RelayCommand ZobrazitVybraniZamCommand { get; private set; }
        public RelayCommand<Window> ZavritVybraniZamCommand { get; private set; }
        public RelayCommand<string> HledejZamProVybraniCommand { get; private set; }
        public RelayCommand ZobrazitPridaniStrediskaCommand { get; private set; }
        public RelayCommand SmazatUzivateleCommand { get; private set; }
        public RelayCommand<Window> ZavritOknoCommand { get; private set; }
        public RelayCommand PouzitFiltrCommand { get; private set; }
        public RelayCommand ZrusitFiltrCommand { get; private set; }

        public static event EventHandlerZpet Zpet = delegate { };
        
        public string Name
        {
            get
            {
                return "Administrace";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Ztmavit
        {
            get { return _ztmavit; }
            set
            {
                if (_ztmavit != value)
                {
                    _ztmavit = value;
                    OnPropertyChanged("Ztmavit");
                }
            }
        }
        public ObservableCollection<CheckList> ChlPrvniDen
        {
            get { return _chlPrvniDen; }
            set
            {
                if (_chlPrvniDen != value)
                {
                    _chlPrvniDen = value;
                    OnPropertyChanged("ChlPrvniDen");
                }
            }
        }
        public ObservableCollection<CheckList> ChlPravidla
        {
            get { return _chlPravidla; }
            set
            {
                if (_chlPravidla != value)
                {
                    _chlPravidla = value;
                    OnPropertyChanged("ChlPravidla");
                }
            }
        }
        public ObservableCollection<MaskaStanic> MaskyStanic
        {
            get { return _maskyStanic; }
            set
            {
                if (_maskyStanic != value)
                {
                    _maskyStanic = value;
                    OnPropertyChanged("MaskyStanic");
                }
            }
        }
        public MaskaStanic NovaMaska
        {
            get { return _novaMaska; }
            set
            {
                if (_novaMaska != value)
                {
                    _novaMaska = value;
                    OnPropertyChanged("NovaMaska");
                }
            }
        }
        public MaskaStanic VybranaMaska
        {
            get { return _vybranaMaska; }
            set
            {
                if (_vybranaMaska != value)
                {
                    _vybranaMaska = value;
                    OnPropertyChanged("VybranaMaska");
                }
            }
        }
        public bool ZobrazeniNoveMasky
        {
            get { return _zobrazeniNoveMasky; }
            set
            {
                if (_zobrazeniNoveMasky != value)
                {
                    _zobrazeniNoveMasky = value;
                    OnPropertyChanged("ZobrazeniNoveMasky");
                }
            }
        }
        public bool ZobrazeniInfa
        {
            get { return _zobrazeniInfa; }
            set
            {
                if (_zobrazeniInfa != value)
                {
                    _zobrazeniInfa = value;
                    OnPropertyChanged("ZobrazeniInfa");
                }
            }
        }
        public string InfoPopis
        {
            get { return _infoPopis; }
            set
            {
                if (_infoPopis != value)
                {
                    _infoPopis = value;
                    OnPropertyChanged("InfoPopis");
                }
            }
        }
        public bool ZobrazenyZadaniOsob
        {
            get { return _zobrazenyZadaniOsob; }
            set
            {
                if (_zobrazenyZadaniOsob != value)
                {
                    _zobrazenyZadaniOsob = value;
                    OnPropertyChanged("ZobrazenyZadaniOsob");
                }
            }
        }
        public ObservableCollection<Opravneni> SeznamUzivatelu
        {
            get { return _seznamUzivatelu; }
            set
            {
                if (_seznamUzivatelu != value)
                {
                    _seznamUzivatelu = value;
                    OnPropertyChanged("SeznamUzivatelu");
                }
            }
        }
        public Opravneni Uzivatel
        {
            get { return _uzivatel; }
            set
            {
                if (_uzivatel != value)
                {
                    _uzivatel = value;
                    OnPropertyChanged("Uzivatel");
                }
            }
        }
        public Opravneni UzivatelProVybrani
        {
            get { return _uzivatelProVybrani; }
            set
            {
                if (_uzivatelProVybrani != value)
                {
                    _uzivatelProVybrani = value;
                    OnPropertyChanged("UzivatelProVybrani");
                }
            }
        }
        public ObservableCollection<Opravneni> SeznamUzProVybrani
        {
            get { return _seznamUzProVybrani; }
            set
            {
                if (_seznamUzProVybrani != value)
                {
                    _seznamUzProVybrani = value;
                    OnPropertyChanged("SeznamUzProVybrani");
                }
            }
        }
        public bool Hledam
        {
            get { return _hledam; }
            set
            {
                if (_hledam != value)
                {
                    _hledam = value;
                    OnPropertyChanged("Hledam");
                }
            }
        }
        public bool Chyba
        {
            get { return _chyba; }
            set
            {
                if (_chyba != value)
                {
                    _chyba = value;
                    OnPropertyChanged("Chyba");
                }
            }
        }
        public string ChybaPopis
        {
            get { return _chybaPopis; }
            set
            {
                if (_chybaPopis != value)
                {
                    _chybaPopis = value;
                    OnPropertyChanged("ChybaPopis");
                }
            }
        }
        public string FiltrJmeno
        {
            get { return _filtrJmeno; }
            set
            {
                if (_filtrJmeno != value)
                {
                    _filtrJmeno = value;
                    OnPropertyChanged("FiltrJmeno");
                }
            }
        }
        public bool EditaceUzivatele
        {
            get { return _editaceUzivatele; }
            set
            {
                if (_editaceUzivatele != value)
                {
                    _editaceUzivatele = value;
                    OnPropertyChanged("EditaceUzivatele");
                }
            }
        }
        public AdministraceControlViewModel()
        {
            Task.Run(() =>
            {
                IsBusy = true;
                ChlPrvniDen = CheckList.SelectCheckList(1);
                ChlPravidla = CheckList.SelectCheckList(3);
                NacteniDatMasky();
                SeznamUzivatelu = Opravneni.SelectUzivatele();
                IsBusy = false;
            });
            OdebratRadekPrvniDenCommand = new RelayCommand<CheckList>(param => this.OdebratRadekPrvniDen(param));
            PridatRadekPrvniDenCommand = new RelayCommand(param => this.PridatRadekPrvniDen());
            OdebratRadekPravidlaCommand = new RelayCommand<CheckList>(param => this.OdebratRadekPravidla(param));
            PridatRadekPravidlaCommand = new RelayCommand(param => this.PridatRadekPravidla());
            OdebratRadekStaniceCommand = new RelayCommand<Stanice>(param => this.OdebratRadekStanice(param));
            PridatRadekStaniceCommand = new RelayCommand(param => this.PridatRadekStanice());
            PridatMaskuStanicCommand = new RelayCommand(param => this.PridatMaskuStanic());
            UlozitMaskuStanicCommand = new RelayCommand(param => this.UlozitMaskuStanic());
            SmazatMaskuStanicCommand = new RelayCommand(param => this.SmazatMaskuStanic());
            ZavritMaskuStanicCommand = new RelayCommand(param => this.ZavritMaskuStanic());
            EditovatMaskuStanicCommand = new RelayCommand(param => this.EditovatMaskuStanic());
            UlozitCommand = new RelayCommand(param => this.Ulozit());
            ZavriAdministraciCommand = new RelayCommand(param => this.ZavriAdministraci());


            VlozitNovehoUzivateleCommand = new RelayCommand(param => this.VlozitNovehoUzivatele());
            UlozitUzivateleCommand = new RelayCommand(param => this.UlozitUzivatele());
            ZobrazitZadaniUzivateleCommand = new RelayCommand(param => this.ZobrazitZadaniUzivatele());
            SchovatZadaniUzivateleCommand = new RelayCommand(param => this.SchovatZadaniUzivatele());
            ZobrazitVybraniZamCommand = new RelayCommand(param => this.ZobrazitVybraniZam());
            ZavritVybraniZamCommand = new RelayCommand<Window>(param => this.ZavritVybraniZam(param));
            HledejZamProVybraniCommand = new RelayCommand<string>(param => this.HledejZamProVybrani(param));
            SmazatUzivateleCommand = new RelayCommand(param => this.SmazatUzivatele());
            ZavritOknoCommand = new RelayCommand<Window>(param => this.ZavritOkno(param));
            PouzitFiltrCommand = new RelayCommand(param => this.PouzitFiltr());
            ZrusitFiltrCommand = new RelayCommand(param => this.ZrusitFiltr());
        }
        private void NacteniDatMasky()
        {
            MaskyStanic = MaskaStanic.SelectMasky();
            ObservableCollection<Stanice> seznamStanicProNacteni = Stanice.SelectStaniceMasek(MaskyStanic);
            foreach (var item in MaskyStanic)
            {
                item.seznamStanic = new ObservableCollection<Stanice>(seznamStanicProNacteni.Where(d => d.idMasky == item.id).Select(d => d).ToList().OrderBy(d=>d.id));
            }
        }
        private void OdebratRadekPrvniDen(CheckList radek)
        {
            if (radek.id != 0)
            {
                if (seznamProSmazani == null) seznamProSmazani = new ObservableCollection<CheckList>();
                seznamProSmazani.Add(radek);
            }
            ChlPrvniDen.Remove(radek);
        }
        private void PridatRadekPrvniDen()
        {
            ChlPrvniDen.Add(new CheckList { datumZadani = DateTime.Now, aktivni = true, zalozka = 1 });
        }
        private void OdebratRadekPravidla(CheckList radek)
        {
            if (radek.id != 0)
            {
                if (seznamProSmazani == null) seznamProSmazani = new ObservableCollection<CheckList>();
                seznamProSmazani.Add(radek);
            }
            ChlPravidla.Remove(radek);
        }
        private void PridatRadekPravidla()
        {
            ChlPravidla.Add(new CheckList { datumZadani = DateTime.Now, aktivni = true, zalozka = 3 });
        }
        private void PridatMaskuStanic()
        {
            ZobrazeniNoveMasky = true;
            NovaMaska = new MaskaStanic();
            NovaMaska.seznamStanic = new ObservableCollection<Stanice>();
            NovaMaska.seznamStanic.Add(new Stanice());
        }
        private void EditovatMaskuStanic()
        {
            ZobrazeniNoveMasky = true;
            NovaMaska = new MaskaStanic();
            NovaMaska.id = VybranaMaska.id;
            NovaMaska.nazev = VybranaMaska.nazev;
            NovaMaska.idUseku = VybranaMaska.idUseku;
            NovaMaska.seznamStanic = new ObservableCollection<Stanice>(VybranaMaska.seznamStanic);
        }
        private void OdebratRadekStanice(Stanice radek)
        {
            if (radek.id != 0)
            {
                if (seznamProSmazaniStanic == null) seznamProSmazaniStanic = new ObservableCollection<Stanice>();
                seznamProSmazaniStanic.Add(radek);
            }
            NovaMaska.seznamStanic.Remove(radek);
        }
        private void PridatRadekStanice()
        {
            NovaMaska.seznamStanic.Add(new Stanice());
        }
        private void Ulozit()
        {
            Task.Run(() =>
            {
                bool uspesny = true;
                IsBusy = true;
                uspesny = Kontrola();
                if (uspesny)
                {
                    ChlPrvniDen = CheckList.VlozitCheckList(ChlPrvniDen);
                    ChlPravidla = CheckList.VlozitCheckList(ChlPravidla);
                    if (seznamProSmazani != null)
                    {
                        uspesny = CheckList.SmazatCheckListy(seznamProSmazani);
                        seznamProSmazani = null;
                    }
                    if (uspesny)
                    {
                        IsBusy = false;
                        Task.Run(() =>
                        {
                            Zatmavit(true);
                            ZobrazeniInfa = true;
                            InfoPopis = "Data byla úspěšně uložena.";
                            System.Threading.Thread.Sleep(2000);
                            ZobrazeniInfa = false;
                            Zatmavit(false);
                        });
                    }                        
                    
                }
                
            });
        }

        private void UlozitMaskuStanic()
        {
            Task.Run(() =>
            {
                bool uspesny = true;
                IsBusy = true;
                uspesny = KontrolaStanic();
                
                if (uspesny)
                {
                    NovaMaska = MaskaStanic.VlozitMasku(NovaMaska);
                    if (NovaMaska.id != 0)
                    {
                        NovaMaska.seznamStanic = Stanice.VlozitStanice(NovaMaska.seznamStanic, NovaMaska.id);
                        if (seznamProSmazaniStanic != null)
                        {
                            uspesny = Stanice.SmazatStanice(seznamProSmazaniStanic);
                            seznamProSmazaniStanic = null;
                        }

                    }

                    if (uspesny)
                    {
                        
                        Task.Run(() =>
                        {
                            Zatmavit(true);
                            NacteniDatMasky();
                            ZobrazeniInfa = true;
                            InfoPopis = "Data byla úspěšně uložena.";
                            System.Threading.Thread.Sleep(2000);
                            ZobrazeniInfa = false;
                            Zatmavit(false);
                            ZobrazeniNoveMasky = false;
                        });
                    }
                }
                IsBusy = false;
            });
        }
        private void SmazatMaskuStanic()
        {
            if (MaskaStanic.SmazatMasku(VybranaMaska.id))
            {
                Task.Run(() =>
                {
                    Zatmavit(true);
                    NacteniDatMasky();
                    ZobrazeniInfa = true;
                    InfoPopis = "Maska byla úspěšně smazána.";
                    System.Threading.Thread.Sleep(2000);
                    ZobrazeniInfa = false;
                    Zatmavit(false);
                    ZobrazeniNoveMasky = false;
                });
            }
            
        }
        private void ZavritMaskuStanic()
        {
            ZobrazeniNoveMasky = false;
        }
        private bool Kontrola()
        {
            ObservableCollection<CheckList> dataProSmazani = new ObservableCollection<CheckList>(ChlPrvniDen.Where(d=>d.id == 0 && String.IsNullOrEmpty(d.otazka)));

            foreach (var data in dataProSmazani)
            {
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    ChlPrvniDen.Remove(data);
                });
            }

            dataProSmazani = new ObservableCollection<CheckList>(ChlPravidla.Where(d => d.id == 0 && String.IsNullOrEmpty(d.otazka)));

            foreach (var data in dataProSmazani)
            {
                App.Current.Dispatcher.Invoke((Action)delegate
                {
                    ChlPravidla.Remove(data);
                });
            }

            return true;
        }
        private bool KontrolaStanic()
        {
            int count = NovaMaska.seznamStanic.Count;
            if (String.IsNullOrEmpty(NovaMaska.nazev))
            {
                return false;
            }
            for (int i = 0; i < count; i++)
            {
                if (NovaMaska.seznamStanic[i].id == 0 && String.IsNullOrEmpty(NovaMaska.seznamStanic[i].nazev))
                {
                    App.Current.Dispatcher.Invoke((Action)delegate
                    {
                        NovaMaska.seznamStanic.Remove(NovaMaska.seznamStanic[i]);
                    });
                }
            }
            return true;

        }
        public void ZavriAdministraci()
        {
            Zpet();
        }

        public void VlozitNovehoUzivatele()
        {
            Uzivatel = new Opravneni();
            Uzivatel.role = 3;
            ZobrazenyZadaniOsob = true;
        }

        private void ZobrazitVybraniZam()
        {
            UzivatelProVybrani = null;
            SeznamUzProVybrani = null;
            Zatmavit(true);
            Ztmavit = true;
            VybratZam vybraniZam = new VybratZam();
            vybraniZam.DataContext = this;
            vybraniZam.Owner = Application.Current.MainWindow;
            vybraniZam.ShowDialog();
        }
        private void ZavritVybraniZam(Window okno)
        {
            Uzivatel.jmeno = UzivatelProVybrani.jmeno;
            Uzivatel.prijmeni = UzivatelProVybrani.prijmeni;
            Uzivatel.oddeleni = UzivatelProVybrani.oddeleni;
            Uzivatel.email = UzivatelProVybrani.email;
            Uzivatel.nt = UzivatelProVybrani.nt.ToLower();
            

            Zatmavit(false);
            Ztmavit = false;
            if (okno != null)
                okno.Close();
        }
        private void HledejZamProVybrani(string jmeno)
        {
            Task.Run(() =>
            {
                Hledam = true;
                SeznamUzProVybrani = ActiveDirectory.VyhledejUzivatele(jmeno);
                Hledam = false;
            });
        }
        private void ZobrazitZadaniUzivatele()
        {
            EditaceUzivatele = true;
            ZobrazenyZadaniOsob = true;
        }
        private void SchovatZadaniUzivatele()
        {
            if (EditaceUzivatele) EditaceUzivatele = false;

            ZobrazenyZadaniOsob = false;
            Uzivatel = null;
        }        
        public void UlozitUzivatele()
        {
            if (KontrolaUzivatele())
            {
                if (EditaceUzivatele)
                {
                    if (!Opravneni.EditaceUzivatele(Uzivatel))
                    {
                        Task.Run(() =>
                        {
                            Chyba = true;
                            ChybaPopis = "Nastala chyba při ukládání";
                            System.Threading.Thread.Sleep(2000);
                            Chyba = false;
                        });
                    }
                    else
                    {
                        SchovatZadaniUzivatele();
                    }
                }
                else
                {
                    if (!Opravneni.VlozitUzivatele(Uzivatel))
                    {
                        Task.Run(() =>
                        {
                            Chyba = true;
                            ChybaPopis = "Nastala chyba při ukládání";
                            System.Threading.Thread.Sleep(2000);
                            Chyba = false;
                        });
                    }
                    else
                    {
                        if (SeznamUzivatelu.Where(d => d.nt == Uzivatel.nt).ToList().Count == 0) SeznamUzivatelu.Add(Uzivatel);
                        else SeznamUzivatelu.Where(d => d.nt == Uzivatel.nt).Select(d => d).FirstOrDefault().role = Uzivatel.role;
                        SchovatZadaniUzivatele();
                    }
                }
            }
            else
            {
                Task.Run(() =>
                {
                    Chyba = true;
                    ChybaPopis = "Vyberte uživatele";
                    System.Threading.Thread.Sleep(3000);
                    Chyba = false;
                });
            }

        }

        private void SmazatUzivatele()
        {
            if (Opravneni.SmazatUzivatele(Uzivatel.nt)) SeznamUzivatelu.Remove(Uzivatel);
        }
        private bool KontrolaUzivatele()
        {
            if (String.IsNullOrEmpty(Uzivatel.jmeno)) return false;
            if (String.IsNullOrEmpty(Uzivatel.prijmeni)) return false;
            if (String.IsNullOrEmpty(Uzivatel.email)) return false;
            if (String.IsNullOrEmpty(Uzivatel.nt)) return false;
            return true;
        }
        private void PouzitFiltr()
        {
            string sqlStr = "SELECT * FROM Opravneni WHERE nt IS NOT NULL AND idUseku = " + Properties.Settings.Default.idUseku;

            if (!string.IsNullOrWhiteSpace(FiltrJmeno)) sqlStr += " AND CONCAT(prijmeni,' ', jmeno) LIKE CONCAT('%', replace('" + FiltrJmeno + "', ' ', '%'), '%')";

            sqlStr += " ORDER BY prijmeni";
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamUzivatelu = Opravneni.SelectFiltrovaniUzivatele(sqlStr);

                IsBusy = false;
            });
        }
        private void ZrusitFiltr()
        {
            FiltrJmeno = "";
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamUzivatelu = Opravneni.SelectUzivatele();
                IsBusy = false;
            });
        }
        private void ZavritOkno(Window okno)
        {
            Zatmavit(false);
            Ztmavit = false;
            if (okno != null)
                okno.Close();
        }
    }
}
