﻿using eTraining.Commands;
using eTraining.Helpers;
using eTraining.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace eTraining.ViewModels.DetailVM
{
    public class DetailKartyViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZpet Zpet = delegate { };

        private bool _isBusy;
        private Zamestnanec _zam;
        private ObservableCollection<CheckListZam> _chlPrvniDen;
        private ObservableCollection<CheckListStanice> _chlStanice;
        private ObservableCollection<CheckListZam> _chlPravidla;
        private Hodnoceni _hodZam = new Hodnoceni();
        public string Name
        {
            get
            {
                return "Zadani";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public Zamestnanec Zam
        {
            get { return _zam; }
            set
            {
                if (_zam != value)
                {
                    _zam = value;
                    OnPropertyChanged("Zam");
                }
            }
        }
        public ObservableCollection<CheckListZam> ChlPrvniDen
        {
            get { return _chlPrvniDen; }
            set
            {
                if (_chlPrvniDen != value)
                {
                    _chlPrvniDen = value;
                    OnPropertyChanged("ChlPrvniDen");
                }
            }
        }
        public ObservableCollection<CheckListStanice> ChlStanice
        {
            get { return _chlStanice; }
            set
            {
                if (_chlStanice != value)
                {
                    _chlStanice = value;
                    OnPropertyChanged("ChlStanice");
                }
            }
        }
        public ObservableCollection<CheckListZam> ChlPravidla
        {
            get { return _chlPravidla; }
            set
            {
                if (_chlPravidla != value)
                {
                    _chlPravidla = value;
                    OnPropertyChanged("ChlPravidla");
                }
            }
        }
        public Hodnoceni HodZam
        {
            get { return _hodZam; }
            set
            {
                if (_hodZam != value)
                {
                    _hodZam = value;
                    OnPropertyChanged("HodZam");
                }
            }
        }
        public DetailKartyViewModel(Zamestnanec zam)
        {
            if (zam != null && zam.id != 0)
            {
                Zam = new Zamestnanec(zam);
                
                Task.Run(() =>
                {
                    IsBusy = true;

                    ChlPrvniDen = CheckListZam.SelectCheckListZam(Zam.id, 1);
                    ChlPravidla = CheckListZam.SelectCheckListZam(Zam.id, 3);
                    ChlStanice = CheckListStanice.SelectCheckListStaniceZam(Zam.id);
                    if (ChlStanice.Count == 0)
                    {
                        App.Current.Dispatcher.Invoke((Action)delegate
                        {
                            ChlStanice.Add(new CheckListStanice { idZam = Zam.id });
                        });   
                    }
                    Zam.seznamHodnoceni = Hodnoceni.SelectVsechnaHodnoceniZam(Zam.id);
                    SpocitatHodnoceni();
                    IsBusy = false;
                });
            }
        }

        private void SpocitatHodnoceni()
        {
            HodZam.chlPrvniDen = true;
            HodZam.chlPravidla = true;
            HodZam.chlStanice = true;
            HodZam.pocetSeznamen = 0;
            foreach (var item in ChlPrvniDen)
            {
                if (item.splneno == 0)
                {
                    HodZam.chlPrvniDen = false;
                    break;
                }
            }
            foreach (var item in ChlPravidla)
            {
                if (item.splneno == 0)
                {
                    HodZam.chlPravidla = false;
                    break;
                }
            }
            foreach (var item in ChlStanice)
            {

                if (item.seznamen) HodZam.pocetSeznamen += 1;
                if (HodZam.chlStanice && item.hodnoceni < 3) HodZam.chlStanice = false;
                HodZam.hodnoceniStanic += item.hodnoceni;
            }
            HodZam.hodnoceniStanic = (HodZam.hodnoceniStanic * 100) / (ChlStanice.Count * 5);
            //HodZam.seznamFeedbacku = Feedback.SelectFeedbackyZam(Zam.id);
        }
    }
}
