﻿using eTraining.Commands;
using eTraining.Helpers;
using eTraining.Models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace eTraining.ViewModels.KartaZamVM
{
    class KartaZamViewModel : ViewModelBase, IPageViewModel
    {
        public static event EventHandlerZpet Zpet = delegate { };
        public static event EventHandlerZatmavit Zatmavit = delegate { };
        public static event EventHandlerTisk TiskKarty = delegate { };
        public static event EventHandlerZaskolovaciInstrukce Instrukce = delegate { };
        public static event EventHandlerPriruckyMA Prirucky = delegate { };
        public static event EventHandlerPriruckyMA Manual = delegate { };
        private ObservableCollection<CheckListStanice> seznamProSmazaniStanic;

        private bool _isBusy;
        private Zamestnanec _zam;
        private ObservableCollection<CheckListZam> _chlPrvniDen;
        private ObservableCollection<CheckListStanice> _chlStanice;
        private ObservableCollection<CheckListZam> _chlPravidla;
        private Hodnoceni _aktualniHodnoceni;
        private ObservableCollection<MaskaStanic> _maskyStanic;
        private bool _zobrazeniInfa;
        private bool _zatemnit;
        private string _infoPopis;
        private bool _zobrazeniUzavreniHodnoceni = false;
        private bool _zobrazenaMaska;
        private Opravneni _opravneniUzivatele;
        public RelayCommand<CheckListStanice> OdebratRadekStaniceCommand { get; private set; }
        public RelayCommand UlozitCommand { get; private set; }
        public RelayCommand UzavritKartuCommand { get; private set; }
        public RelayCommand OtevritKartuCommand { get; private set; }
        public RelayCommand PridatRadekStaniceCommand { get; private set; }
        public RelayCommand<int> PridatMaskuStaniceCommand { get; private set; }
        public RelayCommand PridatHodnoceniCommand { get; private set; }
        public RelayCommand ZobrazitPridaniHodnoceniCommand { get; private set; }
        public RelayCommand ZrusitPridaniHodnoceniCommand { get; private set; }
        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public RelayCommand<string> ZmenitZobrazeniMaskyCommand { get; private set; }
        public RelayCommand OtevritInstrukceCommand { get; private set; }
        public RelayCommand OtevritPriruckyCommand { get; private set; }
        public RelayCommand OtevritManualCommand { get; private set; }
        public RelayCommand TiskCommand { get; private set; }
        
        public string Name
        {
            get
            {
                return "Zadani";
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public Zamestnanec Zam
        {
            get { return _zam; }
            set
            {
                if (_zam != value)
                {
                    _zam = value;
                    OnPropertyChanged("Zam");
                }
            }
        }
        public ObservableCollection<CheckListZam> ChlPrvniDen
        {
            get { return _chlPrvniDen; }
            set
            {
                if (_chlPrvniDen != value)
                {
                    _chlPrvniDen = value;
                    OnPropertyChanged("ChlPrvniDen");
                }
            }
        }
        public Hodnoceni AktualniHodnoceni
        {
            get { return _aktualniHodnoceni; }
            set
            {
                if (_aktualniHodnoceni != value)
                {
                    _aktualniHodnoceni = value;
                    OnPropertyChanged("AktualniHodnoceni");
                }
            }
        }
        public ObservableCollection<MaskaStanic> MaskyStanic
        {
            get { return _maskyStanic; }
            set
            {
                if (_maskyStanic != value)
                {
                    _maskyStanic = value;
                    OnPropertyChanged("MaskyStanic");
                }
            }
        }
        public bool ZobrazeniInfa
        {
            get { return _zobrazeniInfa; }
            set
            {
                if (_zobrazeniInfa != value)
                {
                    _zobrazeniInfa = value;
                    OnPropertyChanged("ZobrazeniInfa");
                }
            }
        }
        public bool Zatemnit
        {
            get { return _zatemnit; }
            set
            {
                if (_zatemnit != value)
                {
                    _zatemnit = value;
                    OnPropertyChanged("Zatemnit");
                }
            }
        }
        public string InfoPopis
        {
            get { return _infoPopis; }
            set
            {
                if (_infoPopis != value)
                {
                    _infoPopis = value;
                    OnPropertyChanged("InfoPopis");
                }
            }
        }
        public bool ZobrazeniUzavreniHodnoceni
        {
            get { return _zobrazeniUzavreniHodnoceni; }
            set
            {
                if (_zobrazeniUzavreniHodnoceni != value)
                {
                    _zobrazeniUzavreniHodnoceni = value;
                    OnPropertyChanged("ZobrazeniUzavreniHodnoceni");
                }
            }
        }
        public ObservableCollection<CheckListStanice> ChlStanice
        {
            get { return _chlStanice; }
            set
            {
                if (_chlStanice != value)
                {
                    _chlStanice = value;
                    OnPropertyChanged("ChlStanice");
                }
            }
        }
        public ObservableCollection<CheckListZam> ChlPravidla
        {
            get { return _chlPravidla; }
            set
            {
                if (_chlPravidla != value)
                {
                    _chlPravidla = value;
                    OnPropertyChanged("ChlPravidla");
                }
            }
        }
        public bool ZobrazenaMaska
        {
            get { return _zobrazenaMaska; }
            set
            {
                if (_zobrazenaMaska != value)
                {
                    _zobrazenaMaska = value;
                    OnPropertyChanged("ZobrazenaMaska");
                }
            }
        }
        public Opravneni OpravneniUzivatele
        {
            get { return _opravneniUzivatele; }
            set
            {
                if (_opravneniUzivatele != value)
                {
                    _opravneniUzivatele = value;
                    OnPropertyChanged("OpravneniUzivatele");
                }
            }
        }
        public KartaZamViewModel(Zamestnanec zamestnanec, Opravneni opravneni)
        {
            Zam = zamestnanec;
            OpravneniUzivatele = opravneni;
            Task.Run(() =>
            {
                IsBusy = true;

                ChlPrvniDen = CheckListZam.SelectCheckListZam(Zam.id, 1);
                ChlPravidla = CheckListZam.SelectCheckListZam(Zam.id, 3);
                ChlStanice = CheckListStanice.SelectCheckListStaniceZam(Zam.id);
                if (ChlStanice.Count == 0) ChlStanice.Add(new CheckListStanice { idZam = Zam.id, datumVlozeni = DateTime.Now });
                Zam.seznamHodnoceni = Hodnoceni.SelectHistorieHodnoceniZam(Zam.id);
                AktualniHodnoceni = Hodnoceni.SelectAktualniHodnoceniZam(Zam.id);
                
                IsBusy = false;
            });
            OdebratRadekStaniceCommand = new RelayCommand<CheckListStanice>(param => this.OdebratRadekStanice(param));
            PridatRadekStaniceCommand = new RelayCommand(param => this.PridatRadekStanice());
            PridatMaskuStaniceCommand = new RelayCommand<int>(param => this.PridatMaskuStanice(param));
            PridatHodnoceniCommand = new RelayCommand(param => this.PridatHodnoceni());
            ZobrazitPridaniHodnoceniCommand = new RelayCommand(param => this.ZobrazitPridaniHodnoceni());
            ZrusitPridaniHodnoceniCommand = new RelayCommand(param => this.ZrusitPridaniHodnoceni());
            UlozitCommand = new RelayCommand(param => this.Ulozit());
            UzavritKartuCommand = new RelayCommand(param => this.UzavritKartu());
            OtevritKartuCommand = new RelayCommand(param => this.OtevritKartu());
            ZpetNaUvodCommand = new RelayCommand(param => this.ZpetNaUvod());
            ZmenitZobrazeniMaskyCommand = new RelayCommand<string>(param => this.ZmenitZobrazeniMasky(param));
            OtevritInstrukceCommand = new RelayCommand(param => this.OtevritInstrukce());
            OtevritPriruckyCommand = new RelayCommand(param => this.OtevritPrirucky());
            OtevritManualCommand = new RelayCommand(param => this.OtevritManual());
            TiskCommand = new RelayCommand(param => this.Tisk());
        }
        private void NacteniDatMasky()
        {
            MaskyStanic = MaskaStanic.SelectMasky();
            ObservableCollection<Stanice> seznamStanicProNacteni = Stanice.SelectStaniceMasek(MaskyStanic);
            foreach (var item in MaskyStanic)
            {
                item.seznamStanic = new ObservableCollection<Stanice>(seznamStanicProNacteni.Where(d => d.idMasky == item.id).Select(d => d).ToList().OrderBy(d => d.id));
            }
        }
        private void OdebratRadekStanice(CheckListStanice radek)
        {
            if (radek.id != 0)
            {
                if (seznamProSmazaniStanic == null) seznamProSmazaniStanic = new ObservableCollection<CheckListStanice>();
                seznamProSmazaniStanic.Add(radek);
            }
            ChlStanice.Remove(radek);
        }
        private void PridatRadekStanice()
        {
            ChlStanice.Add(new CheckListStanice { idZam = Zam.id, datumVlozeni = DateTime.Now });
        }
        private void PridatMaskuStanice(int idMasky)
        {
            Kontrola();
            foreach (var item in MaskyStanic.Where(d=>d.id == idMasky).FirstOrDefault().seznamStanic)
            {
                ChlStanice.Add(new CheckListStanice { idZam = Zam.id, stanice = item.nazev, datumVlozeni = DateTime.Now });
            }
            
        }
        private void PridatHodnoceni()
        {
            Hodnoceni.UlozitHodnoceni(AktualniHodnoceni, true);
            
            Zam.seznamHodnoceni.Add(new Hodnoceni {
                id = AktualniHodnoceni.id,
                idZam = AktualniHodnoceni.idZam,
                poznamka = AktualniHodnoceni.poznamka,
                hodnoceniStanic = AktualniHodnoceni.hodnoceniStanic,
                chlPrvniDen = AktualniHodnoceni.chlPrvniDen,
                chlPravidla = AktualniHodnoceni.chlPravidla,
                pocetStanic = AktualniHodnoceni.pocetStanic,
                uzavreno = true,
                datumHodnoceni = DateTime.Now
            });

            AktualniHodnoceni.poznamka = "";
            AktualniHodnoceni.id = Hodnoceni.VlozitNoveHodnoceni(AktualniHodnoceni);
            Zatemnit = false;
            ZobrazeniInfa = false;
            ZobrazeniUzavreniHodnoceni = false;
            Zatmavit(false);
        }
        private void ZobrazitPridaniHodnoceni()
        {
            Zatemnit = true;
            ZobrazeniInfa = true;
            ZobrazeniUzavreniHodnoceni = true;
            Zatmavit(true);
        }
        private void ZrusitPridaniHodnoceni()
        {
            Zatemnit = false;
            ZobrazeniInfa = false;
            ZobrazeniUzavreniHodnoceni = false;
            Zatmavit(false);
        }
        private Hodnoceni SpocitatHodnoceni(int idHodnoceni)
        {

            Hodnoceni hodZam = new Hodnoceni();
            hodZam.id = idHodnoceni;
            hodZam.poznamka = AktualniHodnoceni.poznamka;
            hodZam.idZam = Zam.id;
            hodZam.hodnoceniStanic = 0;
            hodZam.chlPrvniDen = true;
            hodZam.chlPravidla = true;
            hodZam.chlStanice = true;
            hodZam.pocetStanic = ChlStanice.Count;
            foreach (var item in ChlPrvniDen)
            {
                if (item.splneno == 0)
                {
                    hodZam.chlPrvniDen = false;
                    break;
                }
            }
            foreach (var item in ChlPravidla)
            {
                if (item.splneno == 0)
                {
                    hodZam.chlPravidla = false;
                    break;
                }
            }
            foreach (var item in ChlStanice)
            {
                hodZam.hodnoceniStanic += item.hodnoceni;
                if (hodZam.chlStanice && item.hodnoceni < 3) hodZam.chlStanice = false;
            }
            hodZam.hodnoceniStanic = (hodZam.hodnoceniStanic * 100) / (ChlStanice.Count * 5);

            return hodZam;
        }
        
        private void Ulozit()
        {
            bool uspesny = true;
            
            IsBusy = true;
            uspesny = Kontrola();
            Task.Run(() =>
            {
                if (uspesny)
                {
                    uspesny = CheckListZam.EditaceHromadnaCheckListuZam(new ObservableCollection<CheckListZam>(ChlPrvniDen.Union(ChlPravidla)));
                    if (uspesny)
                    {
                        if (ChlStanice.Count > 0)
                        {
                            ChlStanice = CheckListStanice.VlozitCheckListStanicZam(ChlStanice);
                        }
                        else
                        {
                            App.Current.Dispatcher.Invoke((Action)delegate
                            {
                                ChlStanice.Add(new CheckListStanice { idZam = Zam.id, datumVlozeni = DateTime.Now });
                            });
                        }

                        uspesny = Zamestnanec.UlozitHodnoceni(Zam);
                        AktualniHodnoceni = Hodnoceni.UlozitHodnoceni(SpocitatHodnoceni(AktualniHodnoceni.id), false);
                        if (seznamProSmazaniStanic != null)
                        {
                            uspesny = CheckListStanice.SmazatStanice(seznamProSmazaniStanic);
                            seznamProSmazaniStanic = null;
                        }
                        
                        IsBusy = false;
                        if (uspesny)
                        {
                            Task.Run(() =>
                            {
                                Zatmavit(true);

                                Zatemnit = true;
                                ZobrazeniInfa = true;
                                InfoPopis = "Data byla úspěšně uložena.";
                                System.Threading.Thread.Sleep(2000);
                                Zatemnit = false;
                                ZobrazeniInfa = false;
                                Zatmavit(false);
                            });
                        }                        
                    }
                }
                IsBusy = false;
            });
        }
        private void UzavritKartu()
        {
            bool uspesny = true;

            IsBusy = true;
            uspesny = Kontrola();
            
            
            Task.Run(() =>
            {
                if (uspesny)
                {
                    if (CheckListZam.EditaceHromadnaCheckListuZam(new ObservableCollection<CheckListZam>(ChlPrvniDen.Union(ChlPravidla))))
                    {
                        if (ChlStanice.Count > 0) ChlStanice = CheckListStanice.VlozitCheckListStanicZam(ChlStanice);
                        else
                        {
                            App.Current.Dispatcher.Invoke((Action)delegate
                            {
                                ChlStanice.Add(new CheckListStanice { idZam = Zam.id, datumVlozeni = DateTime.Now });
                            });
                        }
                        Zamestnanec.UlozitHodnoceni(Zam);
                        AktualniHodnoceni = Hodnoceni.UlozitHodnoceni(SpocitatHodnoceni(AktualniHodnoceni.id), false);
                        Zam.uzavrenoDatum = DateTime.Now;
                        Zam.pocetDniZaskoleni = (Zam.uzavrenoDatum.Value.Date - Zam.datumNastupu).Days;
                        if (Zam.uzavrenoDatum.Value.Date <= Zam.terminZaskoleni)
                        {
                            if (Zam.pocetDniZaskoleni <= 14) Zam.verzeZaskoleni = 4;
                            else if (Zam.pocetDniZaskoleni > 14 && Zam.pocetDniZaskoleni <= 31) Zam.verzeZaskoleni = 5;
                            else Zam.verzeZaskoleni = 6;
                        }
                        else
                            Zam.verzeZaskoleni = 7;

                        Zam.uzavreno = true;
                        if (Zamestnanec.UzavritZamestnance(Zam))
                        {
                            IsBusy = false;
                            Task.Run(() =>
                            {
                                Zatmavit(true);
                                Zatemnit = true;

                                
                                ZobrazenaMaska = false;
                                ZobrazeniInfa = true;
                                InfoPopis = "Karta byla úspěšně uzavřena.";
                                System.Threading.Thread.Sleep(2000);
                                ZobrazeniInfa = false;
                                Zatemnit = false;
                                Zatmavit(false);
                            });
                        }
                    }
                }
                IsBusy = false;
            });   
        }
        private void OtevritKartu()
        {
            Zam.uzavreno = false;
            Zam.uzavrenoDatum = null;
            if (Zamestnanec.UzavritZamestnance(Zam))
            {
                IsBusy = false;
                Task.Run(() =>
                {
                    Zatmavit(true);
                    ZobrazeniInfa = true;
                    Zatemnit = true;
                    Zam.pocetDniZaskoleni = (DateTime.Now.Date - Zam.datumNastupu).Days;
                    if (Zam.pocetDniZaskoleni < 0 && DateTime.Now.Date <= Zam.terminZaskoleni) Zam.pocetDniZaskoleni = 0;
                    if (Zam.pocetDniZaskoleni < 15 && DateTime.Now.Date <= Zam.terminZaskoleni) Zam.verzeZaskoleni = 1;
                    else if (Zam.pocetDniZaskoleni >= 15 && DateTime.Now.Date <= Zam.terminZaskoleni) Zam.verzeZaskoleni = 2;
                    else Zam.verzeZaskoleni = 3;
                    InfoPopis = "Karta byla úspěšně otevřena.";
                    System.Threading.Thread.Sleep(2000);
                    ZobrazeniInfa = false;
                    Zatemnit = false;
                    Zatmavit(false);
                });
            }
        }
        private bool Kontrola()
        {
            int count = ChlStanice.Count;
            bool kontrolaVyplneni = false;
            for (int i = 0; i < ChlStanice.Count; i++)
            {
                if (ChlStanice[i].hodnoceni > 0 && !kontrolaVyplneni)
                {
                    kontrolaVyplneni = true;
                }
                if (ChlStanice[i].id == 0 && String.IsNullOrEmpty(ChlStanice[i].stanice))
                {
                    App.Current.Dispatcher.Invoke((Action)delegate
                    {
                        ChlStanice.Remove(ChlStanice[i]);
                        i--;
                    });
                }
            }
            if (ChlStanice.Count > 0 && Properties.Settings.Default.kontrolaSkoliteleStanice && kontrolaVyplneni)
            {
                if (string.IsNullOrWhiteSpace(Zam.jmenoSkolitele))
                {
                    Zatmavit(true);
                    Zatemnit = true;
                    ErrorWindow error = new ErrorWindow();
                    error.Owner = System.Windows.Application.Current.MainWindow;
                    error.TextVarovani = "Není vyplněno jméno školitele v sekci Proškolení stanic!";
                    error.ShowDialog();
                    Zatemnit = false;
                    Zatmavit(false);
                    return false;
                }   
            }
            

            if (Zam.terminZaskoleni < DateTime.Now.Date)
            {
                Zam.poznamka += DateTime.Now.ToShortDateString() + ": Termín zaškolení nesplněn; ";
            }
            return true;
        }
        private void ZmenitZobrazeniMasky(string zavrit)
        {
            if (zavrit == "0") ZobrazenaMaska = false;
            else
            {
                NacteniDatMasky();
                ZobrazenaMaska = true;
            }
        }
        private void Tisk()
        {
            Zatemnit = true;
            TiskKarty();
            Zatemnit = false;
        }
        private void OtevritInstrukce()
        {
            Instrukce();
        }
        private void OtevritPrirucky()
        {
            Prirucky();
        }
        private void OtevritManual()
        {
            Manual();
        }
        private void ZpetNaUvod()
        {
            Zpet();
        }
    }
}
