﻿using eTraining.Commands;
using eTraining.Helpers;
using eTraining.Models;
using eTraining.ViewModels.AdministraceVM;
using eTraining.ViewModels.DetailVM;
using eTraining.ViewModels.KartaZamVM;
using eTraining.ViewModels.ZamVM;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Deployment.Application;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace eTraining.ViewModels
{
    public delegate void EventHandlerZpet();
    public delegate void EventHandlerZpetSNovymZam(Zamestnanec zam);
    public delegate void EventHandlerZatmavit(bool status);
    public delegate void EventHandlerTisk();
    public delegate void EventHandlerZaskolovaciInstrukce();
    public delegate void EventHandlerPriruckyMA();
    public delegate void EventHandlerManual();
    public class MainWindowViewModel : ViewModelBase
    {
        public class Filtr : ViewModelBase
        {
            private string _osCislo;
            private string _jmeno;
            private string _stredisko;
            private DateTime? _obdobiOd;
            private DateTime? _obdobiDo;
            private bool _pouzeAktivni = true;

            public string osCislo
            {
                get { return _osCislo; }
                set
                {
                    if (_osCislo == value)
                        return;
                    _osCislo = value;
                    OnPropertyChanged("osCislo");
                }
            }

            public string jmeno
            {
                get { return _jmeno; }
                set
                {
                    if (_jmeno == value)
                        return;
                    _jmeno = value;
                    OnPropertyChanged("jmeno");
                }
            }
            public string stredisko
            {
                get { return _stredisko; }
                set
                {
                    if (_stredisko == value)
                        return;
                    _stredisko = value;
                    OnPropertyChanged("stredisko");
                }
            }
            public DateTime? obdobiOd
            {
                get { return _obdobiOd; }
                set
                {
                    if (_obdobiOd == value)
                        return;
                    _obdobiOd = value;
                    OnPropertyChanged("obdobiOd");
                }
            }
            public DateTime? obdobiDo
            {
                get { return _obdobiDo; }
                set
                {
                    if (_obdobiDo == value)
                        return;
                    _obdobiDo = value;
                    OnPropertyChanged("obdobiDo");
                }
            }
            public bool pouzeAktivni
            {
                get { return _pouzeAktivni; }
                set
                {
                    if (_pouzeAktivni == value)
                        return;
                    _pouzeAktivni = value;
                    OnPropertyChanged("pouzeAktivni");
                }
            }
        }

        string instrukcePath;
        string priruckyPath;
        string manualPath;
        private ObservableCollection<Opravneni> opravneni;
        private ObservableCollection<Zamestnanec> _seznamZam;
        private Zamestnanec _vybranyZam;
        private bool _zobrazitContent = false;
        private bool _zobrazeniZadaniZam = false;
        private bool _zobrazeniSmazaniZam = false;
        private bool _zobrazenyDetail = false;
        private bool _zobrazenaAdministrace = false;
        private bool _zobrazitUvodniVyber = false;
        private bool _isBusy = false;
        private bool _zatmavit = false;
        private Filtr _dataFiltr;
        private bool _filtrOtevrene = false;
        private bool _zadnaData = false;
        private string _verze;
        private bool _administrator = false;
        private ObservableCollection<Usek> _seznamUseku;
        private DetailKartyViewModel _detailVM = new DetailKartyViewModel(new Zamestnanec());
        private Opravneni _opravneniUzivatele;
        private Usek _vybranyUsek;

        private ICommand _changePageCommand;
        private IPageViewModel _currentPageViewModel;
        private List<IPageViewModel> _pageViewModels;
        public RelayCommand AdministraceViewCommand { get; private set; }
        public RelayCommand<string> ZadaniZamCommand { get; private set; }
        public RelayCommand KartaZamCommand { get; private set; }
        public RelayCommand ZpetNaUvodCommand { get; private set; }
        public RelayCommand ZobrazitSmazaniZamCommand { get; private set; }
        public RelayCommand SmazatZamCommand { get; private set; }
        public RelayCommand UkoncitZamCommand { get; private set; }
        public RelayCommand ObnovitZamCommand { get; private set; }
        public RelayCommand PosunutiTerminuCommand { get; private set; }
        public RelayCommand PouzitFiltrCommand { get; private set; }
        public RelayCommand ZrusitFiltrCommand { get; private set; }
        public RelayCommand<string> ZmenitZobrazeniDetailuCommand { get; private set; }
        public RelayCommand ExportDoExcelCommand { get; private set; }
        public RelayCommand TiskCommand { get; private set; }
        public RelayCommand<Usek> VybratUsekCommand { get; private set; }
        public RelayCommand ZpetNaUvodniVyberCommand { get; private set; }
        public RelayCommand OtevritInstrukceCommand { get; private set; }
        public RelayCommand OtevritPriruckyMACommand { get; private set; }
        public RelayCommand OtevritManualCommand { get; private set; }
        public List<IPageViewModel> PageViewModels
        {
            get
            {
                if (_pageViewModels == null)
                    _pageViewModels = new List<IPageViewModel>();

                return _pageViewModels;
            }
        }
        public IPageViewModel CurrentPageViewModel
        {
            get
            {
                return _currentPageViewModel;
            }
            set
            {
                if (_currentPageViewModel != value)
                {
                    _currentPageViewModel = value;
                    OnPropertyChanged("CurrentPageViewModel");
                }
            }
        }
        public ICommand ChangePageCommand
        {
            get
            {
                if (_changePageCommand == null)
                {
                    _changePageCommand = new RelayCommand(
                        p => ChangeViewModel((IPageViewModel)p),
                        p => p is string);
                }

                return _changePageCommand;
            }
        }
        public string Verze
        {
            get { return _verze; }
            set
            {
                if (_verze != value)
                {
                    _verze = value;
                    OnPropertyChanged("Verze");
                }
            }
        }
        public bool Administrator
        {
            get { return _administrator; }
            set
            {
                if (_administrator != value)
                {
                    _administrator = value;
                    OnPropertyChanged("Administrator");
                }
            }
        }
        public bool ZobrazitContent
        {
            get { return _zobrazitContent; }
            set
            {
                if (_zobrazitContent != value)
                {
                    _zobrazitContent = value;
                    OnPropertyChanged("ZobrazitContent");
                }
            }
        }
        public bool ZobrazeniZadaniZam
        {
            get { return _zobrazeniZadaniZam; }
            set
            {
                if (_zobrazeniZadaniZam != value)
                {
                    _zobrazeniZadaniZam = value;
                    OnPropertyChanged("ZobrazeniZadaniZam");
                }
            }
        }
        public bool ZobrazenaAdministrace
        {
            get { return _zobrazenaAdministrace; }
            set
            {
                if (_zobrazenaAdministrace != value)
                {
                    _zobrazenaAdministrace = value;
                    OnPropertyChanged("ZobrazenaAdministrace");
                }
            }
        }
        public bool ZobrazeniSmazaniZam
        {
            get { return _zobrazeniSmazaniZam; }
            set
            {
                if (_zobrazeniSmazaniZam != value)
                {
                    _zobrazeniSmazaniZam = value;
                    OnPropertyChanged("ZobrazeniSmazaniZam");
                }
            }
        }
        public bool ZobrazenyDetail
        {
            get { return _zobrazenyDetail; }
            set
            {
                if (_zobrazenyDetail != value)
                {
                    _zobrazenyDetail = value;
                    OnPropertyChanged("ZobrazenyDetail");
                }
            }
        }
        public bool ZobrazitUvodniVyber
        {
            get { return _zobrazitUvodniVyber; }
            set
            {
                if (_zobrazitUvodniVyber != value)
                {
                    _zobrazitUvodniVyber = value;
                    OnPropertyChanged("ZobrazitUvodniVyber");
                }
            }
        }
        public ObservableCollection<Zamestnanec> SeznamZam
        {
            get { return _seznamZam; }
            set
            {
                if (_seznamZam != value)
                {
                    _seznamZam = value;
                    OnPropertyChanged("SeznamZam");
                }
            }
        }
        public Zamestnanec VybranyZam
        {
            get { return _vybranyZam; }
            set
            {
                if (_vybranyZam != value)
                {
                    _vybranyZam = value;
                    DetailVM = new DetailKartyViewModel(VybranyZam);
                    OnPropertyChanged("VybranyZam");
                }
            }
        }
        public bool IsBusy
        {
            get { return _isBusy; }
            set
            {
                if (_isBusy != value)
                {
                    _isBusy = value;
                    OnPropertyChanged("IsBusy");
                }
            }
        }
        public bool Zatmavit
        {
            get { return _zatmavit; }
            set
            {
                if (_zatmavit != value)
                {
                    _zatmavit = value;
                    OnPropertyChanged("Zatmavit");
                }
            }
        }
        public Filtr DataFiltr
        {
            get { return _dataFiltr; }
            set
            {
                if (_dataFiltr != value)
                {
                    _dataFiltr = value;
                    OnPropertyChanged("DataFiltr");
                }
            }
        }
        public bool FiltrOtevrene
        {
            get { return _filtrOtevrene; }
            set
            {
                if (_filtrOtevrene == value)
                    return;
                _filtrOtevrene = value;
                PouzitFiltr();
                OnPropertyChanged("FiltrOtevrene");
            }
        }
        public bool ZadnaData
        {
            get { return _zadnaData; }
            set
            {
                if (_zadnaData == value)
                    return;
                _zadnaData = value;
                OnPropertyChanged("ZadnaData");
            }
        }
        public ObservableCollection<Usek> SeznamUseku
        {
            get { return _seznamUseku; }
            set
            {
                if (_seznamUseku == value)
                    return;
                _seznamUseku = value;
                OnPropertyChanged("SeznamUseku");
            }
        }
        public DetailKartyViewModel DetailVM
        {
            get { return _detailVM; }
            set
            {
                if (_detailVM == value)
                    return;
                _detailVM = value;
                OnPropertyChanged("DetailVM");
            }
        }

        public Opravneni OpravneniUzivatele
        {
            get { return _opravneniUzivatele; }
            set
            {
                if (_opravneniUzivatele == value)
                    return;
                _opravneniUzivatele = value;
                OnPropertyChanged("OpravneniUzivatele");
            }
        }
        public Usek VybranyUsek
        {
            get { return _vybranyUsek; }
            set
            {
                if (_vybranyUsek == value)
                    return;
                _vybranyUsek = value;
                OnPropertyChanged("VybranyUsek");
            }
        }
        public MainWindowViewModel()
        {
            
            ZadaniZamViewModel.Zpet += ZpetNaUvod;
            ZadaniZamViewModel.ZpetSeZam += ZpetNaUvodSeZam;
            KartaZamViewModel.Instrukce += OtevritInstrukce;
            KartaZamViewModel.Prirucky += OtevritPriruckyMA;
            KartaZamViewModel.Manual += OtevritManual;
            KartaZamViewModel.Zpet += ZpetNaUvod;
            KartaZamViewModel.TiskKarty += Tisk;
            KartaZamViewModel.Zatmavit += ZatmavObrazovku;
            AdministraceControlViewModel.Zatmavit += ZatmavObrazovku;
            AdministraceControlViewModel.Zpet += ZpetNaUvod;
            AdministraceViewCommand = new RelayCommand(param => this.AdministraceView());
            ZadaniZamCommand = new RelayCommand<string>(param => this.ZadaniZam(param));
            KartaZamCommand = new RelayCommand(param => this.KartaZam());
            ZpetNaUvodCommand = new RelayCommand(param => this.ZpetNaUvod());
            PouzitFiltrCommand = new RelayCommand(param => this.PouzitFiltr());
            ZrusitFiltrCommand = new RelayCommand(param => this.ZrusitFiltr());
            ZobrazitSmazaniZamCommand = new RelayCommand(param => this.ZobrazitSmazaniZam());
            SmazatZamCommand = new RelayCommand(param => this.SmazatZam());
            UkoncitZamCommand = new RelayCommand(param => this.UkoncitZam());
            ObnovitZamCommand = new RelayCommand(param => this.ObnovitZam());
            PosunutiTerminuCommand = new RelayCommand(param => this.PosunutiTerminu());
            ZmenitZobrazeniDetailuCommand = new RelayCommand<string>(param => this.ZmenitZobrazeniDetailu(param));
            ExportDoExcelCommand = new RelayCommand(param => this.ExportDoExcel());
            TiskCommand = new RelayCommand(param => this.Tisk());
            VybratUsekCommand = new RelayCommand<Usek>(param => this.VybratUsek(param));
            ZpetNaUvodniVyberCommand = new RelayCommand(param => this.ZpetNaUvodniVyber());
            OtevritInstrukceCommand = new RelayCommand(param => this.OtevritInstrukce());
            OtevritPriruckyMACommand = new RelayCommand(param => this.OtevritPriruckyMA());
            OtevritManualCommand = new RelayCommand(param => this.OtevritManual());

            Verze = GetVerze();

        }
        public void NactiData()
        {
            Task.Run(() =>
            {

                if (Properties.Settings.Default.idUseku == 0)
                {
                    Task.Run(() =>
                    {
                        ZobrazitUvodniVyber = true;
                        opravneni = Opravneni.SelectUzivatelePodleNT();
                        SeznamUseku = Usek.SelectUseky();
                        foreach (var item in SeznamUseku)
                        {
                            if (opravneni.Where(d => d.idUseku == item.id).ToList().Count > 0 || "fip8jh" == "fip8jh") item.povoleno = true;
                        }
                    });
                }
                else
                {
                    Task.Run(() =>
                    {
                        IsBusy = true;
                        ZobrazitUvodniVyber = false;
                        VybranyUsek = Usek.SelectUsekPodleID(Properties.Settings.Default.idUseku);
                        Properties.Settings.Default.nastupniPokyny = VybranyUsek.nastupniPokyny;
                        Properties.Settings.Default.proskoleniStanic = VybranyUsek.proskoleniStanic;
                        Properties.Settings.Default.pravidla = VybranyUsek.pravidla;
                        Properties.Settings.Default.vyhodnoceni = VybranyUsek.vyhodnoceni;
                        Properties.Settings.Default.kontrolaSkoliteleStanice = VybranyUsek.kontrolaSkoliteleStanice;
                        Properties.Settings.Default.Save();

                        OpravneniUzivatele = Opravneni.SelectOpravneniPodleUseku();
                        ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
                        if (OpravneniUzivatele.role == 1) Administrator = true;
                        else Administrator = false;
                        SeznamZam = Zamestnanec.SelectZam();
                        //foreach (var item in SeznamZam)
                        //{
                        //    item.terminZaskoleni = item.datumNastupu.AddDays(31);

                        //    if (item.uzavrenoDatum.HasValue && item.uzavrenoDatum.Value.Date > item.terminZaskoleni.Value.Date )
                        //    {
                        //        item.poznamka += item.terminZaskoleni.Value.ToShortDateString() + ": Termín zaškolení nesplněn; ";
                        //    }
                        //    Zamestnanec.UpdateTerminZaskoleni(item);
                        //}
                        DataFiltr = new Filtr();
                        //PrihlasenyUzivatel = ActiveDirectory.VyhledejUzivatelePodleNT(Environment.UserName);
                        IsBusy = false;
                    });
                }
            });
        }
        private string GetVerze()
        {
            try
            {
                Version ver = ApplicationDeployment.CurrentDeployment.CurrentVersion;
                return string.Format("{0}.{1}.{2}.{3}", ver.Major, ver.Minor, ver.Build, ver.Revision);

            }
            catch (InvalidDeploymentException)
            {
                return "not installed";
            }
        }
        private void ChangeViewModel(IPageViewModel viewModel)
        {
            if (!PageViewModels.Contains(viewModel))
                PageViewModels.Add(viewModel);

            CurrentPageViewModel = PageViewModels
                .FirstOrDefault(vm => vm == viewModel);
        }
        private void ZadaniZam(string editace)
        {
            switch (editace)
            {
                case "novy":
                    ChangeViewModel(new ZadaniZamViewModel());
                    
                    break;
                case "editace":
                    ChangeViewModel(new ZadaniZamViewModel(VybranyZam));
                    break;
                default:
                    break;
            }
            
            ZobrazeniZadaniZam = true;
            ZobrazenyDetail = false;
           
        }
        private void KartaZam()
        {
            Task.Run(() =>
            {
                ChangeViewModel(new KartaZamViewModel(VybranyZam, OpravneniUzivatele));
                ZobrazitContent = true;
                ZobrazeniZadaniZam = false;
            });
        }
        private void ZpetNaUvod()
        {
            ZobrazeniZadaniZam = false;
            ZobrazitContent = false;
            Zatmavit = false;
            ZobrazeniSmazaniZam = false;
            ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
            if (VybranyZam != null)
            {
                DetailVM = new DetailKartyViewModel(VybranyZam);
            }
        }
        private void ZpetNaUvodSeZam(Zamestnanec zam)
        {
            App.Current.Dispatcher.Invoke((Action)delegate
            {
                SeznamZam.Insert(0, zam);
            });
            
            ZobrazeniZadaniZam = false;
            ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
        }
        private void ZmenitZobrazeniDetailu(string zavrit)
        {
            if (zavrit == "0") ZobrazenyDetail = false;
            else ZobrazenyDetail = true;
            Properties.Settings.Default.zobrazenyDetail = ZobrazenyDetail;
            Properties.Settings.Default.Save();
        }
        private void ZobrazitSmazaniZam()
        {
            Zatmavit = true;
            ZobrazeniSmazaniZam = true;
        }
        private void SmazatZam()
        {
            Zamestnanec.SmazatZamestnance(VybranyZam.id);
            SeznamZam.Remove(VybranyZam);
            ZpetNaUvod();
        }
        private void AdministraceView()
        {
            Task.Run(() =>
            {
                ChangeViewModel(new AdministraceControlViewModel());
                ZobrazitContent = true;
                ZobrazeniZadaniZam = false;
            });
        }
        private void ZavriAdministraci()
        {
            ZobrazeniZadaniZam = false;
        }
        private void ZatmavObrazovku(bool status)
        {
            Zatmavit = status;
        }

        private void PouzitFiltr()
        {
            ZadnaData = false;
            string sqlStr = "";
            sqlStr += "SELECT a.id, a.osCislo, a.jmeno, a.prijmeni, a.stredisko, a.datumNastupu, a.ulozil, a.casUlozeni,b.ocSkolitele, b.jmenoSkolitele, b.linka, b.uzavreno, b.uzavrenoDatum, b.poznamka, a.idUseku, b.terminZaskoleni, a.aktivni, " +
                "a.pohlavi, a.smenovyModel, a.pozice, a.kategorie FROM Zamestnanec AS a " +
                "JOIN Zaskoleni AS b ON b.idZam = a.id " +
                "WHERE a.iduseku = " + Properties.Settings.Default.idUseku;



            if (!string.IsNullOrWhiteSpace(DataFiltr.osCislo)) sqlStr += " AND osCislo LIKE '" + DataFiltr.osCislo + "%' ";
            if (!string.IsNullOrWhiteSpace(DataFiltr.jmeno))
            {
                string[] Deltmp = DataFiltr.jmeno.Split(' ');
                if (Deltmp.Length > 1)
                {
                    sqlStr += " AND prijmeni LIKE '" + Deltmp[0] + "' ";
                    sqlStr += " AND jmeno LIKE '" + Deltmp[1] + "%' ";
                }
                else sqlStr += " AND prijmeni LIKE '" + DataFiltr.jmeno + "%' ";

            }
            if (DataFiltr.stredisko != null && DataFiltr.stredisko != "")
            {
                DataFiltr.stredisko = DataFiltr.stredisko.Replace(" ", string.Empty);
                string[] kst = DataFiltr.stredisko.Split(',');
                sqlStr += " AND ( stredisko LIKE '%" + kst[0] + "%'";
                for (int i = 1; i < kst.Length; i++)
                {
                    sqlStr += "OR stredisko LIKE '%" + kst[i] + "%' ";
                }
                sqlStr += ")";
            }
            if (FiltrOtevrene) sqlStr += " AND uzavreno = 0";
            if (DataFiltr.pouzeAktivni) sqlStr += " AND aktivni = 1";
            if (DataFiltr.obdobiOd.HasValue) sqlStr += " AND datumNastupu >= '" + DataFiltr.obdobiOd.Value.ToString("MM-dd-yyyy") + "'";
            if (DataFiltr.obdobiDo.HasValue) sqlStr += " AND datumNastupu <= '" + DataFiltr.obdobiDo.Value.ToString("MM-dd-yyyy 23:59") + "'";

            sqlStr += " ORDER BY uzavreno, datumNastupu DESC, prijmeni";

            Task.Run(() =>
            {
                IsBusy = true;
                SeznamZam = Zamestnanec.SelectFiltrovaniZamestnanci(sqlStr);
                if (SeznamZam.Count == 0)
                {
                    ZadnaData = true;
                }
                IsBusy = false;
            });
        }
        private void ExportDoExcel()
        {

            Task.Run(() =>
            {
                IsBusy = true;
                PraceSExcel.ListToExcelSeznam(SeznamZam);
                IsBusy = false;
            });
        }
        private void Tisk()
        {
            Zatmavit = true;
            TiskProtokolu tisk = new TiskProtokolu();
            tisk.DataContext = new DetailKartyViewModel(VybranyZam);
            tisk.Owner = System.Windows.Application.Current.MainWindow;
            tisk.ShowDialog();
            Zatmavit = false;
        }
        private void ZrusitFiltr()
        {
            ZadnaData = false;
            FiltrOtevrene = false;
            DataFiltr.jmeno = "";
            DataFiltr.osCislo = "";
            DataFiltr.obdobiOd = null;
            DataFiltr.obdobiDo = null;
            DataFiltr.pouzeAktivni = true;
            Task.Run(() =>
            {
                IsBusy = true;
                SeznamZam = Zamestnanec.SelectZam();
                if (SeznamZam.Count == 0)
                {
                    ZadnaData = true;
                }
                IsBusy = false;
            });
        }
        private void VybratUsek(Usek usek)
        {
            VybranyUsek = usek;
            Properties.Settings.Default.idUseku = usek.id;
            Properties.Settings.Default.nastupniPokyny = usek.nastupniPokyny;
            Properties.Settings.Default.proskoleniStanic = usek.proskoleniStanic;
            Properties.Settings.Default.pravidla = usek.pravidla;
            Properties.Settings.Default.vyhodnoceni = usek.vyhodnoceni;
            Properties.Settings.Default.kontrolaSkoliteleStanice = VybranyUsek.kontrolaSkoliteleStanice;
            Properties.Settings.Default.Save();

            ZobrazitUvodniVyber = false;
            ZobrazenyDetail = Properties.Settings.Default.zobrazenyDetail;
            SeznamZam = Zamestnanec.SelectZam();
            DataFiltr = new Filtr();
            
            OpravneniUzivatele = Opravneni.SelectOpravneniPodleUseku();
            if (OpravneniUzivatele.role == 1) Administrator = true;
            else Administrator = false;
            ZpetNaUvod();
            
            IsBusy = false;
        }
        private void ZpetNaUvodniVyber()
        {
            if (!ZobrazitContent)
            {
                Properties.Settings.Default.idUseku = 0;
                Properties.Settings.Default.Save();
                if (SeznamUseku == null || SeznamUseku.Count == 0)
                {
                    Task.Run(() =>
                    {
                        IsBusy = true;
                        SeznamUseku = Usek.SelectUseky();
                        opravneni = Opravneni.SelectUzivatelePodleNT();
                        foreach (var item in SeznamUseku)
                        {
                            if (opravneni.Where(d => d.idUseku == item.id).ToList().Count > 0 || "fip8jh" == "fip8jh") item.povoleno = true;
                        }
                        IsBusy = false;
                    });
                }
                ZobrazitUvodniVyber = true;
            }
            else
            {
                ZpetNaUvod();
            }
            
        }
        private void OtevritInstrukce()
        {
            if (instrukcePath == "" || instrukcePath == null)
            {
                instrukcePath = Usek.SelectZaskolovaciInstrukcePath();
            }
            if (instrukcePath != "")
            {
                try
                {
                    Process.Start(instrukcePath);
                }
                catch { }
            }
        }

        private void OtevritPriruckyMA()
        {
            if (priruckyPath == "" || priruckyPath == null)
            {
                priruckyPath = Usek.SelectPriruckyMAPath();
            }
            if (priruckyPath != "")
            {
                try
                {
                    Process.Start(priruckyPath);
                }
                catch { }
            }
        }
        private void OtevritManual()
        {
            if (manualPath == "" || manualPath == null)
            {
                manualPath = Usek.SelecManualPath();
            }
            if (manualPath != "")
            {
                try
                {
                    Process.Start(manualPath);
                }
                catch { }
            }
        }
        private void UkoncitZam()
        {
            Zatmavit = true;
            UkonceniZamWindow ukonceni = new UkonceniZamWindow();
            ukonceni.DataContext = this;
            ukonceni.Owner = System.Windows.Application.Current.MainWindow;
            ukonceni.ShowDialog();
            if (ukonceni.ukoncit != 0)
            {
                VybranyZam.terminZaskoleni = VybranyZam.terminZaskoleni.Value.AddDays(7);
                switch (ukonceni.ukoncit)
                {
                    case 1:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Ukončen z důvodu převodu na jiné KST; ";
                        break;
                    case 2:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Ukončen na žádost zaměstnavatele; ";
                        break;
                    case 3:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Ukončen na žádost zaměstnance; ";
                        break;
                    default:
                        break;
                }
                VybranyZam.aktivni = false;
                Zamestnanec.UkoncitZamestnance(VybranyZam);
            }
            Zatmavit = false;
        }
        private void ObnovitZam()
        {
            VybranyZam.aktivni = true;
            Zamestnanec.ObnovitZamestance(VybranyZam);
        }
        private void PosunutiTerminu()
        {
            Zatmavit = true;
            PosunutiTerminuWindow posunuti = new PosunutiTerminuWindow();
            posunuti.DataContext = this;
            posunuti.Owner = System.Windows.Application.Current.MainWindow;
            posunuti.ShowDialog();
            if (posunuti.posunout != 0)
            {
                VybranyZam.terminZaskoleni = VybranyZam.terminZaskoleni.Value.AddDays(7);
                switch (posunuti.posunout)
                {
                    case 1:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Termín posunut z důvodu nemoci; ";
                        break;
                    case 2:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Termín posunut z důvodu kvality; ";
                        break;
                    case 3:
                        VybranyZam.poznamka += DateTime.Now.ToShortDateString() + ": Termín posunut z důvodu kvantity; ";
                        break;
                    default:
                        break;
                }
                Zamestnanec.posunoutTerminZaskoleni(VybranyZam);
                if (VybranyZam.uzavrenoDatum.HasValue)
                {
                    VybranyZam.pocetDniZaskoleni = (VybranyZam.uzavrenoDatum.Value - VybranyZam.datumNastupu).Days;
                    if (VybranyZam.uzavrenoDatum <= VybranyZam.terminZaskoleni)
                    {
                        if (VybranyZam.pocetDniZaskoleni <= 14) VybranyZam.verzeZaskoleni = 4;
                        else if (VybranyZam.pocetDniZaskoleni > 14 && VybranyZam.pocetDniZaskoleni <= 31) VybranyZam.verzeZaskoleni = 5;
                        else VybranyZam.verzeZaskoleni = 6;
                    }
                    else
                        VybranyZam.verzeZaskoleni = 7;

                }
                else
                {
                    VybranyZam.pocetDniZaskoleni = (DateTime.Now - VybranyZam.datumNastupu).Days;
                    if (VybranyZam.pocetDniZaskoleni < 0 && DateTime.Now <= VybranyZam.terminZaskoleni) VybranyZam.pocetDniZaskoleni = 0;
                    if (VybranyZam.pocetDniZaskoleni < 15 && DateTime.Now <= VybranyZam.terminZaskoleni) VybranyZam.verzeZaskoleni = 1;
                    else if (VybranyZam.pocetDniZaskoleni >= 15 && DateTime.Now <= VybranyZam.terminZaskoleni) VybranyZam.verzeZaskoleni = 2;
                    else VybranyZam.verzeZaskoleni = 3;
                }

            }
            Zatmavit = false;
        }
    }
}
